# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class AccessPolicyLoggingSettingModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'file_and_malware_syslog_config': 'ISyslogConfig',
        'syslog_config_from_platform_setting': 'bool',
        'metadata': 'Metadata',
        'description': 'str',
        'enable_file_and_malware_syslog': 'bool',
        'type': 'str',
        'version': 'str',
        'syslog_config': 'ISyslogConfig',
        'name': 'str',
        'file_and_malware_syslog_severity': 'str',
        'severity_for_platform_setting_syslog_config': 'str',
        'links': 'ILinks',
        'id': 'str'
    }

    attribute_map = {
        'file_and_malware_syslog_config': 'fileAndMalwareSyslogConfig',
        'syslog_config_from_platform_setting': 'syslogConfigFromPlatformSetting',
        'metadata': 'metadata',
        'description': 'description',
        'enable_file_and_malware_syslog': 'enableFileAndMalwareSyslog',
        'type': 'type',
        'version': 'version',
        'syslog_config': 'syslogConfig',
        'name': 'name',
        'file_and_malware_syslog_severity': 'fileAndMalwareSyslogSeverity',
        'severity_for_platform_setting_syslog_config': 'severityForPlatformSettingSyslogConfig',
        'links': 'links',
        'id': 'id'
    }

    def __init__(self, file_and_malware_syslog_config=None, syslog_config_from_platform_setting=None, metadata=None, description=None, enable_file_and_malware_syslog=None, type=None, version=None, syslog_config=None, name=None, file_and_malware_syslog_severity=None, severity_for_platform_setting_syslog_config=None, links=None, id=None, _configuration=None):  # noqa: E501
        """AccessPolicyLoggingSettingModel - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._file_and_malware_syslog_config = None
        self._syslog_config_from_platform_setting = None
        self._metadata = None
        self._description = None
        self._enable_file_and_malware_syslog = None
        self._type = None
        self._version = None
        self._syslog_config = None
        self._name = None
        self._file_and_malware_syslog_severity = None
        self._severity_for_platform_setting_syslog_config = None
        self._links = None
        self._id = None
        self.discriminator = None

        if file_and_malware_syslog_config is not None:
            self.file_and_malware_syslog_config = file_and_malware_syslog_config
        if syslog_config_from_platform_setting is not None:
            self.syslog_config_from_platform_setting = syslog_config_from_platform_setting
        if metadata is not None:
            self.metadata = metadata
        if description is not None:
            self.description = description
        if enable_file_and_malware_syslog is not None:
            self.enable_file_and_malware_syslog = enable_file_and_malware_syslog
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version
        if syslog_config is not None:
            self.syslog_config = syslog_config
        if name is not None:
            self.name = name
        if file_and_malware_syslog_severity is not None:
            self.file_and_malware_syslog_severity = file_and_malware_syslog_severity
        if severity_for_platform_setting_syslog_config is not None:
            self.severity_for_platform_setting_syslog_config = severity_for_platform_setting_syslog_config
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id

    @property
    def file_and_malware_syslog_config(self):
        """Gets the file_and_malware_syslog_config of this AccessPolicyLoggingSettingModel.  # noqa: E501


        :return: The file_and_malware_syslog_config of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :rtype: ISyslogConfig
        """
        return self._file_and_malware_syslog_config

    @file_and_malware_syslog_config.setter
    def file_and_malware_syslog_config(self, file_and_malware_syslog_config):
        """Sets the file_and_malware_syslog_config of this AccessPolicyLoggingSettingModel.


        :param file_and_malware_syslog_config: The file_and_malware_syslog_config of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :type: ISyslogConfig
        """

        self._file_and_malware_syslog_config = file_and_malware_syslog_config

    @property
    def syslog_config_from_platform_setting(self):
        """Gets the syslog_config_from_platform_setting of this AccessPolicyLoggingSettingModel.  # noqa: E501


        :return: The syslog_config_from_platform_setting of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :rtype: bool
        """
        return self._syslog_config_from_platform_setting

    @syslog_config_from_platform_setting.setter
    def syslog_config_from_platform_setting(self, syslog_config_from_platform_setting):
        """Sets the syslog_config_from_platform_setting of this AccessPolicyLoggingSettingModel.


        :param syslog_config_from_platform_setting: The syslog_config_from_platform_setting of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :type: bool
        """

        self._syslog_config_from_platform_setting = syslog_config_from_platform_setting

    @property
    def metadata(self):
        """Gets the metadata of this AccessPolicyLoggingSettingModel.  # noqa: E501


        :return: The metadata of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :rtype: Metadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this AccessPolicyLoggingSettingModel.


        :param metadata: The metadata of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :type: Metadata
        """

        self._metadata = metadata

    @property
    def description(self):
        """Gets the description of this AccessPolicyLoggingSettingModel.  # noqa: E501


        :return: The description of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this AccessPolicyLoggingSettingModel.


        :param description: The description of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def enable_file_and_malware_syslog(self):
        """Gets the enable_file_and_malware_syslog of this AccessPolicyLoggingSettingModel.  # noqa: E501


        :return: The enable_file_and_malware_syslog of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :rtype: bool
        """
        return self._enable_file_and_malware_syslog

    @enable_file_and_malware_syslog.setter
    def enable_file_and_malware_syslog(self, enable_file_and_malware_syslog):
        """Sets the enable_file_and_malware_syslog of this AccessPolicyLoggingSettingModel.


        :param enable_file_and_malware_syslog: The enable_file_and_malware_syslog of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :type: bool
        """

        self._enable_file_and_malware_syslog = enable_file_and_malware_syslog

    @property
    def type(self):
        """Gets the type of this AccessPolicyLoggingSettingModel.  # noqa: E501


        :return: The type of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this AccessPolicyLoggingSettingModel.


        :param type: The type of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this AccessPolicyLoggingSettingModel.  # noqa: E501


        :return: The version of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this AccessPolicyLoggingSettingModel.


        :param version: The version of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def syslog_config(self):
        """Gets the syslog_config of this AccessPolicyLoggingSettingModel.  # noqa: E501


        :return: The syslog_config of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :rtype: ISyslogConfig
        """
        return self._syslog_config

    @syslog_config.setter
    def syslog_config(self, syslog_config):
        """Sets the syslog_config of this AccessPolicyLoggingSettingModel.


        :param syslog_config: The syslog_config of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :type: ISyslogConfig
        """

        self._syslog_config = syslog_config

    @property
    def name(self):
        """Gets the name of this AccessPolicyLoggingSettingModel.  # noqa: E501


        :return: The name of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AccessPolicyLoggingSettingModel.


        :param name: The name of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def file_and_malware_syslog_severity(self):
        """Gets the file_and_malware_syslog_severity of this AccessPolicyLoggingSettingModel.  # noqa: E501


        :return: The file_and_malware_syslog_severity of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :rtype: str
        """
        return self._file_and_malware_syslog_severity

    @file_and_malware_syslog_severity.setter
    def file_and_malware_syslog_severity(self, file_and_malware_syslog_severity):
        """Sets the file_and_malware_syslog_severity of this AccessPolicyLoggingSettingModel.


        :param file_and_malware_syslog_severity: The file_and_malware_syslog_severity of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :type: str
        """
        allowed_values = ["ALERT", "CRIT", "DEBUG", "EMERG", "ERR", "INFO", "NOTICE", "WARNING"]  # noqa: E501
        if (self._configuration.client_side_validation and
                file_and_malware_syslog_severity not in allowed_values):
            raise ValueError(
                "Invalid value for `file_and_malware_syslog_severity` ({0}), must be one of {1}"  # noqa: E501
                .format(file_and_malware_syslog_severity, allowed_values)
            )

        self._file_and_malware_syslog_severity = file_and_malware_syslog_severity

    @property
    def severity_for_platform_setting_syslog_config(self):
        """Gets the severity_for_platform_setting_syslog_config of this AccessPolicyLoggingSettingModel.  # noqa: E501


        :return: The severity_for_platform_setting_syslog_config of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :rtype: str
        """
        return self._severity_for_platform_setting_syslog_config

    @severity_for_platform_setting_syslog_config.setter
    def severity_for_platform_setting_syslog_config(self, severity_for_platform_setting_syslog_config):
        """Sets the severity_for_platform_setting_syslog_config of this AccessPolicyLoggingSettingModel.


        :param severity_for_platform_setting_syslog_config: The severity_for_platform_setting_syslog_config of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :type: str
        """
        allowed_values = ["ALERT", "CRIT", "DEBUG", "EMERG", "ERR", "INFO", "NOTICE", "WARNING"]  # noqa: E501
        if (self._configuration.client_side_validation and
                severity_for_platform_setting_syslog_config not in allowed_values):
            raise ValueError(
                "Invalid value for `severity_for_platform_setting_syslog_config` ({0}), must be one of {1}"  # noqa: E501
                .format(severity_for_platform_setting_syslog_config, allowed_values)
            )

        self._severity_for_platform_setting_syslog_config = severity_for_platform_setting_syslog_config

    @property
    def links(self):
        """Gets the links of this AccessPolicyLoggingSettingModel.  # noqa: E501


        :return: The links of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this AccessPolicyLoggingSettingModel.


        :param links: The links of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this AccessPolicyLoggingSettingModel.  # noqa: E501


        :return: The id of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AccessPolicyLoggingSettingModel.


        :param id: The id of this AccessPolicyLoggingSettingModel.  # noqa: E501
        :type: str
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AccessPolicyLoggingSettingModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccessPolicyLoggingSettingModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AccessPolicyLoggingSettingModel):
            return True

        return self.to_dict() != other.to_dict()
