# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class AccessRuleMetadata(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'last_user': 'MetadataUser',
        'rule_index': 'int',
        'domain': 'Domain',
        'read_only': 'ReadOnly',
        'section': 'str',
        'access_policy': 'IReference',
        'category': 'str',
        'timestamp': 'int'
    }

    attribute_map = {
        'last_user': 'lastUser',
        'rule_index': 'ruleIndex',
        'domain': 'domain',
        'read_only': 'readOnly',
        'section': 'section',
        'access_policy': 'accessPolicy',
        'category': 'category',
        'timestamp': 'timestamp'
    }

    def __init__(self, last_user=None, rule_index=None, domain=None, read_only=None, section=None, access_policy=None, category=None, timestamp=None, _configuration=None):  # noqa: E501
        """AccessRuleMetadata - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._last_user = None
        self._rule_index = None
        self._domain = None
        self._read_only = None
        self._section = None
        self._access_policy = None
        self._category = None
        self._timestamp = None
        self.discriminator = None

        if last_user is not None:
            self.last_user = last_user
        if rule_index is not None:
            self.rule_index = rule_index
        if domain is not None:
            self.domain = domain
        if read_only is not None:
            self.read_only = read_only
        if section is not None:
            self.section = section
        if access_policy is not None:
            self.access_policy = access_policy
        if category is not None:
            self.category = category
        if timestamp is not None:
            self.timestamp = timestamp

    @property
    def last_user(self):
        """Gets the last_user of this AccessRuleMetadata.  # noqa: E501


        :return: The last_user of this AccessRuleMetadata.  # noqa: E501
        :rtype: MetadataUser
        """
        return self._last_user

    @last_user.setter
    def last_user(self, last_user):
        """Sets the last_user of this AccessRuleMetadata.


        :param last_user: The last_user of this AccessRuleMetadata.  # noqa: E501
        :type: MetadataUser
        """

        self._last_user = last_user

    @property
    def rule_index(self):
        """Gets the rule_index of this AccessRuleMetadata.  # noqa: E501


        :return: The rule_index of this AccessRuleMetadata.  # noqa: E501
        :rtype: int
        """
        return self._rule_index

    @rule_index.setter
    def rule_index(self, rule_index):
        """Sets the rule_index of this AccessRuleMetadata.


        :param rule_index: The rule_index of this AccessRuleMetadata.  # noqa: E501
        :type: int
        """

        self._rule_index = rule_index

    @property
    def domain(self):
        """Gets the domain of this AccessRuleMetadata.  # noqa: E501


        :return: The domain of this AccessRuleMetadata.  # noqa: E501
        :rtype: Domain
        """
        return self._domain

    @domain.setter
    def domain(self, domain):
        """Sets the domain of this AccessRuleMetadata.


        :param domain: The domain of this AccessRuleMetadata.  # noqa: E501
        :type: Domain
        """

        self._domain = domain

    @property
    def read_only(self):
        """Gets the read_only of this AccessRuleMetadata.  # noqa: E501


        :return: The read_only of this AccessRuleMetadata.  # noqa: E501
        :rtype: ReadOnly
        """
        return self._read_only

    @read_only.setter
    def read_only(self, read_only):
        """Sets the read_only of this AccessRuleMetadata.


        :param read_only: The read_only of this AccessRuleMetadata.  # noqa: E501
        :type: ReadOnly
        """

        self._read_only = read_only

    @property
    def section(self):
        """Gets the section of this AccessRuleMetadata.  # noqa: E501


        :return: The section of this AccessRuleMetadata.  # noqa: E501
        :rtype: str
        """
        return self._section

    @section.setter
    def section(self, section):
        """Sets the section of this AccessRuleMetadata.


        :param section: The section of this AccessRuleMetadata.  # noqa: E501
        :type: str
        """

        self._section = section

    @property
    def access_policy(self):
        """Gets the access_policy of this AccessRuleMetadata.  # noqa: E501


        :return: The access_policy of this AccessRuleMetadata.  # noqa: E501
        :rtype: IReference
        """
        return self._access_policy

    @access_policy.setter
    def access_policy(self, access_policy):
        """Sets the access_policy of this AccessRuleMetadata.


        :param access_policy: The access_policy of this AccessRuleMetadata.  # noqa: E501
        :type: IReference
        """

        self._access_policy = access_policy

    @property
    def category(self):
        """Gets the category of this AccessRuleMetadata.  # noqa: E501


        :return: The category of this AccessRuleMetadata.  # noqa: E501
        :rtype: str
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this AccessRuleMetadata.


        :param category: The category of this AccessRuleMetadata.  # noqa: E501
        :type: str
        """

        self._category = category

    @property
    def timestamp(self):
        """Gets the timestamp of this AccessRuleMetadata.  # noqa: E501


        :return: The timestamp of this AccessRuleMetadata.  # noqa: E501
        :rtype: int
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """Sets the timestamp of this AccessRuleMetadata.


        :param timestamp: The timestamp of this AccessRuleMetadata.  # noqa: E501
        :type: int
        """

        self._timestamp = timestamp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AccessRuleMetadata, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccessRuleMetadata):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AccessRuleMetadata):
            return True

        return self.to_dict() != other.to_dict()
