# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class ApplicableDevice(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'metadata': 'IMetadata',
        'is_part_of_container': 'str',
        'model_id': 'str',
        'advanced': 'IAdvanced',
        'container_type': 'str',
        'description': 'str',
        'model_type': 'str',
        'type': 'str',
        'version': 'str',
        'upgrade_package': 'UpgradePackage',
        'sw_version': 'str',
        'health_status': 'str',
        'health_policy': 'IHealthPolicy',
        'name': 'str',
        'links': 'ILinks',
        'model': 'str',
        'model_number': 'str',
        'id': 'str',
        'access_policy': 'IPolicyModel'
    }

    attribute_map = {
        'metadata': 'metadata',
        'is_part_of_container': 'isPartOfContainer',
        'model_id': 'modelId',
        'advanced': 'advanced',
        'container_type': 'containerType',
        'description': 'description',
        'model_type': 'modelType',
        'type': 'type',
        'version': 'version',
        'upgrade_package': 'upgradePackage',
        'sw_version': 'sw_version',
        'health_status': 'healthStatus',
        'health_policy': 'healthPolicy',
        'name': 'name',
        'links': 'links',
        'model': 'model',
        'model_number': 'modelNumber',
        'id': 'id',
        'access_policy': 'accessPolicy'
    }

    def __init__(self, metadata=None, is_part_of_container=None, model_id=None, advanced=None, container_type=None, description=None, model_type=None, type=None, version=None, upgrade_package=None, sw_version=None, health_status=None, health_policy=None, name=None, links=None, model=None, model_number=None, id=None, access_policy=None, _configuration=None):  # noqa: E501
        """ApplicableDevice - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._metadata = None
        self._is_part_of_container = None
        self._model_id = None
        self._advanced = None
        self._container_type = None
        self._description = None
        self._model_type = None
        self._type = None
        self._version = None
        self._upgrade_package = None
        self._sw_version = None
        self._health_status = None
        self._health_policy = None
        self._name = None
        self._links = None
        self._model = None
        self._model_number = None
        self._id = None
        self._access_policy = None
        self.discriminator = None

        if metadata is not None:
            self.metadata = metadata
        if is_part_of_container is not None:
            self.is_part_of_container = is_part_of_container
        if model_id is not None:
            self.model_id = model_id
        if advanced is not None:
            self.advanced = advanced
        if container_type is not None:
            self.container_type = container_type
        if description is not None:
            self.description = description
        if model_type is not None:
            self.model_type = model_type
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version
        if upgrade_package is not None:
            self.upgrade_package = upgrade_package
        if sw_version is not None:
            self.sw_version = sw_version
        if health_status is not None:
            self.health_status = health_status
        if health_policy is not None:
            self.health_policy = health_policy
        if name is not None:
            self.name = name
        if links is not None:
            self.links = links
        if model is not None:
            self.model = model
        if model_number is not None:
            self.model_number = model_number
        if id is not None:
            self.id = id
        if access_policy is not None:
            self.access_policy = access_policy

    @property
    def metadata(self):
        """Gets the metadata of this ApplicableDevice.  # noqa: E501


        :return: The metadata of this ApplicableDevice.  # noqa: E501
        :rtype: IMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this ApplicableDevice.


        :param metadata: The metadata of this ApplicableDevice.  # noqa: E501
        :type: IMetadata
        """

        self._metadata = metadata

    @property
    def is_part_of_container(self):
        """Gets the is_part_of_container of this ApplicableDevice.  # noqa: E501


        :return: The is_part_of_container of this ApplicableDevice.  # noqa: E501
        :rtype: str
        """
        return self._is_part_of_container

    @is_part_of_container.setter
    def is_part_of_container(self, is_part_of_container):
        """Sets the is_part_of_container of this ApplicableDevice.


        :param is_part_of_container: The is_part_of_container of this ApplicableDevice.  # noqa: E501
        :type: str
        """

        self._is_part_of_container = is_part_of_container

    @property
    def model_id(self):
        """Gets the model_id of this ApplicableDevice.  # noqa: E501


        :return: The model_id of this ApplicableDevice.  # noqa: E501
        :rtype: str
        """
        return self._model_id

    @model_id.setter
    def model_id(self, model_id):
        """Sets the model_id of this ApplicableDevice.


        :param model_id: The model_id of this ApplicableDevice.  # noqa: E501
        :type: str
        """

        self._model_id = model_id

    @property
    def advanced(self):
        """Gets the advanced of this ApplicableDevice.  # noqa: E501


        :return: The advanced of this ApplicableDevice.  # noqa: E501
        :rtype: IAdvanced
        """
        return self._advanced

    @advanced.setter
    def advanced(self, advanced):
        """Sets the advanced of this ApplicableDevice.


        :param advanced: The advanced of this ApplicableDevice.  # noqa: E501
        :type: IAdvanced
        """

        self._advanced = advanced

    @property
    def container_type(self):
        """Gets the container_type of this ApplicableDevice.  # noqa: E501


        :return: The container_type of this ApplicableDevice.  # noqa: E501
        :rtype: str
        """
        return self._container_type

    @container_type.setter
    def container_type(self, container_type):
        """Sets the container_type of this ApplicableDevice.


        :param container_type: The container_type of this ApplicableDevice.  # noqa: E501
        :type: str
        """

        self._container_type = container_type

    @property
    def description(self):
        """Gets the description of this ApplicableDevice.  # noqa: E501


        :return: The description of this ApplicableDevice.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ApplicableDevice.


        :param description: The description of this ApplicableDevice.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def model_type(self):
        """Gets the model_type of this ApplicableDevice.  # noqa: E501


        :return: The model_type of this ApplicableDevice.  # noqa: E501
        :rtype: str
        """
        return self._model_type

    @model_type.setter
    def model_type(self, model_type):
        """Sets the model_type of this ApplicableDevice.


        :param model_type: The model_type of this ApplicableDevice.  # noqa: E501
        :type: str
        """

        self._model_type = model_type

    @property
    def type(self):
        """Gets the type of this ApplicableDevice.  # noqa: E501


        :return: The type of this ApplicableDevice.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ApplicableDevice.


        :param type: The type of this ApplicableDevice.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this ApplicableDevice.  # noqa: E501


        :return: The version of this ApplicableDevice.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this ApplicableDevice.


        :param version: The version of this ApplicableDevice.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def upgrade_package(self):
        """Gets the upgrade_package of this ApplicableDevice.  # noqa: E501


        :return: The upgrade_package of this ApplicableDevice.  # noqa: E501
        :rtype: UpgradePackage
        """
        return self._upgrade_package

    @upgrade_package.setter
    def upgrade_package(self, upgrade_package):
        """Sets the upgrade_package of this ApplicableDevice.


        :param upgrade_package: The upgrade_package of this ApplicableDevice.  # noqa: E501
        :type: UpgradePackage
        """

        self._upgrade_package = upgrade_package

    @property
    def sw_version(self):
        """Gets the sw_version of this ApplicableDevice.  # noqa: E501


        :return: The sw_version of this ApplicableDevice.  # noqa: E501
        :rtype: str
        """
        return self._sw_version

    @sw_version.setter
    def sw_version(self, sw_version):
        """Sets the sw_version of this ApplicableDevice.


        :param sw_version: The sw_version of this ApplicableDevice.  # noqa: E501
        :type: str
        """

        self._sw_version = sw_version

    @property
    def health_status(self):
        """Gets the health_status of this ApplicableDevice.  # noqa: E501


        :return: The health_status of this ApplicableDevice.  # noqa: E501
        :rtype: str
        """
        return self._health_status

    @health_status.setter
    def health_status(self, health_status):
        """Sets the health_status of this ApplicableDevice.


        :param health_status: The health_status of this ApplicableDevice.  # noqa: E501
        :type: str
        """

        self._health_status = health_status

    @property
    def health_policy(self):
        """Gets the health_policy of this ApplicableDevice.  # noqa: E501


        :return: The health_policy of this ApplicableDevice.  # noqa: E501
        :rtype: IHealthPolicy
        """
        return self._health_policy

    @health_policy.setter
    def health_policy(self, health_policy):
        """Sets the health_policy of this ApplicableDevice.


        :param health_policy: The health_policy of this ApplicableDevice.  # noqa: E501
        :type: IHealthPolicy
        """

        self._health_policy = health_policy

    @property
    def name(self):
        """Gets the name of this ApplicableDevice.  # noqa: E501


        :return: The name of this ApplicableDevice.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ApplicableDevice.


        :param name: The name of this ApplicableDevice.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def links(self):
        """Gets the links of this ApplicableDevice.  # noqa: E501


        :return: The links of this ApplicableDevice.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this ApplicableDevice.


        :param links: The links of this ApplicableDevice.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def model(self):
        """Gets the model of this ApplicableDevice.  # noqa: E501


        :return: The model of this ApplicableDevice.  # noqa: E501
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this ApplicableDevice.


        :param model: The model of this ApplicableDevice.  # noqa: E501
        :type: str
        """

        self._model = model

    @property
    def model_number(self):
        """Gets the model_number of this ApplicableDevice.  # noqa: E501


        :return: The model_number of this ApplicableDevice.  # noqa: E501
        :rtype: str
        """
        return self._model_number

    @model_number.setter
    def model_number(self, model_number):
        """Sets the model_number of this ApplicableDevice.


        :param model_number: The model_number of this ApplicableDevice.  # noqa: E501
        :type: str
        """

        self._model_number = model_number

    @property
    def id(self):
        """Gets the id of this ApplicableDevice.  # noqa: E501


        :return: The id of this ApplicableDevice.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ApplicableDevice.


        :param id: The id of this ApplicableDevice.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def access_policy(self):
        """Gets the access_policy of this ApplicableDevice.  # noqa: E501


        :return: The access_policy of this ApplicableDevice.  # noqa: E501
        :rtype: IPolicyModel
        """
        return self._access_policy

    @access_policy.setter
    def access_policy(self, access_policy):
        """Sets the access_policy of this ApplicableDevice.


        :param access_policy: The access_policy of this ApplicableDevice.  # noqa: E501
        :type: IPolicyModel
        """

        self._access_policy = access_policy

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApplicableDevice, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApplicableDevice):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ApplicableDevice):
            return True

        return self.to_dict() != other.to_dict()
