# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class Application(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'application_tags': 'list[IApplicationTag]',
        'metadata': 'IMetadata',
        'app_productivity': 'ApplicationProductivity',
        'deprecated': 'bool',
        'description': 'str',
        'overrides': 'IOverride',
        'type': 'str',
        'decrypted': 'bool',
        'version': 'str',
        'tags': 'list[IApplicationTag]',
        'productivity': 'IApplicationProductivity',
        'app_id': 'int',
        'app_categories': 'list[IApplicationCategory]',
        'name': 'str',
        'overridable': 'bool',
        'links': 'ILinks',
        'risk': 'IApplicationRisk',
        'application_types': 'list[IApplicationType]',
        'id': 'str',
        'categories': 'list[IApplicationCategory]'
    }

    attribute_map = {
        'application_tags': 'applicationTags',
        'metadata': 'metadata',
        'app_productivity': 'appProductivity',
        'deprecated': 'deprecated',
        'description': 'description',
        'overrides': 'overrides',
        'type': 'type',
        'decrypted': 'decrypted',
        'version': 'version',
        'tags': 'tags',
        'productivity': 'productivity',
        'app_id': 'appId',
        'app_categories': 'appCategories',
        'name': 'name',
        'overridable': 'overridable',
        'links': 'links',
        'risk': 'risk',
        'application_types': 'applicationTypes',
        'id': 'id',
        'categories': 'categories'
    }

    def __init__(self, application_tags=None, metadata=None, app_productivity=None, deprecated=None, description=None, overrides=None, type=None, decrypted=None, version=None, tags=None, productivity=None, app_id=None, app_categories=None, name=None, overridable=None, links=None, risk=None, application_types=None, id=None, categories=None, _configuration=None):  # noqa: E501
        """Application - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._application_tags = None
        self._metadata = None
        self._app_productivity = None
        self._deprecated = None
        self._description = None
        self._overrides = None
        self._type = None
        self._decrypted = None
        self._version = None
        self._tags = None
        self._productivity = None
        self._app_id = None
        self._app_categories = None
        self._name = None
        self._overridable = None
        self._links = None
        self._risk = None
        self._application_types = None
        self._id = None
        self._categories = None
        self.discriminator = None

        if application_tags is not None:
            self.application_tags = application_tags
        if metadata is not None:
            self.metadata = metadata
        if app_productivity is not None:
            self.app_productivity = app_productivity
        if deprecated is not None:
            self.deprecated = deprecated
        if description is not None:
            self.description = description
        if overrides is not None:
            self.overrides = overrides
        if type is not None:
            self.type = type
        if decrypted is not None:
            self.decrypted = decrypted
        if version is not None:
            self.version = version
        if tags is not None:
            self.tags = tags
        if productivity is not None:
            self.productivity = productivity
        if app_id is not None:
            self.app_id = app_id
        if app_categories is not None:
            self.app_categories = app_categories
        if name is not None:
            self.name = name
        if overridable is not None:
            self.overridable = overridable
        if links is not None:
            self.links = links
        if risk is not None:
            self.risk = risk
        if application_types is not None:
            self.application_types = application_types
        if id is not None:
            self.id = id
        if categories is not None:
            self.categories = categories

    @property
    def application_tags(self):
        """Gets the application_tags of this Application.  # noqa: E501


        :return: The application_tags of this Application.  # noqa: E501
        :rtype: list[IApplicationTag]
        """
        return self._application_tags

    @application_tags.setter
    def application_tags(self, application_tags):
        """Sets the application_tags of this Application.


        :param application_tags: The application_tags of this Application.  # noqa: E501
        :type: list[IApplicationTag]
        """

        self._application_tags = application_tags

    @property
    def metadata(self):
        """Gets the metadata of this Application.  # noqa: E501


        :return: The metadata of this Application.  # noqa: E501
        :rtype: IMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this Application.


        :param metadata: The metadata of this Application.  # noqa: E501
        :type: IMetadata
        """

        self._metadata = metadata

    @property
    def app_productivity(self):
        """Gets the app_productivity of this Application.  # noqa: E501


        :return: The app_productivity of this Application.  # noqa: E501
        :rtype: ApplicationProductivity
        """
        return self._app_productivity

    @app_productivity.setter
    def app_productivity(self, app_productivity):
        """Sets the app_productivity of this Application.


        :param app_productivity: The app_productivity of this Application.  # noqa: E501
        :type: ApplicationProductivity
        """

        self._app_productivity = app_productivity

    @property
    def deprecated(self):
        """Gets the deprecated of this Application.  # noqa: E501


        :return: The deprecated of this Application.  # noqa: E501
        :rtype: bool
        """
        return self._deprecated

    @deprecated.setter
    def deprecated(self, deprecated):
        """Sets the deprecated of this Application.


        :param deprecated: The deprecated of this Application.  # noqa: E501
        :type: bool
        """

        self._deprecated = deprecated

    @property
    def description(self):
        """Gets the description of this Application.  # noqa: E501


        :return: The description of this Application.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Application.


        :param description: The description of this Application.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def overrides(self):
        """Gets the overrides of this Application.  # noqa: E501


        :return: The overrides of this Application.  # noqa: E501
        :rtype: IOverride
        """
        return self._overrides

    @overrides.setter
    def overrides(self, overrides):
        """Sets the overrides of this Application.


        :param overrides: The overrides of this Application.  # noqa: E501
        :type: IOverride
        """

        self._overrides = overrides

    @property
    def type(self):
        """Gets the type of this Application.  # noqa: E501


        :return: The type of this Application.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Application.


        :param type: The type of this Application.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def decrypted(self):
        """Gets the decrypted of this Application.  # noqa: E501


        :return: The decrypted of this Application.  # noqa: E501
        :rtype: bool
        """
        return self._decrypted

    @decrypted.setter
    def decrypted(self, decrypted):
        """Sets the decrypted of this Application.


        :param decrypted: The decrypted of this Application.  # noqa: E501
        :type: bool
        """

        self._decrypted = decrypted

    @property
    def version(self):
        """Gets the version of this Application.  # noqa: E501


        :return: The version of this Application.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this Application.


        :param version: The version of this Application.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def tags(self):
        """Gets the tags of this Application.  # noqa: E501


        :return: The tags of this Application.  # noqa: E501
        :rtype: list[IApplicationTag]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this Application.


        :param tags: The tags of this Application.  # noqa: E501
        :type: list[IApplicationTag]
        """

        self._tags = tags

    @property
    def productivity(self):
        """Gets the productivity of this Application.  # noqa: E501


        :return: The productivity of this Application.  # noqa: E501
        :rtype: IApplicationProductivity
        """
        return self._productivity

    @productivity.setter
    def productivity(self, productivity):
        """Sets the productivity of this Application.


        :param productivity: The productivity of this Application.  # noqa: E501
        :type: IApplicationProductivity
        """

        self._productivity = productivity

    @property
    def app_id(self):
        """Gets the app_id of this Application.  # noqa: E501


        :return: The app_id of this Application.  # noqa: E501
        :rtype: int
        """
        return self._app_id

    @app_id.setter
    def app_id(self, app_id):
        """Sets the app_id of this Application.


        :param app_id: The app_id of this Application.  # noqa: E501
        :type: int
        """

        self._app_id = app_id

    @property
    def app_categories(self):
        """Gets the app_categories of this Application.  # noqa: E501


        :return: The app_categories of this Application.  # noqa: E501
        :rtype: list[IApplicationCategory]
        """
        return self._app_categories

    @app_categories.setter
    def app_categories(self, app_categories):
        """Sets the app_categories of this Application.


        :param app_categories: The app_categories of this Application.  # noqa: E501
        :type: list[IApplicationCategory]
        """

        self._app_categories = app_categories

    @property
    def name(self):
        """Gets the name of this Application.  # noqa: E501


        :return: The name of this Application.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Application.


        :param name: The name of this Application.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def overridable(self):
        """Gets the overridable of this Application.  # noqa: E501


        :return: The overridable of this Application.  # noqa: E501
        :rtype: bool
        """
        return self._overridable

    @overridable.setter
    def overridable(self, overridable):
        """Sets the overridable of this Application.


        :param overridable: The overridable of this Application.  # noqa: E501
        :type: bool
        """

        self._overridable = overridable

    @property
    def links(self):
        """Gets the links of this Application.  # noqa: E501


        :return: The links of this Application.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Application.


        :param links: The links of this Application.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def risk(self):
        """Gets the risk of this Application.  # noqa: E501


        :return: The risk of this Application.  # noqa: E501
        :rtype: IApplicationRisk
        """
        return self._risk

    @risk.setter
    def risk(self, risk):
        """Sets the risk of this Application.


        :param risk: The risk of this Application.  # noqa: E501
        :type: IApplicationRisk
        """

        self._risk = risk

    @property
    def application_types(self):
        """Gets the application_types of this Application.  # noqa: E501


        :return: The application_types of this Application.  # noqa: E501
        :rtype: list[IApplicationType]
        """
        return self._application_types

    @application_types.setter
    def application_types(self, application_types):
        """Sets the application_types of this Application.


        :param application_types: The application_types of this Application.  # noqa: E501
        :type: list[IApplicationType]
        """

        self._application_types = application_types

    @property
    def id(self):
        """Gets the id of this Application.  # noqa: E501


        :return: The id of this Application.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Application.


        :param id: The id of this Application.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def categories(self):
        """Gets the categories of this Application.  # noqa: E501


        :return: The categories of this Application.  # noqa: E501
        :rtype: list[IApplicationCategory]
        """
        return self._categories

    @categories.setter
    def categories(self, categories):
        """Sets the categories of this Application.


        :param categories: The categories of this Application.  # noqa: E501
        :type: list[IApplicationCategory]
        """

        self._categories = categories

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Application, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Application):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Application):
            return True

        return self.to_dict() != other.to_dict()
