# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class CloudEvents(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'send_intrusion_events': 'bool',
        'metadata': 'IMetadata',
        'send_connection_events': 'bool',
        'name': 'str',
        'send_file_events': 'bool',
        'description': 'str',
        'links': 'ILinks',
        'id': 'str',
        'type': 'str',
        'version': 'str'
    }

    attribute_map = {
        'send_intrusion_events': 'sendIntrusionEvents',
        'metadata': 'metadata',
        'send_connection_events': 'sendConnectionEvents',
        'name': 'name',
        'send_file_events': 'sendFileEvents',
        'description': 'description',
        'links': 'links',
        'id': 'id',
        'type': 'type',
        'version': 'version'
    }

    def __init__(self, send_intrusion_events=None, metadata=None, send_connection_events=None, name=None, send_file_events=None, description=None, links=None, id=None, type=None, version=None, _configuration=None):  # noqa: E501
        """CloudEvents - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._send_intrusion_events = None
        self._metadata = None
        self._send_connection_events = None
        self._name = None
        self._send_file_events = None
        self._description = None
        self._links = None
        self._id = None
        self._type = None
        self._version = None
        self.discriminator = None

        if send_intrusion_events is not None:
            self.send_intrusion_events = send_intrusion_events
        if metadata is not None:
            self.metadata = metadata
        if send_connection_events is not None:
            self.send_connection_events = send_connection_events
        if name is not None:
            self.name = name
        if send_file_events is not None:
            self.send_file_events = send_file_events
        if description is not None:
            self.description = description
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version

    @property
    def send_intrusion_events(self):
        """Gets the send_intrusion_events of this CloudEvents.  # noqa: E501

        Boolean indicating whether to send intrusion events to cloud  # noqa: E501

        :return: The send_intrusion_events of this CloudEvents.  # noqa: E501
        :rtype: bool
        """
        return self._send_intrusion_events

    @send_intrusion_events.setter
    def send_intrusion_events(self, send_intrusion_events):
        """Sets the send_intrusion_events of this CloudEvents.

        Boolean indicating whether to send intrusion events to cloud  # noqa: E501

        :param send_intrusion_events: The send_intrusion_events of this CloudEvents.  # noqa: E501
        :type: bool
        """

        self._send_intrusion_events = send_intrusion_events

    @property
    def metadata(self):
        """Gets the metadata of this CloudEvents.  # noqa: E501


        :return: The metadata of this CloudEvents.  # noqa: E501
        :rtype: IMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this CloudEvents.


        :param metadata: The metadata of this CloudEvents.  # noqa: E501
        :type: IMetadata
        """

        self._metadata = metadata

    @property
    def send_connection_events(self):
        """Gets the send_connection_events of this CloudEvents.  # noqa: E501

        Boolean indicating whether to send connection events to cloud  # noqa: E501

        :return: The send_connection_events of this CloudEvents.  # noqa: E501
        :rtype: bool
        """
        return self._send_connection_events

    @send_connection_events.setter
    def send_connection_events(self, send_connection_events):
        """Sets the send_connection_events of this CloudEvents.

        Boolean indicating whether to send connection events to cloud  # noqa: E501

        :param send_connection_events: The send_connection_events of this CloudEvents.  # noqa: E501
        :type: bool
        """

        self._send_connection_events = send_connection_events

    @property
    def name(self):
        """Gets the name of this CloudEvents.  # noqa: E501


        :return: The name of this CloudEvents.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CloudEvents.


        :param name: The name of this CloudEvents.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def send_file_events(self):
        """Gets the send_file_events of this CloudEvents.  # noqa: E501

        Boolean indicating whether to send file/malware events to cloud  # noqa: E501

        :return: The send_file_events of this CloudEvents.  # noqa: E501
        :rtype: bool
        """
        return self._send_file_events

    @send_file_events.setter
    def send_file_events(self, send_file_events):
        """Sets the send_file_events of this CloudEvents.

        Boolean indicating whether to send file/malware events to cloud  # noqa: E501

        :param send_file_events: The send_file_events of this CloudEvents.  # noqa: E501
        :type: bool
        """

        self._send_file_events = send_file_events

    @property
    def description(self):
        """Gets the description of this CloudEvents.  # noqa: E501


        :return: The description of this CloudEvents.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CloudEvents.


        :param description: The description of this CloudEvents.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def links(self):
        """Gets the links of this CloudEvents.  # noqa: E501

        Links to the configuration object  # noqa: E501

        :return: The links of this CloudEvents.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this CloudEvents.

        Links to the configuration object  # noqa: E501

        :param links: The links of this CloudEvents.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this CloudEvents.  # noqa: E501

        Unique UUID of the configuration object  # noqa: E501

        :return: The id of this CloudEvents.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CloudEvents.

        Unique UUID of the configuration object  # noqa: E501

        :param id: The id of this CloudEvents.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this CloudEvents.  # noqa: E501

        Type of the configuration object: CloudEventsConfigs  # noqa: E501

        :return: The type of this CloudEvents.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this CloudEvents.

        Type of the configuration object: CloudEventsConfigs  # noqa: E501

        :param type: The type of this CloudEvents.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this CloudEvents.  # noqa: E501


        :return: The version of this CloudEvents.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this CloudEvents.


        :param version: The version of this CloudEvents.  # noqa: E501
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CloudEvents, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CloudEvents):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CloudEvents):
            return True

        return self.to_dict() != other.to_dict()
