# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class Commands(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'command_output': 'str',
        'metadata': 'IMetadata',
        'name': 'str',
        'description': 'str',
        'links': 'ILinks',
        'id': 'str',
        'type': 'str',
        'version': 'str',
        'command_input': 'str'
    }

    attribute_map = {
        'command_output': 'commandOutput',
        'metadata': 'metadata',
        'name': 'name',
        'description': 'description',
        'links': 'links',
        'id': 'id',
        'type': 'type',
        'version': 'version',
        'command_input': 'commandInput'
    }

    def __init__(self, command_output=None, metadata=None, name=None, description=None, links=None, id=None, type=None, version=None, command_input=None, _configuration=None):  # noqa: E501
        """Commands - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._command_output = None
        self._metadata = None
        self._name = None
        self._description = None
        self._links = None
        self._id = None
        self._type = None
        self._version = None
        self._command_input = None
        self.discriminator = None

        if command_output is not None:
            self.command_output = command_output
        if metadata is not None:
            self.metadata = metadata
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version
        if command_input is not None:
            self.command_input = command_input

    @property
    def command_output(self):
        """Gets the command_output of this Commands.  # noqa: E501


        :return: The command_output of this Commands.  # noqa: E501
        :rtype: str
        """
        return self._command_output

    @command_output.setter
    def command_output(self, command_output):
        """Sets the command_output of this Commands.


        :param command_output: The command_output of this Commands.  # noqa: E501
        :type: str
        """

        self._command_output = command_output

    @property
    def metadata(self):
        """Gets the metadata of this Commands.  # noqa: E501


        :return: The metadata of this Commands.  # noqa: E501
        :rtype: IMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this Commands.


        :param metadata: The metadata of this Commands.  # noqa: E501
        :type: IMetadata
        """

        self._metadata = metadata

    @property
    def name(self):
        """Gets the name of this Commands.  # noqa: E501


        :return: The name of this Commands.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Commands.


        :param name: The name of this Commands.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this Commands.  # noqa: E501


        :return: The description of this Commands.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Commands.


        :param description: The description of this Commands.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def links(self):
        """Gets the links of this Commands.  # noqa: E501


        :return: The links of this Commands.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Commands.


        :param links: The links of this Commands.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this Commands.  # noqa: E501


        :return: The id of this Commands.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Commands.


        :param id: The id of this Commands.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this Commands.  # noqa: E501


        :return: The type of this Commands.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Commands.


        :param type: The type of this Commands.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this Commands.  # noqa: E501


        :return: The version of this Commands.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this Commands.


        :param version: The version of this Commands.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def command_input(self):
        """Gets the command_input of this Commands.  # noqa: E501


        :return: The command_input of this Commands.  # noqa: E501
        :rtype: str
        """
        return self._command_input

    @command_input.setter
    def command_input(self, command_input):
        """Sets the command_input of this Commands.


        :param command_input: The command_input of this Commands.  # noqa: E501
        :type: str
        """

        self._command_input = command_input

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Commands, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Commands):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Commands):
            return True

        return self.to_dict() != other.to_dict()
