# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class CommunityList(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'metadata': 'Metadata',
        'expanded_entries': 'list[IExpandedCommunityListEntry]',
        'overridable': 'bool',
        'name': 'str',
        'links': 'Links',
        'overrides': 'IOverride',
        'id': 'str',
        'type': 'str',
        'standard_entries': 'list[IStandardCommunityListEntry]',
        'version': 'str'
    }

    attribute_map = {
        'metadata': 'metadata',
        'expanded_entries': 'expandedEntries',
        'overridable': 'overridable',
        'name': 'name',
        'links': 'links',
        'overrides': 'overrides',
        'id': 'id',
        'type': 'type',
        'standard_entries': 'standardEntries',
        'version': 'version'
    }

    def __init__(self, metadata=None, expanded_entries=None, overridable=None, name=None, links=None, overrides=None, id=None, type=None, standard_entries=None, version=None, _configuration=None):  # noqa: E501
        """CommunityList - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._metadata = None
        self._expanded_entries = None
        self._overridable = None
        self._name = None
        self._links = None
        self._overrides = None
        self._id = None
        self._type = None
        self._standard_entries = None
        self._version = None
        self.discriminator = None

        if metadata is not None:
            self.metadata = metadata
        if expanded_entries is not None:
            self.expanded_entries = expanded_entries
        if overridable is not None:
            self.overridable = overridable
        if name is not None:
            self.name = name
        if links is not None:
            self.links = links
        if overrides is not None:
            self.overrides = overrides
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if standard_entries is not None:
            self.standard_entries = standard_entries
        if version is not None:
            self.version = version

    @property
    def metadata(self):
        """Gets the metadata of this CommunityList.  # noqa: E501


        :return: The metadata of this CommunityList.  # noqa: E501
        :rtype: Metadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this CommunityList.


        :param metadata: The metadata of this CommunityList.  # noqa: E501
        :type: Metadata
        """

        self._metadata = metadata

    @property
    def expanded_entries(self):
        """Gets the expanded_entries of this CommunityList.  # noqa: E501


        :return: The expanded_entries of this CommunityList.  # noqa: E501
        :rtype: list[IExpandedCommunityListEntry]
        """
        return self._expanded_entries

    @expanded_entries.setter
    def expanded_entries(self, expanded_entries):
        """Sets the expanded_entries of this CommunityList.


        :param expanded_entries: The expanded_entries of this CommunityList.  # noqa: E501
        :type: list[IExpandedCommunityListEntry]
        """

        self._expanded_entries = expanded_entries

    @property
    def overridable(self):
        """Gets the overridable of this CommunityList.  # noqa: E501


        :return: The overridable of this CommunityList.  # noqa: E501
        :rtype: bool
        """
        return self._overridable

    @overridable.setter
    def overridable(self, overridable):
        """Sets the overridable of this CommunityList.


        :param overridable: The overridable of this CommunityList.  # noqa: E501
        :type: bool
        """

        self._overridable = overridable

    @property
    def name(self):
        """Gets the name of this CommunityList.  # noqa: E501


        :return: The name of this CommunityList.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CommunityList.


        :param name: The name of this CommunityList.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def links(self):
        """Gets the links of this CommunityList.  # noqa: E501


        :return: The links of this CommunityList.  # noqa: E501
        :rtype: Links
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this CommunityList.


        :param links: The links of this CommunityList.  # noqa: E501
        :type: Links
        """

        self._links = links

    @property
    def overrides(self):
        """Gets the overrides of this CommunityList.  # noqa: E501


        :return: The overrides of this CommunityList.  # noqa: E501
        :rtype: IOverride
        """
        return self._overrides

    @overrides.setter
    def overrides(self, overrides):
        """Sets the overrides of this CommunityList.


        :param overrides: The overrides of this CommunityList.  # noqa: E501
        :type: IOverride
        """

        self._overrides = overrides

    @property
    def id(self):
        """Gets the id of this CommunityList.  # noqa: E501


        :return: The id of this CommunityList.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CommunityList.


        :param id: The id of this CommunityList.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this CommunityList.  # noqa: E501


        :return: The type of this CommunityList.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this CommunityList.


        :param type: The type of this CommunityList.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def standard_entries(self):
        """Gets the standard_entries of this CommunityList.  # noqa: E501


        :return: The standard_entries of this CommunityList.  # noqa: E501
        :rtype: list[IStandardCommunityListEntry]
        """
        return self._standard_entries

    @standard_entries.setter
    def standard_entries(self, standard_entries):
        """Sets the standard_entries of this CommunityList.


        :param standard_entries: The standard_entries of this CommunityList.  # noqa: E501
        :type: list[IStandardCommunityListEntry]
        """

        self._standard_entries = standard_entries

    @property
    def version(self):
        """Gets the version of this CommunityList.  # noqa: E501


        :return: The version of this CommunityList.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this CommunityList.


        :param version: The version of this CommunityList.  # noqa: E501
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CommunityList, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CommunityList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CommunityList):
            return True

        return self.to_dict() != other.to_dict()
