# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class DeploymentDetail(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'metadata': 'IMetadata',
        'policy_list': 'list[IPolicyModel]',
        'name': 'str',
        'description': 'str',
        'start_time': 'int',
        'links': 'ILinks',
        'end_time': 'int',
        'id': 'str',
        'type': 'str',
        'version': 'str',
        'status': 'str'
    }

    attribute_map = {
        'metadata': 'metadata',
        'policy_list': 'policyList',
        'name': 'name',
        'description': 'description',
        'start_time': 'startTime',
        'links': 'links',
        'end_time': 'endTime',
        'id': 'id',
        'type': 'type',
        'version': 'version',
        'status': 'status'
    }

    def __init__(self, metadata=None, policy_list=None, name=None, description=None, start_time=None, links=None, end_time=None, id=None, type=None, version=None, status=None, _configuration=None):  # noqa: E501
        """DeploymentDetail - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._metadata = None
        self._policy_list = None
        self._name = None
        self._description = None
        self._start_time = None
        self._links = None
        self._end_time = None
        self._id = None
        self._type = None
        self._version = None
        self._status = None
        self.discriminator = None

        if metadata is not None:
            self.metadata = metadata
        if policy_list is not None:
            self.policy_list = policy_list
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if start_time is not None:
            self.start_time = start_time
        if links is not None:
            self.links = links
        if end_time is not None:
            self.end_time = end_time
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version
        if status is not None:
            self.status = status

    @property
    def metadata(self):
        """Gets the metadata of this DeploymentDetail.  # noqa: E501


        :return: The metadata of this DeploymentDetail.  # noqa: E501
        :rtype: IMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this DeploymentDetail.


        :param metadata: The metadata of this DeploymentDetail.  # noqa: E501
        :type: IMetadata
        """

        self._metadata = metadata

    @property
    def policy_list(self):
        """Gets the policy_list of this DeploymentDetail.  # noqa: E501

        Details of policies which were deployed to the device.  # noqa: E501

        :return: The policy_list of this DeploymentDetail.  # noqa: E501
        :rtype: list[IPolicyModel]
        """
        return self._policy_list

    @policy_list.setter
    def policy_list(self, policy_list):
        """Sets the policy_list of this DeploymentDetail.

        Details of policies which were deployed to the device.  # noqa: E501

        :param policy_list: The policy_list of this DeploymentDetail.  # noqa: E501
        :type: list[IPolicyModel]
        """

        self._policy_list = policy_list

    @property
    def name(self):
        """Gets the name of this DeploymentDetail.  # noqa: E501

        Name of the deployment job   # noqa: E501

        :return: The name of this DeploymentDetail.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DeploymentDetail.

        Name of the deployment job   # noqa: E501

        :param name: The name of this DeploymentDetail.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this DeploymentDetail.  # noqa: E501


        :return: The description of this DeploymentDetail.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this DeploymentDetail.


        :param description: The description of this DeploymentDetail.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def start_time(self):
        """Gets the start_time of this DeploymentDetail.  # noqa: E501

        Time in seconds at which the deployment was started, timestamp is in unix format  # noqa: E501

        :return: The start_time of this DeploymentDetail.  # noqa: E501
        :rtype: int
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this DeploymentDetail.

        Time in seconds at which the deployment was started, timestamp is in unix format  # noqa: E501

        :param start_time: The start_time of this DeploymentDetail.  # noqa: E501
        :type: int
        """

        self._start_time = start_time

    @property
    def links(self):
        """Gets the links of this DeploymentDetail.  # noqa: E501


        :return: The links of this DeploymentDetail.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this DeploymentDetail.


        :param links: The links of this DeploymentDetail.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def end_time(self):
        """Gets the end_time of this DeploymentDetail.  # noqa: E501

        Time in seconds at which the deployment ended, timestamp is in unix format  # noqa: E501

        :return: The end_time of this DeploymentDetail.  # noqa: E501
        :rtype: int
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time):
        """Sets the end_time of this DeploymentDetail.

        Time in seconds at which the deployment ended, timestamp is in unix format  # noqa: E501

        :param end_time: The end_time of this DeploymentDetail.  # noqa: E501
        :type: int
        """

        self._end_time = end_time

    @property
    def id(self):
        """Gets the id of this DeploymentDetail.  # noqa: E501


        :return: The id of this DeploymentDetail.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DeploymentDetail.


        :param id: The id of this DeploymentDetail.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this DeploymentDetail.  # noqa: E501


        :return: The type of this DeploymentDetail.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this DeploymentDetail.


        :param type: The type of this DeploymentDetail.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this DeploymentDetail.  # noqa: E501


        :return: The version of this DeploymentDetail.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this DeploymentDetail.


        :param version: The version of this DeploymentDetail.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def status(self):
        """Gets the status of this DeploymentDetail.  # noqa: E501

        Status of the deployment, can be one of DEPLOYING, SUCCEEDED, PARTIALLY_SUCCEEDED, FAILED, SSP_SUCCEEDED, SSP_FAILED, SSP_PRIMARY_BOOTSTRAP_SUCCEEDED, SSP_PRIMARY_BOOTSTRAP_FAILED, SSP_SECONDARY_BOOTSTRAP_SUCCEEDED, SSP_SECONDARY_BOOTSTRAP_FAILED, PRIMARY_BOOTSTRAP_SUCCEEDED, PRIMARY_BOOTSTRAP_FAILED, SECONDARY_BOOTSTRAP_SUCCEEDED, SECONDARY_BOOTSTRAP_FAILED, BREAK_SUCCEEDED, BREAK_FAILED, PRIMARY_BOOTSTRAP_PARTIALLY_SUCCEEDED, SECONDARY_BOOTSTRAP_PARTIALLY_SUCCEEDED, SSP_PRIMARY_BOOTSTRAP_PARTIALLY_SUCCEEDED, SSP_SECONDARY_BOOTSTRAP_PARTIALLY_SUCCEEDED, BREAK_PARTIALLY_SUCCEEDED, CANCELLED and NONE   # noqa: E501

        :return: The status of this DeploymentDetail.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this DeploymentDetail.

        Status of the deployment, can be one of DEPLOYING, SUCCEEDED, PARTIALLY_SUCCEEDED, FAILED, SSP_SUCCEEDED, SSP_FAILED, SSP_PRIMARY_BOOTSTRAP_SUCCEEDED, SSP_PRIMARY_BOOTSTRAP_FAILED, SSP_SECONDARY_BOOTSTRAP_SUCCEEDED, SSP_SECONDARY_BOOTSTRAP_FAILED, PRIMARY_BOOTSTRAP_SUCCEEDED, PRIMARY_BOOTSTRAP_FAILED, SECONDARY_BOOTSTRAP_SUCCEEDED, SECONDARY_BOOTSTRAP_FAILED, BREAK_SUCCEEDED, BREAK_FAILED, PRIMARY_BOOTSTRAP_PARTIALLY_SUCCEEDED, SECONDARY_BOOTSTRAP_PARTIALLY_SUCCEEDED, SSP_PRIMARY_BOOTSTRAP_PARTIALLY_SUCCEEDED, SSP_SECONDARY_BOOTSTRAP_PARTIALLY_SUCCEEDED, BREAK_PARTIALLY_SUCCEEDED, CANCELLED and NONE   # noqa: E501

        :param status: The status of this DeploymentDetail.  # noqa: E501
        :type: str
        """
        allowed_values = ["DEPLOYING", "SUCCEEDED", "PARTIALLY_SUCCEEDED", "FAILED", "SSP_SUCCEEDED", "SSP_FAILED", "SSP_PRIMARY_BOOTSTRAP_SUCCEEDED", "SSP_PRIMARY_BOOTSTRAP_FAILED", "SSP_SECONDARY_BOOTSTRAP_SUCCEEDED", "SSP_SECONDARY_BOOTSTRAP_FAILED", "PRIMARY_BOOTSTRAP_SUCCEEDED", "PRIMARY_BOOTSTRAP_FAILED", "SECONDARY_BOOTSTRAP_SUCCEEDED", "SECONDARY_BOOTSTRAP_FAILED", "BREAK_SUCCEEDED", "BREAK_FAILED", "PRIMARY_BOOTSTRAP_PARTIALLY_SUCCEEDED", "SECONDARY_BOOTSTRAP_PARTIALLY_SUCCEEDED", "SSP_PRIMARY_BOOTSTRAP_PARTIALLY_SUCCEEDED", "SSP_SECONDARY_BOOTSTRAP_PARTIALLY_SUCCEEDED", "BREAK_PARTIALLY_SUCCEEDED", "CANCELLED", "NONE"]  # noqa: E501
        if (self._configuration.client_side_validation and
                status not in allowed_values):
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DeploymentDetail, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeploymentDetail):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DeploymentDetail):
            return True

        return self.to_dict() != other.to_dict()
