# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class ErrorResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'severity': 'str',
        'messages': 'list[ErrorMessagesContainer]',
        'category': 'str'
    }

    attribute_map = {
        'severity': 'severity',
        'messages': 'messages',
        'category': 'category'
    }

    def __init__(self, severity=None, messages=None, category=None, _configuration=None):  # noqa: E501
        """ErrorResponse - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._severity = None
        self._messages = None
        self._category = None
        self.discriminator = None

        if severity is not None:
            self.severity = severity
        if messages is not None:
            self.messages = messages
        if category is not None:
            self.category = category

    @property
    def severity(self):
        """Gets the severity of this ErrorResponse.  # noqa: E501


        :return: The severity of this ErrorResponse.  # noqa: E501
        :rtype: str
        """
        return self._severity

    @severity.setter
    def severity(self, severity):
        """Sets the severity of this ErrorResponse.


        :param severity: The severity of this ErrorResponse.  # noqa: E501
        :type: str
        """
        allowed_values = ["ERROR", "WARN"]  # noqa: E501
        if (self._configuration.client_side_validation and
                severity not in allowed_values):
            raise ValueError(
                "Invalid value for `severity` ({0}), must be one of {1}"  # noqa: E501
                .format(severity, allowed_values)
            )

        self._severity = severity

    @property
    def messages(self):
        """Gets the messages of this ErrorResponse.  # noqa: E501


        :return: The messages of this ErrorResponse.  # noqa: E501
        :rtype: list[ErrorMessagesContainer]
        """
        return self._messages

    @messages.setter
    def messages(self, messages):
        """Sets the messages of this ErrorResponse.


        :param messages: The messages of this ErrorResponse.  # noqa: E501
        :type: list[ErrorMessagesContainer]
        """

        self._messages = messages

    @property
    def category(self):
        """Gets the category of this ErrorResponse.  # noqa: E501


        :return: The category of this ErrorResponse.  # noqa: E501
        :rtype: str
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this ErrorResponse.


        :param category: The category of this ErrorResponse.  # noqa: E501
        :type: str
        """
        allowed_values = ["FRAMEWORK", "OTHER"]  # noqa: E501
        if (self._configuration.client_side_validation and
                category not in allowed_values):
            raise ValueError(
                "Invalid value for `category` ({0}), must be one of {1}"  # noqa: E501
                .format(category, allowed_values)
            )

        self._category = category

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ErrorResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ErrorResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ErrorResponse):
            return True

        return self.to_dict() != other.to_dict()
