# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class ExternalStorage(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'template': 'str',
        'metadata': 'IMetadata',
        'int_value': 'int',
        'description': 'str',
        'type': 'str',
        'cross_launch_enabled': 'bool',
        'version': 'str',
        'long_value': 'int',
        'enabled': 'bool',
        'network': 'NetworkObject',
        'eventing_url': 'str',
        'name': 'str',
        'links': 'ILinks',
        'id': 'str'
    }

    attribute_map = {
        'template': 'template',
        'metadata': 'metadata',
        'int_value': 'intValue',
        'description': 'description',
        'type': 'type',
        'cross_launch_enabled': 'crossLaunchEnabled',
        'version': 'version',
        'long_value': 'longValue',
        'enabled': 'enabled',
        'network': 'network',
        'eventing_url': 'eventingUrl',
        'name': 'name',
        'links': 'links',
        'id': 'id'
    }

    def __init__(self, template=None, metadata=None, int_value=None, description=None, type=None, cross_launch_enabled=None, version=None, long_value=None, enabled=None, network=None, eventing_url=None, name=None, links=None, id=None, _configuration=None):  # noqa: E501
        """ExternalStorage - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._template = None
        self._metadata = None
        self._int_value = None
        self._description = None
        self._type = None
        self._cross_launch_enabled = None
        self._version = None
        self._long_value = None
        self._enabled = None
        self._network = None
        self._eventing_url = None
        self._name = None
        self._links = None
        self._id = None
        self.discriminator = None

        if template is not None:
            self.template = template
        if metadata is not None:
            self.metadata = metadata
        if int_value is not None:
            self.int_value = int_value
        if description is not None:
            self.description = description
        if type is not None:
            self.type = type
        if cross_launch_enabled is not None:
            self.cross_launch_enabled = cross_launch_enabled
        if version is not None:
            self.version = version
        if long_value is not None:
            self.long_value = long_value
        if enabled is not None:
            self.enabled = enabled
        if network is not None:
            self.network = network
        if eventing_url is not None:
            self.eventing_url = eventing_url
        if name is not None:
            self.name = name
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id

    @property
    def template(self):
        """Gets the template of this ExternalStorage.  # noqa: E501


        :return: The template of this ExternalStorage.  # noqa: E501
        :rtype: str
        """
        return self._template

    @template.setter
    def template(self, template):
        """Sets the template of this ExternalStorage.


        :param template: The template of this ExternalStorage.  # noqa: E501
        :type: str
        """

        self._template = template

    @property
    def metadata(self):
        """Gets the metadata of this ExternalStorage.  # noqa: E501


        :return: The metadata of this ExternalStorage.  # noqa: E501
        :rtype: IMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this ExternalStorage.


        :param metadata: The metadata of this ExternalStorage.  # noqa: E501
        :type: IMetadata
        """

        self._metadata = metadata

    @property
    def int_value(self):
        """Gets the int_value of this ExternalStorage.  # noqa: E501


        :return: The int_value of this ExternalStorage.  # noqa: E501
        :rtype: int
        """
        return self._int_value

    @int_value.setter
    def int_value(self, int_value):
        """Sets the int_value of this ExternalStorage.


        :param int_value: The int_value of this ExternalStorage.  # noqa: E501
        :type: int
        """

        self._int_value = int_value

    @property
    def description(self):
        """Gets the description of this ExternalStorage.  # noqa: E501


        :return: The description of this ExternalStorage.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ExternalStorage.


        :param description: The description of this ExternalStorage.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def type(self):
        """Gets the type of this ExternalStorage.  # noqa: E501


        :return: The type of this ExternalStorage.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ExternalStorage.


        :param type: The type of this ExternalStorage.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def cross_launch_enabled(self):
        """Gets the cross_launch_enabled of this ExternalStorage.  # noqa: E501


        :return: The cross_launch_enabled of this ExternalStorage.  # noqa: E501
        :rtype: bool
        """
        return self._cross_launch_enabled

    @cross_launch_enabled.setter
    def cross_launch_enabled(self, cross_launch_enabled):
        """Sets the cross_launch_enabled of this ExternalStorage.


        :param cross_launch_enabled: The cross_launch_enabled of this ExternalStorage.  # noqa: E501
        :type: bool
        """

        self._cross_launch_enabled = cross_launch_enabled

    @property
    def version(self):
        """Gets the version of this ExternalStorage.  # noqa: E501


        :return: The version of this ExternalStorage.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this ExternalStorage.


        :param version: The version of this ExternalStorage.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def long_value(self):
        """Gets the long_value of this ExternalStorage.  # noqa: E501


        :return: The long_value of this ExternalStorage.  # noqa: E501
        :rtype: int
        """
        return self._long_value

    @long_value.setter
    def long_value(self, long_value):
        """Sets the long_value of this ExternalStorage.


        :param long_value: The long_value of this ExternalStorage.  # noqa: E501
        :type: int
        """

        self._long_value = long_value

    @property
    def enabled(self):
        """Gets the enabled of this ExternalStorage.  # noqa: E501


        :return: The enabled of this ExternalStorage.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this ExternalStorage.


        :param enabled: The enabled of this ExternalStorage.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def network(self):
        """Gets the network of this ExternalStorage.  # noqa: E501


        :return: The network of this ExternalStorage.  # noqa: E501
        :rtype: NetworkObject
        """
        return self._network

    @network.setter
    def network(self, network):
        """Sets the network of this ExternalStorage.


        :param network: The network of this ExternalStorage.  # noqa: E501
        :type: NetworkObject
        """

        self._network = network

    @property
    def eventing_url(self):
        """Gets the eventing_url of this ExternalStorage.  # noqa: E501


        :return: The eventing_url of this ExternalStorage.  # noqa: E501
        :rtype: str
        """
        return self._eventing_url

    @eventing_url.setter
    def eventing_url(self, eventing_url):
        """Sets the eventing_url of this ExternalStorage.


        :param eventing_url: The eventing_url of this ExternalStorage.  # noqa: E501
        :type: str
        """

        self._eventing_url = eventing_url

    @property
    def name(self):
        """Gets the name of this ExternalStorage.  # noqa: E501


        :return: The name of this ExternalStorage.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ExternalStorage.


        :param name: The name of this ExternalStorage.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def links(self):
        """Gets the links of this ExternalStorage.  # noqa: E501


        :return: The links of this ExternalStorage.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this ExternalStorage.


        :param links: The links of this ExternalStorage.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this ExternalStorage.  # noqa: E501


        :return: The id of this ExternalStorage.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ExternalStorage.


        :param id: The id of this ExternalStorage.  # noqa: E501
        :type: str
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ExternalStorage, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExternalStorage):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ExternalStorage):
            return True

        return self.to_dict() != other.to_dict()
