# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class FQDNObject(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'metadata': 'Metadata',
        'dns_resolution': 'str',
        'overridable': 'bool',
        'name': 'str',
        'description': 'str',
        'links': 'Links',
        'overrides': 'IOverride',
        'id': 'str',
        'type': 'str',
        'value': 'str',
        'version': 'str',
        'override_target_id': 'str'
    }

    attribute_map = {
        'metadata': 'metadata',
        'dns_resolution': 'dnsResolution',
        'overridable': 'overridable',
        'name': 'name',
        'description': 'description',
        'links': 'links',
        'overrides': 'overrides',
        'id': 'id',
        'type': 'type',
        'value': 'value',
        'version': 'version',
        'override_target_id': 'overrideTargetId'
    }

    def __init__(self, metadata=None, dns_resolution=None, overridable=None, name=None, description=None, links=None, overrides=None, id=None, type=None, value=None, version=None, override_target_id=None, _configuration=None):  # noqa: E501
        """FQDNObject - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._metadata = None
        self._dns_resolution = None
        self._overridable = None
        self._name = None
        self._description = None
        self._links = None
        self._overrides = None
        self._id = None
        self._type = None
        self._value = None
        self._version = None
        self._override_target_id = None
        self.discriminator = None

        if metadata is not None:
            self.metadata = metadata
        self.dns_resolution = dns_resolution
        if overridable is not None:
            self.overridable = overridable
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if links is not None:
            self.links = links
        if overrides is not None:
            self.overrides = overrides
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if value is not None:
            self.value = value
        if version is not None:
            self.version = version
        if override_target_id is not None:
            self.override_target_id = override_target_id

    @property
    def metadata(self):
        """Gets the metadata of this FQDNObject.  # noqa: E501


        :return: The metadata of this FQDNObject.  # noqa: E501
        :rtype: Metadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this FQDNObject.


        :param metadata: The metadata of this FQDNObject.  # noqa: E501
        :type: Metadata
        """

        self._metadata = metadata

    @property
    def dns_resolution(self):
        """Gets the dns_resolution of this FQDNObject.  # noqa: E501


        :return: The dns_resolution of this FQDNObject.  # noqa: E501
        :rtype: str
        """
        return self._dns_resolution

    @dns_resolution.setter
    def dns_resolution(self, dns_resolution):
        """Sets the dns_resolution of this FQDNObject.


        :param dns_resolution: The dns_resolution of this FQDNObject.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and dns_resolution is None:
            raise ValueError("Invalid value for `dns_resolution`, must not be `None`")  # noqa: E501
        allowed_values = ["IPV4_ONLY", "IPV6_ONLY", "IPV4_AND_IPV6"]  # noqa: E501
        if (self._configuration.client_side_validation and
                dns_resolution not in allowed_values):
            raise ValueError(
                "Invalid value for `dns_resolution` ({0}), must be one of {1}"  # noqa: E501
                .format(dns_resolution, allowed_values)
            )

        self._dns_resolution = dns_resolution

    @property
    def overridable(self):
        """Gets the overridable of this FQDNObject.  # noqa: E501


        :return: The overridable of this FQDNObject.  # noqa: E501
        :rtype: bool
        """
        return self._overridable

    @overridable.setter
    def overridable(self, overridable):
        """Sets the overridable of this FQDNObject.


        :param overridable: The overridable of this FQDNObject.  # noqa: E501
        :type: bool
        """

        self._overridable = overridable

    @property
    def name(self):
        """Gets the name of this FQDNObject.  # noqa: E501


        :return: The name of this FQDNObject.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this FQDNObject.


        :param name: The name of this FQDNObject.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this FQDNObject.  # noqa: E501


        :return: The description of this FQDNObject.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this FQDNObject.


        :param description: The description of this FQDNObject.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def links(self):
        """Gets the links of this FQDNObject.  # noqa: E501


        :return: The links of this FQDNObject.  # noqa: E501
        :rtype: Links
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this FQDNObject.


        :param links: The links of this FQDNObject.  # noqa: E501
        :type: Links
        """

        self._links = links

    @property
    def overrides(self):
        """Gets the overrides of this FQDNObject.  # noqa: E501


        :return: The overrides of this FQDNObject.  # noqa: E501
        :rtype: IOverride
        """
        return self._overrides

    @overrides.setter
    def overrides(self, overrides):
        """Sets the overrides of this FQDNObject.


        :param overrides: The overrides of this FQDNObject.  # noqa: E501
        :type: IOverride
        """

        self._overrides = overrides

    @property
    def id(self):
        """Gets the id of this FQDNObject.  # noqa: E501


        :return: The id of this FQDNObject.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this FQDNObject.


        :param id: The id of this FQDNObject.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this FQDNObject.  # noqa: E501


        :return: The type of this FQDNObject.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this FQDNObject.


        :param type: The type of this FQDNObject.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def value(self):
        """Gets the value of this FQDNObject.  # noqa: E501


        :return: The value of this FQDNObject.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this FQDNObject.


        :param value: The value of this FQDNObject.  # noqa: E501
        :type: str
        """

        self._value = value

    @property
    def version(self):
        """Gets the version of this FQDNObject.  # noqa: E501


        :return: The version of this FQDNObject.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this FQDNObject.


        :param version: The version of this FQDNObject.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def override_target_id(self):
        """Gets the override_target_id of this FQDNObject.  # noqa: E501


        :return: The override_target_id of this FQDNObject.  # noqa: E501
        :rtype: str
        """
        return self._override_target_id

    @override_target_id.setter
    def override_target_id(self, override_target_id):
        """Sets the override_target_id of this FQDNObject.


        :param override_target_id: The override_target_id of this FQDNObject.  # noqa: E501
        :type: str
        """

        self._override_target_id = override_target_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FQDNObject, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FQDNObject):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FQDNObject):
            return True

        return self.to_dict() != other.to_dict()
