# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class FTDHAIPv6Configuration(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ipv6_active_standby_pair': 'list[IFTDHAIPv6ActiveStandbyPair]',
        'active_i_pv6_link_local_address': 'str',
        'standby_i_pv6_link_local_address': 'str'
    }

    attribute_map = {
        'ipv6_active_standby_pair': 'ipv6ActiveStandbyPair',
        'active_i_pv6_link_local_address': 'activeIPv6LinkLocalAddress',
        'standby_i_pv6_link_local_address': 'standbyIPv6LinkLocalAddress'
    }

    def __init__(self, ipv6_active_standby_pair=None, active_i_pv6_link_local_address=None, standby_i_pv6_link_local_address=None, _configuration=None):  # noqa: E501
        """FTDHAIPv6Configuration - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._ipv6_active_standby_pair = None
        self._active_i_pv6_link_local_address = None
        self._standby_i_pv6_link_local_address = None
        self.discriminator = None

        if ipv6_active_standby_pair is not None:
            self.ipv6_active_standby_pair = ipv6_active_standby_pair
        if active_i_pv6_link_local_address is not None:
            self.active_i_pv6_link_local_address = active_i_pv6_link_local_address
        if standby_i_pv6_link_local_address is not None:
            self.standby_i_pv6_link_local_address = standby_i_pv6_link_local_address

    @property
    def ipv6_active_standby_pair(self):
        """Gets the ipv6_active_standby_pair of this FTDHAIPv6Configuration.  # noqa: E501


        :return: The ipv6_active_standby_pair of this FTDHAIPv6Configuration.  # noqa: E501
        :rtype: list[IFTDHAIPv6ActiveStandbyPair]
        """
        return self._ipv6_active_standby_pair

    @ipv6_active_standby_pair.setter
    def ipv6_active_standby_pair(self, ipv6_active_standby_pair):
        """Sets the ipv6_active_standby_pair of this FTDHAIPv6Configuration.


        :param ipv6_active_standby_pair: The ipv6_active_standby_pair of this FTDHAIPv6Configuration.  # noqa: E501
        :type: list[IFTDHAIPv6ActiveStandbyPair]
        """

        self._ipv6_active_standby_pair = ipv6_active_standby_pair

    @property
    def active_i_pv6_link_local_address(self):
        """Gets the active_i_pv6_link_local_address of this FTDHAIPv6Configuration.  # noqa: E501


        :return: The active_i_pv6_link_local_address of this FTDHAIPv6Configuration.  # noqa: E501
        :rtype: str
        """
        return self._active_i_pv6_link_local_address

    @active_i_pv6_link_local_address.setter
    def active_i_pv6_link_local_address(self, active_i_pv6_link_local_address):
        """Sets the active_i_pv6_link_local_address of this FTDHAIPv6Configuration.


        :param active_i_pv6_link_local_address: The active_i_pv6_link_local_address of this FTDHAIPv6Configuration.  # noqa: E501
        :type: str
        """

        self._active_i_pv6_link_local_address = active_i_pv6_link_local_address

    @property
    def standby_i_pv6_link_local_address(self):
        """Gets the standby_i_pv6_link_local_address of this FTDHAIPv6Configuration.  # noqa: E501


        :return: The standby_i_pv6_link_local_address of this FTDHAIPv6Configuration.  # noqa: E501
        :rtype: str
        """
        return self._standby_i_pv6_link_local_address

    @standby_i_pv6_link_local_address.setter
    def standby_i_pv6_link_local_address(self, standby_i_pv6_link_local_address):
        """Sets the standby_i_pv6_link_local_address of this FTDHAIPv6Configuration.


        :param standby_i_pv6_link_local_address: The standby_i_pv6_link_local_address of this FTDHAIPv6Configuration.  # noqa: E501
        :type: str
        """

        self._standby_i_pv6_link_local_address = standby_i_pv6_link_local_address

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FTDHAIPv6Configuration, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FTDHAIPv6Configuration):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FTDHAIPv6Configuration):
            return True

        return self.to_dict() != other.to_dict()
