# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class HealthMonitorModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'date_time': 'str',
        'health_monitor_metric': 'IHealthMonitorMetric',
        'metadata': 'IMetadata',
        'metric': 'str',
        'name': 'str',
        'description': 'str',
        'links': 'ILinks',
        'id': 'str',
        'type': 'str',
        'version': 'str'
    }

    attribute_map = {
        'date_time': 'dateTime',
        'health_monitor_metric': 'healthMonitorMetric',
        'metadata': 'metadata',
        'metric': 'metric',
        'name': 'name',
        'description': 'description',
        'links': 'links',
        'id': 'id',
        'type': 'type',
        'version': 'version'
    }

    def __init__(self, date_time=None, health_monitor_metric=None, metadata=None, metric=None, name=None, description=None, links=None, id=None, type=None, version=None, _configuration=None):  # noqa: E501
        """HealthMonitorModel - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._date_time = None
        self._health_monitor_metric = None
        self._metadata = None
        self._metric = None
        self._name = None
        self._description = None
        self._links = None
        self._id = None
        self._type = None
        self._version = None
        self.discriminator = None

        if date_time is not None:
            self.date_time = date_time
        if health_monitor_metric is not None:
            self.health_monitor_metric = health_monitor_metric
        if metadata is not None:
            self.metadata = metadata
        if metric is not None:
            self.metric = metric
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version

    @property
    def date_time(self):
        """Gets the date_time of this HealthMonitorModel.  # noqa: E501


        :return: The date_time of this HealthMonitorModel.  # noqa: E501
        :rtype: str
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this HealthMonitorModel.


        :param date_time: The date_time of this HealthMonitorModel.  # noqa: E501
        :type: str
        """

        self._date_time = date_time

    @property
    def health_monitor_metric(self):
        """Gets the health_monitor_metric of this HealthMonitorModel.  # noqa: E501


        :return: The health_monitor_metric of this HealthMonitorModel.  # noqa: E501
        :rtype: IHealthMonitorMetric
        """
        return self._health_monitor_metric

    @health_monitor_metric.setter
    def health_monitor_metric(self, health_monitor_metric):
        """Sets the health_monitor_metric of this HealthMonitorModel.


        :param health_monitor_metric: The health_monitor_metric of this HealthMonitorModel.  # noqa: E501
        :type: IHealthMonitorMetric
        """

        self._health_monitor_metric = health_monitor_metric

    @property
    def metadata(self):
        """Gets the metadata of this HealthMonitorModel.  # noqa: E501


        :return: The metadata of this HealthMonitorModel.  # noqa: E501
        :rtype: IMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this HealthMonitorModel.


        :param metadata: The metadata of this HealthMonitorModel.  # noqa: E501
        :type: IMetadata
        """

        self._metadata = metadata

    @property
    def metric(self):
        """Gets the metric of this HealthMonitorModel.  # noqa: E501


        :return: The metric of this HealthMonitorModel.  # noqa: E501
        :rtype: str
        """
        return self._metric

    @metric.setter
    def metric(self, metric):
        """Sets the metric of this HealthMonitorModel.


        :param metric: The metric of this HealthMonitorModel.  # noqa: E501
        :type: str
        """

        self._metric = metric

    @property
    def name(self):
        """Gets the name of this HealthMonitorModel.  # noqa: E501


        :return: The name of this HealthMonitorModel.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this HealthMonitorModel.


        :param name: The name of this HealthMonitorModel.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this HealthMonitorModel.  # noqa: E501


        :return: The description of this HealthMonitorModel.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this HealthMonitorModel.


        :param description: The description of this HealthMonitorModel.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def links(self):
        """Gets the links of this HealthMonitorModel.  # noqa: E501


        :return: The links of this HealthMonitorModel.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this HealthMonitorModel.


        :param links: The links of this HealthMonitorModel.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this HealthMonitorModel.  # noqa: E501


        :return: The id of this HealthMonitorModel.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this HealthMonitorModel.


        :param id: The id of this HealthMonitorModel.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this HealthMonitorModel.  # noqa: E501


        :return: The type of this HealthMonitorModel.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this HealthMonitorModel.


        :param type: The type of this HealthMonitorModel.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this HealthMonitorModel.  # noqa: E501


        :return: The version of this HealthMonitorModel.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this HealthMonitorModel.


        :param version: The version of this HealthMonitorModel.  # noqa: E501
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(HealthMonitorModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HealthMonitorModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, HealthMonitorModel):
            return True

        return self.to_dict() != other.to_dict()
