# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class HitCountMetadata(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'last_user': 'MetadataUser',
        'task': 'ITaskStatus',
        'rule_index': 'int',
        'domain': 'Domain',
        'device_rule_id': 'str',
        'timestamp': 'int',
        'policy': 'IPolicyModel'
    }

    attribute_map = {
        'last_user': 'lastUser',
        'task': 'task',
        'rule_index': 'ruleIndex',
        'domain': 'domain',
        'device_rule_id': 'deviceRuleId',
        'timestamp': 'timestamp',
        'policy': 'policy'
    }

    def __init__(self, last_user=None, task=None, rule_index=None, domain=None, device_rule_id=None, timestamp=None, policy=None, _configuration=None):  # noqa: E501
        """HitCountMetadata - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._last_user = None
        self._task = None
        self._rule_index = None
        self._domain = None
        self._device_rule_id = None
        self._timestamp = None
        self._policy = None
        self.discriminator = None

        if last_user is not None:
            self.last_user = last_user
        if task is not None:
            self.task = task
        if rule_index is not None:
            self.rule_index = rule_index
        if domain is not None:
            self.domain = domain
        if device_rule_id is not None:
            self.device_rule_id = device_rule_id
        if timestamp is not None:
            self.timestamp = timestamp
        if policy is not None:
            self.policy = policy

    @property
    def last_user(self):
        """Gets the last_user of this HitCountMetadata.  # noqa: E501


        :return: The last_user of this HitCountMetadata.  # noqa: E501
        :rtype: MetadataUser
        """
        return self._last_user

    @last_user.setter
    def last_user(self, last_user):
        """Sets the last_user of this HitCountMetadata.


        :param last_user: The last_user of this HitCountMetadata.  # noqa: E501
        :type: MetadataUser
        """

        self._last_user = last_user

    @property
    def task(self):
        """Gets the task of this HitCountMetadata.  # noqa: E501

        Object representing the task status of the hit count operation.  # noqa: E501

        :return: The task of this HitCountMetadata.  # noqa: E501
        :rtype: ITaskStatus
        """
        return self._task

    @task.setter
    def task(self, task):
        """Sets the task of this HitCountMetadata.

        Object representing the task status of the hit count operation.  # noqa: E501

        :param task: The task of this HitCountMetadata.  # noqa: E501
        :type: ITaskStatus
        """

        self._task = task

    @property
    def rule_index(self):
        """Gets the rule_index of this HitCountMetadata.  # noqa: E501

        Index number of the rule in the access control or prefilter policy list, against which the hit count information is retrieved.  # noqa: E501

        :return: The rule_index of this HitCountMetadata.  # noqa: E501
        :rtype: int
        """
        return self._rule_index

    @rule_index.setter
    def rule_index(self, rule_index):
        """Sets the rule_index of this HitCountMetadata.

        Index number of the rule in the access control or prefilter policy list, against which the hit count information is retrieved.  # noqa: E501

        :param rule_index: The rule_index of this HitCountMetadata.  # noqa: E501
        :type: int
        """

        self._rule_index = rule_index

    @property
    def domain(self):
        """Gets the domain of this HitCountMetadata.  # noqa: E501

        Object representing the domain under which the operation has been performed.  # noqa: E501

        :return: The domain of this HitCountMetadata.  # noqa: E501
        :rtype: Domain
        """
        return self._domain

    @domain.setter
    def domain(self, domain):
        """Sets the domain of this HitCountMetadata.

        Object representing the domain under which the operation has been performed.  # noqa: E501

        :param domain: The domain of this HitCountMetadata.  # noqa: E501
        :type: Domain
        """

        self._domain = domain

    @property
    def device_rule_id(self):
        """Gets the device_rule_id of this HitCountMetadata.  # noqa: E501

        ID of the rule on the target device console.  # noqa: E501

        :return: The device_rule_id of this HitCountMetadata.  # noqa: E501
        :rtype: str
        """
        return self._device_rule_id

    @device_rule_id.setter
    def device_rule_id(self, device_rule_id):
        """Sets the device_rule_id of this HitCountMetadata.

        ID of the rule on the target device console.  # noqa: E501

        :param device_rule_id: The device_rule_id of this HitCountMetadata.  # noqa: E501
        :type: str
        """

        self._device_rule_id = device_rule_id

    @property
    def timestamp(self):
        """Gets the timestamp of this HitCountMetadata.  # noqa: E501


        :return: The timestamp of this HitCountMetadata.  # noqa: E501
        :rtype: int
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """Sets the timestamp of this HitCountMetadata.


        :param timestamp: The timestamp of this HitCountMetadata.  # noqa: E501
        :type: int
        """

        self._timestamp = timestamp

    @property
    def policy(self):
        """Gets the policy of this HitCountMetadata.  # noqa: E501

        Object representing the access control or prefilter policy containing the rule.  # noqa: E501

        :return: The policy of this HitCountMetadata.  # noqa: E501
        :rtype: IPolicyModel
        """
        return self._policy

    @policy.setter
    def policy(self, policy):
        """Sets the policy of this HitCountMetadata.

        Object representing the access control or prefilter policy containing the rule.  # noqa: E501

        :param policy: The policy of this HitCountMetadata.  # noqa: E501
        :type: IPolicyModel
        """

        self._policy = policy

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(HitCountMetadata, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HitCountMetadata):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, HitCountMetadata):
            return True

        return self.to_dict() != other.to_dict()
