# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IAddressContainer(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'address': 'str',
        'enforce_eui64': 'bool',
        'prefix': 'str'
    }

    attribute_map = {
        'address': 'address',
        'enforce_eui64': 'enforceEUI64',
        'prefix': 'prefix'
    }

    def __init__(self, address=None, enforce_eui64=None, prefix=None, _configuration=None):  # noqa: E501
        """IAddressContainer - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._address = None
        self._enforce_eui64 = None
        self._prefix = None
        self.discriminator = None

        if address is not None:
            self.address = address
        if enforce_eui64 is not None:
            self.enforce_eui64 = enforce_eui64
        if prefix is not None:
            self.prefix = prefix

    @property
    def address(self):
        """Gets the address of this IAddressContainer.  # noqa: E501


        :return: The address of this IAddressContainer.  # noqa: E501
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this IAddressContainer.


        :param address: The address of this IAddressContainer.  # noqa: E501
        :type: str
        """

        self._address = address

    @property
    def enforce_eui64(self):
        """Gets the enforce_eui64 of this IAddressContainer.  # noqa: E501


        :return: The enforce_eui64 of this IAddressContainer.  # noqa: E501
        :rtype: bool
        """
        return self._enforce_eui64

    @enforce_eui64.setter
    def enforce_eui64(self, enforce_eui64):
        """Sets the enforce_eui64 of this IAddressContainer.


        :param enforce_eui64: The enforce_eui64 of this IAddressContainer.  # noqa: E501
        :type: bool
        """

        self._enforce_eui64 = enforce_eui64

    @property
    def prefix(self):
        """Gets the prefix of this IAddressContainer.  # noqa: E501


        :return: The prefix of this IAddressContainer.  # noqa: E501
        :rtype: str
        """
        return self._prefix

    @prefix.setter
    def prefix(self, prefix):
        """Sets the prefix of this IAddressContainer.


        :param prefix: The prefix of this IAddressContainer.  # noqa: E501
        :type: str
        """

        self._prefix = prefix

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IAddressContainer, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IAddressContainer):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IAddressContainer):
            return True

        return self.to_dict() != other.to_dict()
