# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IAdvertisement(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'auto_config': 'bool',
        'offlink': 'bool',
        'prefer_life_time': 'PreferLifeTime'
    }

    attribute_map = {
        'auto_config': 'autoConfig',
        'offlink': 'offlink',
        'prefer_life_time': 'preferLifeTime'
    }

    def __init__(self, auto_config=None, offlink=None, prefer_life_time=None, _configuration=None):  # noqa: E501
        """IAdvertisement - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._auto_config = None
        self._offlink = None
        self._prefer_life_time = None
        self.discriminator = None

        if auto_config is not None:
            self.auto_config = auto_config
        if offlink is not None:
            self.offlink = offlink
        if prefer_life_time is not None:
            self.prefer_life_time = prefer_life_time

    @property
    def auto_config(self):
        """Gets the auto_config of this IAdvertisement.  # noqa: E501


        :return: The auto_config of this IAdvertisement.  # noqa: E501
        :rtype: bool
        """
        return self._auto_config

    @auto_config.setter
    def auto_config(self, auto_config):
        """Sets the auto_config of this IAdvertisement.


        :param auto_config: The auto_config of this IAdvertisement.  # noqa: E501
        :type: bool
        """

        self._auto_config = auto_config

    @property
    def offlink(self):
        """Gets the offlink of this IAdvertisement.  # noqa: E501


        :return: The offlink of this IAdvertisement.  # noqa: E501
        :rtype: bool
        """
        return self._offlink

    @offlink.setter
    def offlink(self, offlink):
        """Sets the offlink of this IAdvertisement.


        :param offlink: The offlink of this IAdvertisement.  # noqa: E501
        :type: bool
        """

        self._offlink = offlink

    @property
    def prefer_life_time(self):
        """Gets the prefer_life_time of this IAdvertisement.  # noqa: E501


        :return: The prefer_life_time of this IAdvertisement.  # noqa: E501
        :rtype: PreferLifeTime
        """
        return self._prefer_life_time

    @prefer_life_time.setter
    def prefer_life_time(self, prefer_life_time):
        """Sets the prefer_life_time of this IAdvertisement.


        :param prefer_life_time: The prefer_life_time of this IAdvertisement.  # noqa: E501
        :type: PreferLifeTime
        """

        self._prefer_life_time = prefer_life_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IAdvertisement, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IAdvertisement):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IAdvertisement):
            return True

        return self.to_dict() != other.to_dict()
