# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IAsPathListEntry(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sequence': 'int',
        'regular_expression': 'str',
        'action': 'str'
    }

    attribute_map = {
        'sequence': 'sequence',
        'regular_expression': 'regularExpression',
        'action': 'action'
    }

    def __init__(self, sequence=None, regular_expression=None, action=None, _configuration=None):  # noqa: E501
        """IAsPathListEntry - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._sequence = None
        self._regular_expression = None
        self._action = None
        self.discriminator = None

        self.sequence = sequence
        if regular_expression is not None:
            self.regular_expression = regular_expression
        if action is not None:
            self.action = action

    @property
    def sequence(self):
        """Gets the sequence of this IAsPathListEntry.  # noqa: E501


        :return: The sequence of this IAsPathListEntry.  # noqa: E501
        :rtype: int
        """
        return self._sequence

    @sequence.setter
    def sequence(self, sequence):
        """Sets the sequence of this IAsPathListEntry.


        :param sequence: The sequence of this IAsPathListEntry.  # noqa: E501
        :type: int
        """
        if self._configuration.client_side_validation and sequence is None:
            raise ValueError("Invalid value for `sequence`, must not be `None`")  # noqa: E501

        self._sequence = sequence

    @property
    def regular_expression(self):
        """Gets the regular_expression of this IAsPathListEntry.  # noqa: E501


        :return: The regular_expression of this IAsPathListEntry.  # noqa: E501
        :rtype: str
        """
        return self._regular_expression

    @regular_expression.setter
    def regular_expression(self, regular_expression):
        """Sets the regular_expression of this IAsPathListEntry.


        :param regular_expression: The regular_expression of this IAsPathListEntry.  # noqa: E501
        :type: str
        """

        self._regular_expression = regular_expression

    @property
    def action(self):
        """Gets the action of this IAsPathListEntry.  # noqa: E501


        :return: The action of this IAsPathListEntry.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this IAsPathListEntry.


        :param action: The action of this IAsPathListEntry.  # noqa: E501
        :type: str
        """
        allowed_values = ["PERMIT", "DENY"]  # noqa: E501
        if (self._configuration.client_side_validation and
                action not in allowed_values):
            raise ValueError(
                "Invalid value for `action` ({0}), must be one of {1}"  # noqa: E501
                .format(action, allowed_values)
            )

        self._action = action

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IAsPathListEntry, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IAsPathListEntry):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IAsPathListEntry):
            return True

        return self.to_dict() != other.to_dict()
