# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IAuthTypeAndString(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'crypto_key_string': 'str',
        'crypto_encryption_type': 'str'
    }

    attribute_map = {
        'crypto_key_string': 'cryptoKeyString',
        'crypto_encryption_type': 'cryptoEncryptionType'
    }

    def __init__(self, crypto_key_string=None, crypto_encryption_type=None, _configuration=None):  # noqa: E501
        """IAuthTypeAndString - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._crypto_key_string = None
        self._crypto_encryption_type = None
        self.discriminator = None

        if crypto_key_string is not None:
            self.crypto_key_string = crypto_key_string
        if crypto_encryption_type is not None:
            self.crypto_encryption_type = crypto_encryption_type

    @property
    def crypto_key_string(self):
        """Gets the crypto_key_string of this IAuthTypeAndString.  # noqa: E501


        :return: The crypto_key_string of this IAuthTypeAndString.  # noqa: E501
        :rtype: str
        """
        return self._crypto_key_string

    @crypto_key_string.setter
    def crypto_key_string(self, crypto_key_string):
        """Sets the crypto_key_string of this IAuthTypeAndString.


        :param crypto_key_string: The crypto_key_string of this IAuthTypeAndString.  # noqa: E501
        :type: str
        """

        self._crypto_key_string = crypto_key_string

    @property
    def crypto_encryption_type(self):
        """Gets the crypto_encryption_type of this IAuthTypeAndString.  # noqa: E501


        :return: The crypto_encryption_type of this IAuthTypeAndString.  # noqa: E501
        :rtype: str
        """
        return self._crypto_encryption_type

    @crypto_encryption_type.setter
    def crypto_encryption_type(self, crypto_encryption_type):
        """Sets the crypto_encryption_type of this IAuthTypeAndString.


        :param crypto_encryption_type: The crypto_encryption_type of this IAuthTypeAndString.  # noqa: E501
        :type: str
        """
        allowed_values = ["PLAINTEXT"]  # noqa: E501
        if (self._configuration.client_side_validation and
                crypto_encryption_type not in allowed_values):
            raise ValueError(
                "Invalid value for `crypto_encryption_type` ({0}), must be one of {1}"  # noqa: E501
                .format(crypto_encryption_type, allowed_values)
            )

        self._crypto_encryption_type = crypto_encryption_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IAuthTypeAndString, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IAuthTypeAndString):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IAuthTypeAndString):
            return True

        return self.to_dict() != other.to_dict()
