# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class ICertificateMapSettings(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'use_cert_map_configured_in_endpoint_to_determine_tunnel': 'bool',
        'use_peer_ip_address_to_determine_tunnel': 'bool',
        'use_certificate_ou_to_determine_tunnel': 'bool',
        'use_ike_identity_ou_to_determine_tunnel': 'bool'
    }

    attribute_map = {
        'use_cert_map_configured_in_endpoint_to_determine_tunnel': 'useCertMapConfiguredInEndpointToDetermineTunnel',
        'use_peer_ip_address_to_determine_tunnel': 'usePeerIpAddressToDetermineTunnel',
        'use_certificate_ou_to_determine_tunnel': 'useCertificateOuToDetermineTunnel',
        'use_ike_identity_ou_to_determine_tunnel': 'useIkeIdentityOuToDetermineTunnel'
    }

    def __init__(self, use_cert_map_configured_in_endpoint_to_determine_tunnel=None, use_peer_ip_address_to_determine_tunnel=None, use_certificate_ou_to_determine_tunnel=None, use_ike_identity_ou_to_determine_tunnel=None, _configuration=None):  # noqa: E501
        """ICertificateMapSettings - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._use_cert_map_configured_in_endpoint_to_determine_tunnel = None
        self._use_peer_ip_address_to_determine_tunnel = None
        self._use_certificate_ou_to_determine_tunnel = None
        self._use_ike_identity_ou_to_determine_tunnel = None
        self.discriminator = None

        if use_cert_map_configured_in_endpoint_to_determine_tunnel is not None:
            self.use_cert_map_configured_in_endpoint_to_determine_tunnel = use_cert_map_configured_in_endpoint_to_determine_tunnel
        if use_peer_ip_address_to_determine_tunnel is not None:
            self.use_peer_ip_address_to_determine_tunnel = use_peer_ip_address_to_determine_tunnel
        if use_certificate_ou_to_determine_tunnel is not None:
            self.use_certificate_ou_to_determine_tunnel = use_certificate_ou_to_determine_tunnel
        if use_ike_identity_ou_to_determine_tunnel is not None:
            self.use_ike_identity_ou_to_determine_tunnel = use_ike_identity_ou_to_determine_tunnel

    @property
    def use_cert_map_configured_in_endpoint_to_determine_tunnel(self):
        """Gets the use_cert_map_configured_in_endpoint_to_determine_tunnel of this ICertificateMapSettings.  # noqa: E501


        :return: The use_cert_map_configured_in_endpoint_to_determine_tunnel of this ICertificateMapSettings.  # noqa: E501
        :rtype: bool
        """
        return self._use_cert_map_configured_in_endpoint_to_determine_tunnel

    @use_cert_map_configured_in_endpoint_to_determine_tunnel.setter
    def use_cert_map_configured_in_endpoint_to_determine_tunnel(self, use_cert_map_configured_in_endpoint_to_determine_tunnel):
        """Sets the use_cert_map_configured_in_endpoint_to_determine_tunnel of this ICertificateMapSettings.


        :param use_cert_map_configured_in_endpoint_to_determine_tunnel: The use_cert_map_configured_in_endpoint_to_determine_tunnel of this ICertificateMapSettings.  # noqa: E501
        :type: bool
        """

        self._use_cert_map_configured_in_endpoint_to_determine_tunnel = use_cert_map_configured_in_endpoint_to_determine_tunnel

    @property
    def use_peer_ip_address_to_determine_tunnel(self):
        """Gets the use_peer_ip_address_to_determine_tunnel of this ICertificateMapSettings.  # noqa: E501


        :return: The use_peer_ip_address_to_determine_tunnel of this ICertificateMapSettings.  # noqa: E501
        :rtype: bool
        """
        return self._use_peer_ip_address_to_determine_tunnel

    @use_peer_ip_address_to_determine_tunnel.setter
    def use_peer_ip_address_to_determine_tunnel(self, use_peer_ip_address_to_determine_tunnel):
        """Sets the use_peer_ip_address_to_determine_tunnel of this ICertificateMapSettings.


        :param use_peer_ip_address_to_determine_tunnel: The use_peer_ip_address_to_determine_tunnel of this ICertificateMapSettings.  # noqa: E501
        :type: bool
        """

        self._use_peer_ip_address_to_determine_tunnel = use_peer_ip_address_to_determine_tunnel

    @property
    def use_certificate_ou_to_determine_tunnel(self):
        """Gets the use_certificate_ou_to_determine_tunnel of this ICertificateMapSettings.  # noqa: E501


        :return: The use_certificate_ou_to_determine_tunnel of this ICertificateMapSettings.  # noqa: E501
        :rtype: bool
        """
        return self._use_certificate_ou_to_determine_tunnel

    @use_certificate_ou_to_determine_tunnel.setter
    def use_certificate_ou_to_determine_tunnel(self, use_certificate_ou_to_determine_tunnel):
        """Sets the use_certificate_ou_to_determine_tunnel of this ICertificateMapSettings.


        :param use_certificate_ou_to_determine_tunnel: The use_certificate_ou_to_determine_tunnel of this ICertificateMapSettings.  # noqa: E501
        :type: bool
        """

        self._use_certificate_ou_to_determine_tunnel = use_certificate_ou_to_determine_tunnel

    @property
    def use_ike_identity_ou_to_determine_tunnel(self):
        """Gets the use_ike_identity_ou_to_determine_tunnel of this ICertificateMapSettings.  # noqa: E501


        :return: The use_ike_identity_ou_to_determine_tunnel of this ICertificateMapSettings.  # noqa: E501
        :rtype: bool
        """
        return self._use_ike_identity_ou_to_determine_tunnel

    @use_ike_identity_ou_to_determine_tunnel.setter
    def use_ike_identity_ou_to_determine_tunnel(self, use_ike_identity_ou_to_determine_tunnel):
        """Sets the use_ike_identity_ou_to_determine_tunnel of this ICertificateMapSettings.


        :param use_ike_identity_ou_to_determine_tunnel: The use_ike_identity_ou_to_determine_tunnel of this ICertificateMapSettings.  # noqa: E501
        :type: bool
        """

        self._use_ike_identity_ou_to_determine_tunnel = use_ike_identity_ou_to_determine_tunnel

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ICertificateMapSettings, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ICertificateMapSettings):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ICertificateMapSettings):
            return True

        return self.to_dict() != other.to_dict()
