# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IDevice(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'host_name': 'str',
        'metadata': 'IMetadata',
        'model_id': 'str',
        'advanced': 'IAdvanced',
        'nat_id': 'str',
        'license_caps': 'list[str]',
        'description': 'str',
        'ftd_mode': 'str',
        'model_type': 'str',
        'keep_local_events': 'bool',
        'reg_key': 'str',
        'type': 'str',
        'version': 'str',
        'sw_version': 'str',
        'health_status': 'str',
        'health_policy': 'IHealthPolicy',
        'name': 'str',
        'model': 'str',
        'model_number': 'str',
        'links': 'ILinks',
        'access_policy': 'IPolicyModel',
        'id': 'str',
        'prohibit_packet_transfer': 'bool',
        'device_group': 'IDeviceGroup'
    }

    attribute_map = {
        'host_name': 'hostName',
        'metadata': 'metadata',
        'model_id': 'modelId',
        'advanced': 'advanced',
        'nat_id': 'natID',
        'license_caps': 'license_caps',
        'description': 'description',
        'ftd_mode': 'ftdMode',
        'model_type': 'modelType',
        'keep_local_events': 'keepLocalEvents',
        'reg_key': 'regKey',
        'type': 'type',
        'version': 'version',
        'sw_version': 'sw_version',
        'health_status': 'healthStatus',
        'health_policy': 'healthPolicy',
        'name': 'name',
        'model': 'model',
        'model_number': 'modelNumber',
        'links': 'links',
        'access_policy': 'accessPolicy',
        'id': 'id',
        'prohibit_packet_transfer': 'prohibitPacketTransfer',
        'device_group': 'deviceGroup'
    }

    def __init__(self, host_name=None, metadata=None, model_id=None, advanced=None, nat_id=None, license_caps=None, description=None, ftd_mode=None, model_type=None, keep_local_events=None, reg_key=None, type=None, version=None, sw_version=None, health_status=None, health_policy=None, name=None, model=None, model_number=None, links=None, access_policy=None, id=None, prohibit_packet_transfer=None, device_group=None, _configuration=None):  # noqa: E501
        """IDevice - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._host_name = None
        self._metadata = None
        self._model_id = None
        self._advanced = None
        self._nat_id = None
        self._license_caps = None
        self._description = None
        self._ftd_mode = None
        self._model_type = None
        self._keep_local_events = None
        self._reg_key = None
        self._type = None
        self._version = None
        self._sw_version = None
        self._health_status = None
        self._health_policy = None
        self._name = None
        self._model = None
        self._model_number = None
        self._links = None
        self._access_policy = None
        self._id = None
        self._prohibit_packet_transfer = None
        self._device_group = None
        self.discriminator = None

        self.host_name = host_name
        if metadata is not None:
            self.metadata = metadata
        if model_id is not None:
            self.model_id = model_id
        if advanced is not None:
            self.advanced = advanced
        if nat_id is not None:
            self.nat_id = nat_id
        self.license_caps = license_caps
        if description is not None:
            self.description = description
        if ftd_mode is not None:
            self.ftd_mode = ftd_mode
        if model_type is not None:
            self.model_type = model_type
        if keep_local_events is not None:
            self.keep_local_events = keep_local_events
        self.reg_key = reg_key
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version
        if sw_version is not None:
            self.sw_version = sw_version
        if health_status is not None:
            self.health_status = health_status
        if health_policy is not None:
            self.health_policy = health_policy
        if name is not None:
            self.name = name
        if model is not None:
            self.model = model
        if model_number is not None:
            self.model_number = model_number
        if links is not None:
            self.links = links
        if access_policy is not None:
            self.access_policy = access_policy
        if id is not None:
            self.id = id
        if prohibit_packet_transfer is not None:
            self.prohibit_packet_transfer = prohibit_packet_transfer
        if device_group is not None:
            self.device_group = device_group

    @property
    def host_name(self):
        """Gets the host_name of this IDevice.  # noqa: E501


        :return: The host_name of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._host_name

    @host_name.setter
    def host_name(self, host_name):
        """Sets the host_name of this IDevice.


        :param host_name: The host_name of this IDevice.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and host_name is None:
            raise ValueError("Invalid value for `host_name`, must not be `None`")  # noqa: E501

        self._host_name = host_name

    @property
    def metadata(self):
        """Gets the metadata of this IDevice.  # noqa: E501


        :return: The metadata of this IDevice.  # noqa: E501
        :rtype: IMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this IDevice.


        :param metadata: The metadata of this IDevice.  # noqa: E501
        :type: IMetadata
        """

        self._metadata = metadata

    @property
    def model_id(self):
        """Gets the model_id of this IDevice.  # noqa: E501


        :return: The model_id of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._model_id

    @model_id.setter
    def model_id(self, model_id):
        """Sets the model_id of this IDevice.


        :param model_id: The model_id of this IDevice.  # noqa: E501
        :type: str
        """

        self._model_id = model_id

    @property
    def advanced(self):
        """Gets the advanced of this IDevice.  # noqa: E501


        :return: The advanced of this IDevice.  # noqa: E501
        :rtype: IAdvanced
        """
        return self._advanced

    @advanced.setter
    def advanced(self, advanced):
        """Sets the advanced of this IDevice.


        :param advanced: The advanced of this IDevice.  # noqa: E501
        :type: IAdvanced
        """

        self._advanced = advanced

    @property
    def nat_id(self):
        """Gets the nat_id of this IDevice.  # noqa: E501


        :return: The nat_id of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._nat_id

    @nat_id.setter
    def nat_id(self, nat_id):
        """Sets the nat_id of this IDevice.


        :param nat_id: The nat_id of this IDevice.  # noqa: E501
        :type: str
        """

        self._nat_id = nat_id

    @property
    def license_caps(self):
        """Gets the license_caps of this IDevice.  # noqa: E501


        :return: The license_caps of this IDevice.  # noqa: E501
        :rtype: list[str]
        """
        return self._license_caps

    @license_caps.setter
    def license_caps(self, license_caps):
        """Sets the license_caps of this IDevice.


        :param license_caps: The license_caps of this IDevice.  # noqa: E501
        :type: list[str]
        """
        if self._configuration.client_side_validation and license_caps is None:
            raise ValueError("Invalid value for `license_caps`, must not be `None`")  # noqa: E501

        self._license_caps = license_caps

    @property
    def description(self):
        """Gets the description of this IDevice.  # noqa: E501


        :return: The description of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this IDevice.


        :param description: The description of this IDevice.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def ftd_mode(self):
        """Gets the ftd_mode of this IDevice.  # noqa: E501


        :return: The ftd_mode of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._ftd_mode

    @ftd_mode.setter
    def ftd_mode(self, ftd_mode):
        """Sets the ftd_mode of this IDevice.


        :param ftd_mode: The ftd_mode of this IDevice.  # noqa: E501
        :type: str
        """
        allowed_values = ["ROUTED", "TRANSPARENT"]  # noqa: E501
        if (self._configuration.client_side_validation and
                ftd_mode not in allowed_values):
            raise ValueError(
                "Invalid value for `ftd_mode` ({0}), must be one of {1}"  # noqa: E501
                .format(ftd_mode, allowed_values)
            )

        self._ftd_mode = ftd_mode

    @property
    def model_type(self):
        """Gets the model_type of this IDevice.  # noqa: E501


        :return: The model_type of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._model_type

    @model_type.setter
    def model_type(self, model_type):
        """Sets the model_type of this IDevice.


        :param model_type: The model_type of this IDevice.  # noqa: E501
        :type: str
        """

        self._model_type = model_type

    @property
    def keep_local_events(self):
        """Gets the keep_local_events of this IDevice.  # noqa: E501


        :return: The keep_local_events of this IDevice.  # noqa: E501
        :rtype: bool
        """
        return self._keep_local_events

    @keep_local_events.setter
    def keep_local_events(self, keep_local_events):
        """Sets the keep_local_events of this IDevice.


        :param keep_local_events: The keep_local_events of this IDevice.  # noqa: E501
        :type: bool
        """

        self._keep_local_events = keep_local_events

    @property
    def reg_key(self):
        """Gets the reg_key of this IDevice.  # noqa: E501


        :return: The reg_key of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._reg_key

    @reg_key.setter
    def reg_key(self, reg_key):
        """Sets the reg_key of this IDevice.


        :param reg_key: The reg_key of this IDevice.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and reg_key is None:
            raise ValueError("Invalid value for `reg_key`, must not be `None`")  # noqa: E501

        self._reg_key = reg_key

    @property
    def type(self):
        """Gets the type of this IDevice.  # noqa: E501


        :return: The type of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this IDevice.


        :param type: The type of this IDevice.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this IDevice.  # noqa: E501


        :return: The version of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this IDevice.


        :param version: The version of this IDevice.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def sw_version(self):
        """Gets the sw_version of this IDevice.  # noqa: E501


        :return: The sw_version of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._sw_version

    @sw_version.setter
    def sw_version(self, sw_version):
        """Sets the sw_version of this IDevice.


        :param sw_version: The sw_version of this IDevice.  # noqa: E501
        :type: str
        """

        self._sw_version = sw_version

    @property
    def health_status(self):
        """Gets the health_status of this IDevice.  # noqa: E501


        :return: The health_status of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._health_status

    @health_status.setter
    def health_status(self, health_status):
        """Sets the health_status of this IDevice.


        :param health_status: The health_status of this IDevice.  # noqa: E501
        :type: str
        """

        self._health_status = health_status

    @property
    def health_policy(self):
        """Gets the health_policy of this IDevice.  # noqa: E501


        :return: The health_policy of this IDevice.  # noqa: E501
        :rtype: IHealthPolicy
        """
        return self._health_policy

    @health_policy.setter
    def health_policy(self, health_policy):
        """Sets the health_policy of this IDevice.


        :param health_policy: The health_policy of this IDevice.  # noqa: E501
        :type: IHealthPolicy
        """

        self._health_policy = health_policy

    @property
    def name(self):
        """Gets the name of this IDevice.  # noqa: E501


        :return: The name of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this IDevice.


        :param name: The name of this IDevice.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def model(self):
        """Gets the model of this IDevice.  # noqa: E501


        :return: The model of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this IDevice.


        :param model: The model of this IDevice.  # noqa: E501
        :type: str
        """

        self._model = model

    @property
    def model_number(self):
        """Gets the model_number of this IDevice.  # noqa: E501


        :return: The model_number of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._model_number

    @model_number.setter
    def model_number(self, model_number):
        """Sets the model_number of this IDevice.


        :param model_number: The model_number of this IDevice.  # noqa: E501
        :type: str
        """

        self._model_number = model_number

    @property
    def links(self):
        """Gets the links of this IDevice.  # noqa: E501


        :return: The links of this IDevice.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this IDevice.


        :param links: The links of this IDevice.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def access_policy(self):
        """Gets the access_policy of this IDevice.  # noqa: E501


        :return: The access_policy of this IDevice.  # noqa: E501
        :rtype: IPolicyModel
        """
        return self._access_policy

    @access_policy.setter
    def access_policy(self, access_policy):
        """Sets the access_policy of this IDevice.


        :param access_policy: The access_policy of this IDevice.  # noqa: E501
        :type: IPolicyModel
        """

        self._access_policy = access_policy

    @property
    def id(self):
        """Gets the id of this IDevice.  # noqa: E501


        :return: The id of this IDevice.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this IDevice.


        :param id: The id of this IDevice.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def prohibit_packet_transfer(self):
        """Gets the prohibit_packet_transfer of this IDevice.  # noqa: E501


        :return: The prohibit_packet_transfer of this IDevice.  # noqa: E501
        :rtype: bool
        """
        return self._prohibit_packet_transfer

    @prohibit_packet_transfer.setter
    def prohibit_packet_transfer(self, prohibit_packet_transfer):
        """Sets the prohibit_packet_transfer of this IDevice.


        :param prohibit_packet_transfer: The prohibit_packet_transfer of this IDevice.  # noqa: E501
        :type: bool
        """

        self._prohibit_packet_transfer = prohibit_packet_transfer

    @property
    def device_group(self):
        """Gets the device_group of this IDevice.  # noqa: E501


        :return: The device_group of this IDevice.  # noqa: E501
        :rtype: IDeviceGroup
        """
        return self._device_group

    @device_group.setter
    def device_group(self, device_group):
        """Sets the device_group of this IDevice.


        :param device_group: The device_group of this IDevice.  # noqa: E501
        :type: IDeviceGroup
        """

        self._device_group = device_group

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IDevice, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IDevice):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IDevice):
            return True

        return self.to_dict() != other.to_dict()
