# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IDeviceChassisData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'security_module_no': 'int',
        'chassis_url': 'str',
        'security_module_sn': 'str',
        'chassis_serial_no': 'str'
    }

    attribute_map = {
        'security_module_no': 'securityModuleNo',
        'chassis_url': 'chassisUrl',
        'security_module_sn': 'securityModuleSN',
        'chassis_serial_no': 'chassisSerialNo'
    }

    def __init__(self, security_module_no=None, chassis_url=None, security_module_sn=None, chassis_serial_no=None, _configuration=None):  # noqa: E501
        """IDeviceChassisData - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._security_module_no = None
        self._chassis_url = None
        self._security_module_sn = None
        self._chassis_serial_no = None
        self.discriminator = None

        if security_module_no is not None:
            self.security_module_no = security_module_no
        if chassis_url is not None:
            self.chassis_url = chassis_url
        if security_module_sn is not None:
            self.security_module_sn = security_module_sn
        if chassis_serial_no is not None:
            self.chassis_serial_no = chassis_serial_no

    @property
    def security_module_no(self):
        """Gets the security_module_no of this IDeviceChassisData.  # noqa: E501


        :return: The security_module_no of this IDeviceChassisData.  # noqa: E501
        :rtype: int
        """
        return self._security_module_no

    @security_module_no.setter
    def security_module_no(self, security_module_no):
        """Sets the security_module_no of this IDeviceChassisData.


        :param security_module_no: The security_module_no of this IDeviceChassisData.  # noqa: E501
        :type: int
        """

        self._security_module_no = security_module_no

    @property
    def chassis_url(self):
        """Gets the chassis_url of this IDeviceChassisData.  # noqa: E501


        :return: The chassis_url of this IDeviceChassisData.  # noqa: E501
        :rtype: str
        """
        return self._chassis_url

    @chassis_url.setter
    def chassis_url(self, chassis_url):
        """Sets the chassis_url of this IDeviceChassisData.


        :param chassis_url: The chassis_url of this IDeviceChassisData.  # noqa: E501
        :type: str
        """

        self._chassis_url = chassis_url

    @property
    def security_module_sn(self):
        """Gets the security_module_sn of this IDeviceChassisData.  # noqa: E501


        :return: The security_module_sn of this IDeviceChassisData.  # noqa: E501
        :rtype: str
        """
        return self._security_module_sn

    @security_module_sn.setter
    def security_module_sn(self, security_module_sn):
        """Sets the security_module_sn of this IDeviceChassisData.


        :param security_module_sn: The security_module_sn of this IDeviceChassisData.  # noqa: E501
        :type: str
        """

        self._security_module_sn = security_module_sn

    @property
    def chassis_serial_no(self):
        """Gets the chassis_serial_no of this IDeviceChassisData.  # noqa: E501


        :return: The chassis_serial_no of this IDeviceChassisData.  # noqa: E501
        :rtype: str
        """
        return self._chassis_serial_no

    @chassis_serial_no.setter
    def chassis_serial_no(self, chassis_serial_no):
        """Sets the chassis_serial_no of this IDeviceChassisData.


        :param chassis_serial_no: The chassis_serial_no of this IDeviceChassisData.  # noqa: E501
        :type: str
        """

        self._chassis_serial_no = chassis_serial_no

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IDeviceChassisData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IDeviceChassisData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IDeviceChassisData):
            return True

        return self.to_dict() != other.to_dict()
