# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IGroupDependencyDetailEntry(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'selectively_deployable_policies': 'list[str]',
        'mandatory_deployable_policies': 'list[str]',
        'dependent_policy_list': 'list[IDependentPolicy]'
    }

    attribute_map = {
        'selectively_deployable_policies': 'selectivelyDeployablePolicies',
        'mandatory_deployable_policies': 'mandatoryDeployablePolicies',
        'dependent_policy_list': 'dependentPolicyList'
    }

    def __init__(self, selectively_deployable_policies=None, mandatory_deployable_policies=None, dependent_policy_list=None, _configuration=None):  # noqa: E501
        """IGroupDependencyDetailEntry - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._selectively_deployable_policies = None
        self._mandatory_deployable_policies = None
        self._dependent_policy_list = None
        self.discriminator = None

        if selectively_deployable_policies is not None:
            self.selectively_deployable_policies = selectively_deployable_policies
        if mandatory_deployable_policies is not None:
            self.mandatory_deployable_policies = mandatory_deployable_policies
        if dependent_policy_list is not None:
            self.dependent_policy_list = dependent_policy_list

    @property
    def selectively_deployable_policies(self):
        """Gets the selectively_deployable_policies of this IGroupDependencyDetailEntry.  # noqa: E501

        List of out-of-date policies which can be selectively deployed.  # noqa: E501

        :return: The selectively_deployable_policies of this IGroupDependencyDetailEntry.  # noqa: E501
        :rtype: list[str]
        """
        return self._selectively_deployable_policies

    @selectively_deployable_policies.setter
    def selectively_deployable_policies(self, selectively_deployable_policies):
        """Sets the selectively_deployable_policies of this IGroupDependencyDetailEntry.

        List of out-of-date policies which can be selectively deployed.  # noqa: E501

        :param selectively_deployable_policies: The selectively_deployable_policies of this IGroupDependencyDetailEntry.  # noqa: E501
        :type: list[str]
        """

        self._selectively_deployable_policies = selectively_deployable_policies

    @property
    def mandatory_deployable_policies(self):
        """Gets the mandatory_deployable_policies of this IGroupDependencyDetailEntry.  # noqa: E501

        List of out-of-date policies which must get deployed always in the upcoming deployment. These policies will get added into the deployment by default.  # noqa: E501

        :return: The mandatory_deployable_policies of this IGroupDependencyDetailEntry.  # noqa: E501
        :rtype: list[str]
        """
        return self._mandatory_deployable_policies

    @mandatory_deployable_policies.setter
    def mandatory_deployable_policies(self, mandatory_deployable_policies):
        """Sets the mandatory_deployable_policies of this IGroupDependencyDetailEntry.

        List of out-of-date policies which must get deployed always in the upcoming deployment. These policies will get added into the deployment by default.  # noqa: E501

        :param mandatory_deployable_policies: The mandatory_deployable_policies of this IGroupDependencyDetailEntry.  # noqa: E501
        :type: list[str]
        """

        self._mandatory_deployable_policies = mandatory_deployable_policies

    @property
    def dependent_policy_list(self):
        """Gets the dependent_policy_list of this IGroupDependencyDetailEntry.  # noqa: E501

        Describes the dependency between the out-of-date policies with the reason  # noqa: E501

        :return: The dependent_policy_list of this IGroupDependencyDetailEntry.  # noqa: E501
        :rtype: list[IDependentPolicy]
        """
        return self._dependent_policy_list

    @dependent_policy_list.setter
    def dependent_policy_list(self, dependent_policy_list):
        """Sets the dependent_policy_list of this IGroupDependencyDetailEntry.

        Describes the dependency between the out-of-date policies with the reason  # noqa: E501

        :param dependent_policy_list: The dependent_policy_list of this IGroupDependencyDetailEntry.  # noqa: E501
        :type: list[IDependentPolicy]
        """

        self._dependent_policy_list = dependent_policy_list

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IGroupDependencyDetailEntry, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IGroupDependencyDetailEntry):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IGroupDependencyDetailEntry):
            return True

        return self.to_dict() != other.to_dict()
