# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IHardwareContainer(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'duplex': 'str',
        'speed': 'str'
    }

    attribute_map = {
        'duplex': 'duplex',
        'speed': 'speed'
    }

    def __init__(self, duplex=None, speed=None, _configuration=None):  # noqa: E501
        """IHardwareContainer - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._duplex = None
        self._speed = None
        self.discriminator = None

        if duplex is not None:
            self.duplex = duplex
        if speed is not None:
            self.speed = speed

    @property
    def duplex(self):
        """Gets the duplex of this IHardwareContainer.  # noqa: E501


        :return: The duplex of this IHardwareContainer.  # noqa: E501
        :rtype: str
        """
        return self._duplex

    @duplex.setter
    def duplex(self, duplex):
        """Sets the duplex of this IHardwareContainer.


        :param duplex: The duplex of this IHardwareContainer.  # noqa: E501
        :type: str
        """
        allowed_values = ["AUTO", "FULL", "HALF"]  # noqa: E501
        if (self._configuration.client_side_validation and
                duplex not in allowed_values):
            raise ValueError(
                "Invalid value for `duplex` ({0}), must be one of {1}"  # noqa: E501
                .format(duplex, allowed_values)
            )

        self._duplex = duplex

    @property
    def speed(self):
        """Gets the speed of this IHardwareContainer.  # noqa: E501


        :return: The speed of this IHardwareContainer.  # noqa: E501
        :rtype: str
        """
        return self._speed

    @speed.setter
    def speed(self, speed):
        """Sets the speed of this IHardwareContainer.


        :param speed: The speed of this IHardwareContainer.  # noqa: E501
        :type: str
        """
        allowed_values = ["AUTO", "TEN", "HUNDRED", "THOUSAND", "TEN_THOUSAND", "FORTY_THOUSAND", "LAKH"]  # noqa: E501
        if (self._configuration.client_side_validation and
                speed not in allowed_values):
            raise ValueError(
                "Invalid value for `speed` ({0}), must be one of {1}"  # noqa: E501
                .format(speed, allowed_values)
            )

        self._speed = speed

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IHardwareContainer, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IHardwareContainer):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IHardwareContainer):
            return True

        return self.to_dict() != other.to_dict()
