# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IIpvPrefixListFilter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ipv6_prefix_list': 'IReference',
        'filter_update_action': 'str',
        'name': 'str',
        'ipv4_prefix_list': 'IReference',
        'links': 'ILinks',
        'id': 'str',
        'type': 'str'
    }

    attribute_map = {
        'ipv6_prefix_list': 'ipv6PrefixList',
        'filter_update_action': 'filterUpdateAction',
        'name': 'name',
        'ipv4_prefix_list': 'ipv4PrefixList',
        'links': 'links',
        'id': 'id',
        'type': 'type'
    }

    def __init__(self, ipv6_prefix_list=None, filter_update_action=None, name=None, ipv4_prefix_list=None, links=None, id=None, type=None, _configuration=None):  # noqa: E501
        """IIpvPrefixListFilter - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._ipv6_prefix_list = None
        self._filter_update_action = None
        self._name = None
        self._ipv4_prefix_list = None
        self._links = None
        self._id = None
        self._type = None
        self.discriminator = None

        if ipv6_prefix_list is not None:
            self.ipv6_prefix_list = ipv6_prefix_list
        if filter_update_action is not None:
            self.filter_update_action = filter_update_action
        if name is not None:
            self.name = name
        if ipv4_prefix_list is not None:
            self.ipv4_prefix_list = ipv4_prefix_list
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type

    @property
    def ipv6_prefix_list(self):
        """Gets the ipv6_prefix_list of this IIpvPrefixListFilter.  # noqa: E501


        :return: The ipv6_prefix_list of this IIpvPrefixListFilter.  # noqa: E501
        :rtype: IReference
        """
        return self._ipv6_prefix_list

    @ipv6_prefix_list.setter
    def ipv6_prefix_list(self, ipv6_prefix_list):
        """Sets the ipv6_prefix_list of this IIpvPrefixListFilter.


        :param ipv6_prefix_list: The ipv6_prefix_list of this IIpvPrefixListFilter.  # noqa: E501
        :type: IReference
        """

        self._ipv6_prefix_list = ipv6_prefix_list

    @property
    def filter_update_action(self):
        """Gets the filter_update_action of this IIpvPrefixListFilter.  # noqa: E501


        :return: The filter_update_action of this IIpvPrefixListFilter.  # noqa: E501
        :rtype: str
        """
        return self._filter_update_action

    @filter_update_action.setter
    def filter_update_action(self, filter_update_action):
        """Sets the filter_update_action of this IIpvPrefixListFilter.


        :param filter_update_action: The filter_update_action of this IIpvPrefixListFilter.  # noqa: E501
        :type: str
        """
        allowed_values = ["IN", "OUT"]  # noqa: E501
        if (self._configuration.client_side_validation and
                filter_update_action not in allowed_values):
            raise ValueError(
                "Invalid value for `filter_update_action` ({0}), must be one of {1}"  # noqa: E501
                .format(filter_update_action, allowed_values)
            )

        self._filter_update_action = filter_update_action

    @property
    def name(self):
        """Gets the name of this IIpvPrefixListFilter.  # noqa: E501


        :return: The name of this IIpvPrefixListFilter.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this IIpvPrefixListFilter.


        :param name: The name of this IIpvPrefixListFilter.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def ipv4_prefix_list(self):
        """Gets the ipv4_prefix_list of this IIpvPrefixListFilter.  # noqa: E501


        :return: The ipv4_prefix_list of this IIpvPrefixListFilter.  # noqa: E501
        :rtype: IReference
        """
        return self._ipv4_prefix_list

    @ipv4_prefix_list.setter
    def ipv4_prefix_list(self, ipv4_prefix_list):
        """Sets the ipv4_prefix_list of this IIpvPrefixListFilter.


        :param ipv4_prefix_list: The ipv4_prefix_list of this IIpvPrefixListFilter.  # noqa: E501
        :type: IReference
        """

        self._ipv4_prefix_list = ipv4_prefix_list

    @property
    def links(self):
        """Gets the links of this IIpvPrefixListFilter.  # noqa: E501


        :return: The links of this IIpvPrefixListFilter.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this IIpvPrefixListFilter.


        :param links: The links of this IIpvPrefixListFilter.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this IIpvPrefixListFilter.  # noqa: E501


        :return: The id of this IIpvPrefixListFilter.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this IIpvPrefixListFilter.


        :param id: The id of this IIpvPrefixListFilter.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this IIpvPrefixListFilter.  # noqa: E501


        :return: The type of this IIpvPrefixListFilter.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this IIpvPrefixListFilter.


        :param type: The type of this IIpvPrefixListFilter.  # noqa: E501
        :type: str
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IIpvPrefixListFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IIpvPrefixListFilter):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IIpvPrefixListFilter):
            return True

        return self.to_dict() != other.to_dict()
