# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IMaximumTransmissionUnitAging(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'reset_interval_minutes': 'int',
        'enabled': 'bool'
    }

    attribute_map = {
        'reset_interval_minutes': 'resetIntervalMinutes',
        'enabled': 'enabled'
    }

    def __init__(self, reset_interval_minutes=None, enabled=None, _configuration=None):  # noqa: E501
        """IMaximumTransmissionUnitAging - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._reset_interval_minutes = None
        self._enabled = None
        self.discriminator = None

        if reset_interval_minutes is not None:
            self.reset_interval_minutes = reset_interval_minutes
        if enabled is not None:
            self.enabled = enabled

    @property
    def reset_interval_minutes(self):
        """Gets the reset_interval_minutes of this IMaximumTransmissionUnitAging.  # noqa: E501

        Interval before resetting the MTU.  # noqa: E501

        :return: The reset_interval_minutes of this IMaximumTransmissionUnitAging.  # noqa: E501
        :rtype: int
        """
        return self._reset_interval_minutes

    @reset_interval_minutes.setter
    def reset_interval_minutes(self, reset_interval_minutes):
        """Sets the reset_interval_minutes of this IMaximumTransmissionUnitAging.

        Interval before resetting the MTU.  # noqa: E501

        :param reset_interval_minutes: The reset_interval_minutes of this IMaximumTransmissionUnitAging.  # noqa: E501
        :type: int
        """

        self._reset_interval_minutes = reset_interval_minutes

    @property
    def enabled(self):
        """Gets the enabled of this IMaximumTransmissionUnitAging.  # noqa: E501

        Indicates whether MTU aging is enabled.  # noqa: E501

        :return: The enabled of this IMaximumTransmissionUnitAging.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this IMaximumTransmissionUnitAging.

        Indicates whether MTU aging is enabled.  # noqa: E501

        :param enabled: The enabled of this IMaximumTransmissionUnitAging.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IMaximumTransmissionUnitAging, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IMaximumTransmissionUnitAging):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IMaximumTransmissionUnitAging):
            return True

        return self.to_dict() != other.to_dict()
