# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class INatKeepaliveTraversal(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'enabled': 'bool',
        'interval_seconds': 'int'
    }

    attribute_map = {
        'enabled': 'enabled',
        'interval_seconds': 'intervalSeconds'
    }

    def __init__(self, enabled=None, interval_seconds=None, _configuration=None):  # noqa: E501
        """INatKeepaliveTraversal - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._enabled = None
        self._interval_seconds = None
        self.discriminator = None

        if enabled is not None:
            self.enabled = enabled
        if interval_seconds is not None:
            self.interval_seconds = interval_seconds

    @property
    def enabled(self):
        """Gets the enabled of this INatKeepaliveTraversal.  # noqa: E501


        :return: The enabled of this INatKeepaliveTraversal.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this INatKeepaliveTraversal.


        :param enabled: The enabled of this INatKeepaliveTraversal.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def interval_seconds(self):
        """Gets the interval_seconds of this INatKeepaliveTraversal.  # noqa: E501


        :return: The interval_seconds of this INatKeepaliveTraversal.  # noqa: E501
        :rtype: int
        """
        return self._interval_seconds

    @interval_seconds.setter
    def interval_seconds(self, interval_seconds):
        """Sets the interval_seconds of this INatKeepaliveTraversal.


        :param interval_seconds: The interval_seconds of this INatKeepaliveTraversal.  # noqa: E501
        :type: int
        """

        self._interval_seconds = interval_seconds

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(INatKeepaliveTraversal, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, INatKeepaliveTraversal):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, INatKeepaliveTraversal):
            return True

        return self.to_dict() != other.to_dict()
