# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class INeighborAdvertiseMaps(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'route_map': 'IRouteMap',
        'name': 'str',
        'links': 'ILinks',
        'exist_route_map': 'IRouteMap',
        'id': 'str',
        'exist_map': 'bool',
        'type': 'str'
    }

    attribute_map = {
        'route_map': 'routeMap',
        'name': 'name',
        'links': 'links',
        'exist_route_map': 'existRouteMap',
        'id': 'id',
        'exist_map': 'existMap',
        'type': 'type'
    }

    def __init__(self, route_map=None, name=None, links=None, exist_route_map=None, id=None, exist_map=None, type=None, _configuration=None):  # noqa: E501
        """INeighborAdvertiseMaps - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._route_map = None
        self._name = None
        self._links = None
        self._exist_route_map = None
        self._id = None
        self._exist_map = None
        self._type = None
        self.discriminator = None

        if route_map is not None:
            self.route_map = route_map
        if name is not None:
            self.name = name
        if links is not None:
            self.links = links
        if exist_route_map is not None:
            self.exist_route_map = exist_route_map
        if id is not None:
            self.id = id
        if exist_map is not None:
            self.exist_map = exist_map
        if type is not None:
            self.type = type

    @property
    def route_map(self):
        """Gets the route_map of this INeighborAdvertiseMaps.  # noqa: E501


        :return: The route_map of this INeighborAdvertiseMaps.  # noqa: E501
        :rtype: IRouteMap
        """
        return self._route_map

    @route_map.setter
    def route_map(self, route_map):
        """Sets the route_map of this INeighborAdvertiseMaps.


        :param route_map: The route_map of this INeighborAdvertiseMaps.  # noqa: E501
        :type: IRouteMap
        """

        self._route_map = route_map

    @property
    def name(self):
        """Gets the name of this INeighborAdvertiseMaps.  # noqa: E501


        :return: The name of this INeighborAdvertiseMaps.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this INeighborAdvertiseMaps.


        :param name: The name of this INeighborAdvertiseMaps.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def links(self):
        """Gets the links of this INeighborAdvertiseMaps.  # noqa: E501


        :return: The links of this INeighborAdvertiseMaps.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this INeighborAdvertiseMaps.


        :param links: The links of this INeighborAdvertiseMaps.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def exist_route_map(self):
        """Gets the exist_route_map of this INeighborAdvertiseMaps.  # noqa: E501


        :return: The exist_route_map of this INeighborAdvertiseMaps.  # noqa: E501
        :rtype: IRouteMap
        """
        return self._exist_route_map

    @exist_route_map.setter
    def exist_route_map(self, exist_route_map):
        """Sets the exist_route_map of this INeighborAdvertiseMaps.


        :param exist_route_map: The exist_route_map of this INeighborAdvertiseMaps.  # noqa: E501
        :type: IRouteMap
        """

        self._exist_route_map = exist_route_map

    @property
    def id(self):
        """Gets the id of this INeighborAdvertiseMaps.  # noqa: E501


        :return: The id of this INeighborAdvertiseMaps.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this INeighborAdvertiseMaps.


        :param id: The id of this INeighborAdvertiseMaps.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def exist_map(self):
        """Gets the exist_map of this INeighborAdvertiseMaps.  # noqa: E501


        :return: The exist_map of this INeighborAdvertiseMaps.  # noqa: E501
        :rtype: bool
        """
        return self._exist_map

    @exist_map.setter
    def exist_map(self, exist_map):
        """Sets the exist_map of this INeighborAdvertiseMaps.


        :param exist_map: The exist_map of this INeighborAdvertiseMaps.  # noqa: E501
        :type: bool
        """

        self._exist_map = exist_map

    @property
    def type(self):
        """Gets the type of this INeighborAdvertiseMaps.  # noqa: E501


        :return: The type of this INeighborAdvertiseMaps.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this INeighborAdvertiseMaps.


        :param type: The type of this INeighborAdvertiseMaps.  # noqa: E501
        :type: str
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(INeighborAdvertiseMaps, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, INeighborAdvertiseMaps):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, INeighborAdvertiseMaps):
            return True

        return self.to_dict() != other.to_dict()
