# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class INeighborGeneral(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'enable_address': 'bool',
        'name': 'str',
        'description': 'str',
        'links': 'ILinks',
        'id': 'str',
        'fall_over_bfd': 'str',
        'type': 'str',
        'shutdown': 'bool'
    }

    attribute_map = {
        'enable_address': 'enableAddress',
        'name': 'name',
        'description': 'description',
        'links': 'links',
        'id': 'id',
        'fall_over_bfd': 'fallOverBFD',
        'type': 'type',
        'shutdown': 'shutdown'
    }

    def __init__(self, enable_address=None, name=None, description=None, links=None, id=None, fall_over_bfd=None, type=None, shutdown=None, _configuration=None):  # noqa: E501
        """INeighborGeneral - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._enable_address = None
        self._name = None
        self._description = None
        self._links = None
        self._id = None
        self._fall_over_bfd = None
        self._type = None
        self._shutdown = None
        self.discriminator = None

        if enable_address is not None:
            self.enable_address = enable_address
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if fall_over_bfd is not None:
            self.fall_over_bfd = fall_over_bfd
        if type is not None:
            self.type = type
        if shutdown is not None:
            self.shutdown = shutdown

    @property
    def enable_address(self):
        """Gets the enable_address of this INeighborGeneral.  # noqa: E501


        :return: The enable_address of this INeighborGeneral.  # noqa: E501
        :rtype: bool
        """
        return self._enable_address

    @enable_address.setter
    def enable_address(self, enable_address):
        """Sets the enable_address of this INeighborGeneral.


        :param enable_address: The enable_address of this INeighborGeneral.  # noqa: E501
        :type: bool
        """

        self._enable_address = enable_address

    @property
    def name(self):
        """Gets the name of this INeighborGeneral.  # noqa: E501


        :return: The name of this INeighborGeneral.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this INeighborGeneral.


        :param name: The name of this INeighborGeneral.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this INeighborGeneral.  # noqa: E501


        :return: The description of this INeighborGeneral.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this INeighborGeneral.


        :param description: The description of this INeighborGeneral.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def links(self):
        """Gets the links of this INeighborGeneral.  # noqa: E501


        :return: The links of this INeighborGeneral.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this INeighborGeneral.


        :param links: The links of this INeighborGeneral.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this INeighborGeneral.  # noqa: E501


        :return: The id of this INeighborGeneral.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this INeighborGeneral.


        :param id: The id of this INeighborGeneral.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def fall_over_bfd(self):
        """Gets the fall_over_bfd of this INeighborGeneral.  # noqa: E501


        :return: The fall_over_bfd of this INeighborGeneral.  # noqa: E501
        :rtype: str
        """
        return self._fall_over_bfd

    @fall_over_bfd.setter
    def fall_over_bfd(self, fall_over_bfd):
        """Sets the fall_over_bfd of this INeighborGeneral.


        :param fall_over_bfd: The fall_over_bfd of this INeighborGeneral.  # noqa: E501
        :type: str
        """
        allowed_values = ["SINGLE_HOP", "MULTI_HOP"]  # noqa: E501
        if (self._configuration.client_side_validation and
                fall_over_bfd not in allowed_values):
            raise ValueError(
                "Invalid value for `fall_over_bfd` ({0}), must be one of {1}"  # noqa: E501
                .format(fall_over_bfd, allowed_values)
            )

        self._fall_over_bfd = fall_over_bfd

    @property
    def type(self):
        """Gets the type of this INeighborGeneral.  # noqa: E501


        :return: The type of this INeighborGeneral.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this INeighborGeneral.


        :param type: The type of this INeighborGeneral.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def shutdown(self):
        """Gets the shutdown of this INeighborGeneral.  # noqa: E501


        :return: The shutdown of this INeighborGeneral.  # noqa: E501
        :rtype: bool
        """
        return self._shutdown

    @shutdown.setter
    def shutdown(self, shutdown):
        """Sets the shutdown of this INeighborGeneral.


        :param shutdown: The shutdown of this INeighborGeneral.  # noqa: E501
        :type: bool
        """

        self._shutdown = shutdown

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(INeighborGeneral, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, INeighborGeneral):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, INeighborGeneral):
            return True

        return self.to_dict() != other.to_dict()
