# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class INeighborLocalAs(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'no_prepend': 'bool',
        'as_number': 'str',
        'name': 'str',
        'links': 'ILinks',
        'id': 'str',
        'replace_as': 'bool',
        'type': 'str',
        'dual_as': 'bool'
    }

    attribute_map = {
        'no_prepend': 'noPrepend',
        'as_number': 'asNumber',
        'name': 'name',
        'links': 'links',
        'id': 'id',
        'replace_as': 'replaceAs',
        'type': 'type',
        'dual_as': 'dualAs'
    }

    def __init__(self, no_prepend=None, as_number=None, name=None, links=None, id=None, replace_as=None, type=None, dual_as=None, _configuration=None):  # noqa: E501
        """INeighborLocalAs - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._no_prepend = None
        self._as_number = None
        self._name = None
        self._links = None
        self._id = None
        self._replace_as = None
        self._type = None
        self._dual_as = None
        self.discriminator = None

        if no_prepend is not None:
            self.no_prepend = no_prepend
        if as_number is not None:
            self.as_number = as_number
        if name is not None:
            self.name = name
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if replace_as is not None:
            self.replace_as = replace_as
        if type is not None:
            self.type = type
        if dual_as is not None:
            self.dual_as = dual_as

    @property
    def no_prepend(self):
        """Gets the no_prepend of this INeighborLocalAs.  # noqa: E501


        :return: The no_prepend of this INeighborLocalAs.  # noqa: E501
        :rtype: bool
        """
        return self._no_prepend

    @no_prepend.setter
    def no_prepend(self, no_prepend):
        """Sets the no_prepend of this INeighborLocalAs.


        :param no_prepend: The no_prepend of this INeighborLocalAs.  # noqa: E501
        :type: bool
        """

        self._no_prepend = no_prepend

    @property
    def as_number(self):
        """Gets the as_number of this INeighborLocalAs.  # noqa: E501


        :return: The as_number of this INeighborLocalAs.  # noqa: E501
        :rtype: str
        """
        return self._as_number

    @as_number.setter
    def as_number(self, as_number):
        """Sets the as_number of this INeighborLocalAs.


        :param as_number: The as_number of this INeighborLocalAs.  # noqa: E501
        :type: str
        """

        self._as_number = as_number

    @property
    def name(self):
        """Gets the name of this INeighborLocalAs.  # noqa: E501


        :return: The name of this INeighborLocalAs.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this INeighborLocalAs.


        :param name: The name of this INeighborLocalAs.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def links(self):
        """Gets the links of this INeighborLocalAs.  # noqa: E501


        :return: The links of this INeighborLocalAs.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this INeighborLocalAs.


        :param links: The links of this INeighborLocalAs.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this INeighborLocalAs.  # noqa: E501


        :return: The id of this INeighborLocalAs.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this INeighborLocalAs.


        :param id: The id of this INeighborLocalAs.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def replace_as(self):
        """Gets the replace_as of this INeighborLocalAs.  # noqa: E501


        :return: The replace_as of this INeighborLocalAs.  # noqa: E501
        :rtype: bool
        """
        return self._replace_as

    @replace_as.setter
    def replace_as(self, replace_as):
        """Sets the replace_as of this INeighborLocalAs.


        :param replace_as: The replace_as of this INeighborLocalAs.  # noqa: E501
        :type: bool
        """

        self._replace_as = replace_as

    @property
    def type(self):
        """Gets the type of this INeighborLocalAs.  # noqa: E501


        :return: The type of this INeighborLocalAs.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this INeighborLocalAs.


        :param type: The type of this INeighborLocalAs.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def dual_as(self):
        """Gets the dual_as of this INeighborLocalAs.  # noqa: E501


        :return: The dual_as of this INeighborLocalAs.  # noqa: E501
        :rtype: bool
        """
        return self._dual_as

    @dual_as.setter
    def dual_as(self, dual_as):
        """Sets the dual_as of this INeighborLocalAs.


        :param dual_as: The dual_as of this INeighborLocalAs.  # noqa: E501
        :type: bool
        """

        self._dual_as = dual_as

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(INeighborLocalAs, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, INeighborLocalAs):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, INeighborLocalAs):
            return True

        return self.to_dict() != other.to_dict()
