# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class INeighborMaximumPrefix(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'max_prefix_limit': 'int',
        'name': 'str',
        'warning_only': 'bool',
        'threshold_value': 'int',
        'links': 'ILinks',
        'id': 'str',
        'type': 'str',
        'restart_interval': 'int'
    }

    attribute_map = {
        'max_prefix_limit': 'maxPrefixLimit',
        'name': 'name',
        'warning_only': 'warningOnly',
        'threshold_value': 'thresholdValue',
        'links': 'links',
        'id': 'id',
        'type': 'type',
        'restart_interval': 'restartInterval'
    }

    def __init__(self, max_prefix_limit=None, name=None, warning_only=None, threshold_value=None, links=None, id=None, type=None, restart_interval=None, _configuration=None):  # noqa: E501
        """INeighborMaximumPrefix - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._max_prefix_limit = None
        self._name = None
        self._warning_only = None
        self._threshold_value = None
        self._links = None
        self._id = None
        self._type = None
        self._restart_interval = None
        self.discriminator = None

        if max_prefix_limit is not None:
            self.max_prefix_limit = max_prefix_limit
        if name is not None:
            self.name = name
        if warning_only is not None:
            self.warning_only = warning_only
        if threshold_value is not None:
            self.threshold_value = threshold_value
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if restart_interval is not None:
            self.restart_interval = restart_interval

    @property
    def max_prefix_limit(self):
        """Gets the max_prefix_limit of this INeighborMaximumPrefix.  # noqa: E501


        :return: The max_prefix_limit of this INeighborMaximumPrefix.  # noqa: E501
        :rtype: int
        """
        return self._max_prefix_limit

    @max_prefix_limit.setter
    def max_prefix_limit(self, max_prefix_limit):
        """Sets the max_prefix_limit of this INeighborMaximumPrefix.


        :param max_prefix_limit: The max_prefix_limit of this INeighborMaximumPrefix.  # noqa: E501
        :type: int
        """

        self._max_prefix_limit = max_prefix_limit

    @property
    def name(self):
        """Gets the name of this INeighborMaximumPrefix.  # noqa: E501


        :return: The name of this INeighborMaximumPrefix.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this INeighborMaximumPrefix.


        :param name: The name of this INeighborMaximumPrefix.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def warning_only(self):
        """Gets the warning_only of this INeighborMaximumPrefix.  # noqa: E501


        :return: The warning_only of this INeighborMaximumPrefix.  # noqa: E501
        :rtype: bool
        """
        return self._warning_only

    @warning_only.setter
    def warning_only(self, warning_only):
        """Sets the warning_only of this INeighborMaximumPrefix.


        :param warning_only: The warning_only of this INeighborMaximumPrefix.  # noqa: E501
        :type: bool
        """

        self._warning_only = warning_only

    @property
    def threshold_value(self):
        """Gets the threshold_value of this INeighborMaximumPrefix.  # noqa: E501


        :return: The threshold_value of this INeighborMaximumPrefix.  # noqa: E501
        :rtype: int
        """
        return self._threshold_value

    @threshold_value.setter
    def threshold_value(self, threshold_value):
        """Sets the threshold_value of this INeighborMaximumPrefix.


        :param threshold_value: The threshold_value of this INeighborMaximumPrefix.  # noqa: E501
        :type: int
        """

        self._threshold_value = threshold_value

    @property
    def links(self):
        """Gets the links of this INeighborMaximumPrefix.  # noqa: E501


        :return: The links of this INeighborMaximumPrefix.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this INeighborMaximumPrefix.


        :param links: The links of this INeighborMaximumPrefix.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this INeighborMaximumPrefix.  # noqa: E501


        :return: The id of this INeighborMaximumPrefix.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this INeighborMaximumPrefix.


        :param id: The id of this INeighborMaximumPrefix.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this INeighborMaximumPrefix.  # noqa: E501


        :return: The type of this INeighborMaximumPrefix.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this INeighborMaximumPrefix.


        :param type: The type of this INeighborMaximumPrefix.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def restart_interval(self):
        """Gets the restart_interval of this INeighborMaximumPrefix.  # noqa: E501


        :return: The restart_interval of this INeighborMaximumPrefix.  # noqa: E501
        :rtype: int
        """
        return self._restart_interval

    @restart_interval.setter
    def restart_interval(self, restart_interval):
        """Sets the restart_interval of this INeighborMaximumPrefix.


        :param restart_interval: The restart_interval of this INeighborMaximumPrefix.  # noqa: E501
        :type: int
        """

        self._restart_interval = restart_interval

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(INeighborMaximumPrefix, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, INeighborMaximumPrefix):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, INeighborMaximumPrefix):
            return True

        return self.to_dict() != other.to_dict()
