# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class INeighborTimers(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'keep_alive_interval': 'int',
        'minimum_hold_time': 'int',
        'name': 'str',
        'links': 'ILinks',
        'id': 'str',
        'type': 'str',
        'hold_time': 'int'
    }

    attribute_map = {
        'keep_alive_interval': 'keepAliveInterval',
        'minimum_hold_time': 'minimumHoldTime',
        'name': 'name',
        'links': 'links',
        'id': 'id',
        'type': 'type',
        'hold_time': 'holdTime'
    }

    def __init__(self, keep_alive_interval=None, minimum_hold_time=None, name=None, links=None, id=None, type=None, hold_time=None, _configuration=None):  # noqa: E501
        """INeighborTimers - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._keep_alive_interval = None
        self._minimum_hold_time = None
        self._name = None
        self._links = None
        self._id = None
        self._type = None
        self._hold_time = None
        self.discriminator = None

        if keep_alive_interval is not None:
            self.keep_alive_interval = keep_alive_interval
        if minimum_hold_time is not None:
            self.minimum_hold_time = minimum_hold_time
        if name is not None:
            self.name = name
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if hold_time is not None:
            self.hold_time = hold_time

    @property
    def keep_alive_interval(self):
        """Gets the keep_alive_interval of this INeighborTimers.  # noqa: E501


        :return: The keep_alive_interval of this INeighborTimers.  # noqa: E501
        :rtype: int
        """
        return self._keep_alive_interval

    @keep_alive_interval.setter
    def keep_alive_interval(self, keep_alive_interval):
        """Sets the keep_alive_interval of this INeighborTimers.


        :param keep_alive_interval: The keep_alive_interval of this INeighborTimers.  # noqa: E501
        :type: int
        """

        self._keep_alive_interval = keep_alive_interval

    @property
    def minimum_hold_time(self):
        """Gets the minimum_hold_time of this INeighborTimers.  # noqa: E501


        :return: The minimum_hold_time of this INeighborTimers.  # noqa: E501
        :rtype: int
        """
        return self._minimum_hold_time

    @minimum_hold_time.setter
    def minimum_hold_time(self, minimum_hold_time):
        """Sets the minimum_hold_time of this INeighborTimers.


        :param minimum_hold_time: The minimum_hold_time of this INeighborTimers.  # noqa: E501
        :type: int
        """

        self._minimum_hold_time = minimum_hold_time

    @property
    def name(self):
        """Gets the name of this INeighborTimers.  # noqa: E501


        :return: The name of this INeighborTimers.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this INeighborTimers.


        :param name: The name of this INeighborTimers.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def links(self):
        """Gets the links of this INeighborTimers.  # noqa: E501


        :return: The links of this INeighborTimers.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this INeighborTimers.


        :param links: The links of this INeighborTimers.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this INeighborTimers.  # noqa: E501


        :return: The id of this INeighborTimers.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this INeighborTimers.


        :param id: The id of this INeighborTimers.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this INeighborTimers.  # noqa: E501


        :return: The type of this INeighborTimers.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this INeighborTimers.


        :param type: The type of this INeighborTimers.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def hold_time(self):
        """Gets the hold_time of this INeighborTimers.  # noqa: E501


        :return: The hold_time of this INeighborTimers.  # noqa: E501
        :rtype: int
        """
        return self._hold_time

    @hold_time.setter
    def hold_time(self, hold_time):
        """Sets the hold_time of this INeighborTimers.


        :param hold_time: The hold_time of this INeighborTimers.  # noqa: E501
        :type: int
        """

        self._hold_time = hold_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(INeighborTimers, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, INeighborTimers):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, INeighborTimers):
            return True

        return self.to_dict() != other.to_dict()
