# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IOspfAdministrativeDistance(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'external': 'int',
        'inter_area': 'int',
        'intra_area': 'int'
    }

    attribute_map = {
        'external': 'external',
        'inter_area': 'interArea',
        'intra_area': 'intraArea'
    }

    def __init__(self, external=None, inter_area=None, intra_area=None, _configuration=None):  # noqa: E501
        """IOspfAdministrativeDistance - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._external = None
        self._inter_area = None
        self._intra_area = None
        self.discriminator = None

        if external is not None:
            self.external = external
        if inter_area is not None:
            self.inter_area = inter_area
        if intra_area is not None:
            self.intra_area = intra_area

    @property
    def external(self):
        """Gets the external of this IOspfAdministrativeDistance.  # noqa: E501


        :return: The external of this IOspfAdministrativeDistance.  # noqa: E501
        :rtype: int
        """
        return self._external

    @external.setter
    def external(self, external):
        """Sets the external of this IOspfAdministrativeDistance.


        :param external: The external of this IOspfAdministrativeDistance.  # noqa: E501
        :type: int
        """

        self._external = external

    @property
    def inter_area(self):
        """Gets the inter_area of this IOspfAdministrativeDistance.  # noqa: E501


        :return: The inter_area of this IOspfAdministrativeDistance.  # noqa: E501
        :rtype: int
        """
        return self._inter_area

    @inter_area.setter
    def inter_area(self, inter_area):
        """Sets the inter_area of this IOspfAdministrativeDistance.


        :param inter_area: The inter_area of this IOspfAdministrativeDistance.  # noqa: E501
        :type: int
        """

        self._inter_area = inter_area

    @property
    def intra_area(self):
        """Gets the intra_area of this IOspfAdministrativeDistance.  # noqa: E501


        :return: The intra_area of this IOspfAdministrativeDistance.  # noqa: E501
        :rtype: int
        """
        return self._intra_area

    @intra_area.setter
    def intra_area(self, intra_area):
        """Sets the intra_area of this IOspfAdministrativeDistance.


        :param intra_area: The intra_area of this IOspfAdministrativeDistance.  # noqa: E501
        :type: int
        """

        self._intra_area = intra_area

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IOspfAdministrativeDistance, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IOspfAdministrativeDistance):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IOspfAdministrativeDistance):
            return True

        return self.to_dict() != other.to_dict()
