# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IOspfAreaRanges(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'address_network': 'INetworkAddress',
        'advertise': 'bool'
    }

    attribute_map = {
        'address_network': 'addressNetwork',
        'advertise': 'advertise'
    }

    def __init__(self, address_network=None, advertise=None, _configuration=None):  # noqa: E501
        """IOspfAreaRanges - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._address_network = None
        self._advertise = None
        self.discriminator = None

        if address_network is not None:
            self.address_network = address_network
        if advertise is not None:
            self.advertise = advertise

    @property
    def address_network(self):
        """Gets the address_network of this IOspfAreaRanges.  # noqa: E501


        :return: The address_network of this IOspfAreaRanges.  # noqa: E501
        :rtype: INetworkAddress
        """
        return self._address_network

    @address_network.setter
    def address_network(self, address_network):
        """Sets the address_network of this IOspfAreaRanges.


        :param address_network: The address_network of this IOspfAreaRanges.  # noqa: E501
        :type: INetworkAddress
        """

        self._address_network = address_network

    @property
    def advertise(self):
        """Gets the advertise of this IOspfAreaRanges.  # noqa: E501


        :return: The advertise of this IOspfAreaRanges.  # noqa: E501
        :rtype: bool
        """
        return self._advertise

    @advertise.setter
    def advertise(self, advertise):
        """Sets the advertise of this IOspfAreaRanges.


        :param advertise: The advertise of this IOspfAreaRanges.  # noqa: E501
        :type: bool
        """

        self._advertise = advertise

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IOspfAreaRanges, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IOspfAreaRanges):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IOspfAreaRanges):
            return True

        return self.to_dict() != other.to_dict()
