# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IOspfAreaType(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'route_metric': 'IOspfRouteMetric',
        'name': 'str',
        'links': 'ILinks',
        'id': 'str',
        'no_summary': 'bool',
        'no_redistribution': 'bool',
        'type': 'str'
    }

    attribute_map = {
        'route_metric': 'routeMetric',
        'name': 'name',
        'links': 'links',
        'id': 'id',
        'no_summary': 'noSummary',
        'no_redistribution': 'noRedistribution',
        'type': 'type'
    }

    def __init__(self, route_metric=None, name=None, links=None, id=None, no_summary=None, no_redistribution=None, type=None, _configuration=None):  # noqa: E501
        """IOspfAreaType - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._route_metric = None
        self._name = None
        self._links = None
        self._id = None
        self._no_summary = None
        self._no_redistribution = None
        self._type = None
        self.discriminator = None

        if route_metric is not None:
            self.route_metric = route_metric
        if name is not None:
            self.name = name
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if no_summary is not None:
            self.no_summary = no_summary
        if no_redistribution is not None:
            self.no_redistribution = no_redistribution
        if type is not None:
            self.type = type

    @property
    def route_metric(self):
        """Gets the route_metric of this IOspfAreaType.  # noqa: E501


        :return: The route_metric of this IOspfAreaType.  # noqa: E501
        :rtype: IOspfRouteMetric
        """
        return self._route_metric

    @route_metric.setter
    def route_metric(self, route_metric):
        """Sets the route_metric of this IOspfAreaType.


        :param route_metric: The route_metric of this IOspfAreaType.  # noqa: E501
        :type: IOspfRouteMetric
        """

        self._route_metric = route_metric

    @property
    def name(self):
        """Gets the name of this IOspfAreaType.  # noqa: E501


        :return: The name of this IOspfAreaType.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this IOspfAreaType.


        :param name: The name of this IOspfAreaType.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def links(self):
        """Gets the links of this IOspfAreaType.  # noqa: E501


        :return: The links of this IOspfAreaType.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this IOspfAreaType.


        :param links: The links of this IOspfAreaType.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this IOspfAreaType.  # noqa: E501


        :return: The id of this IOspfAreaType.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this IOspfAreaType.


        :param id: The id of this IOspfAreaType.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def no_summary(self):
        """Gets the no_summary of this IOspfAreaType.  # noqa: E501


        :return: The no_summary of this IOspfAreaType.  # noqa: E501
        :rtype: bool
        """
        return self._no_summary

    @no_summary.setter
    def no_summary(self, no_summary):
        """Sets the no_summary of this IOspfAreaType.


        :param no_summary: The no_summary of this IOspfAreaType.  # noqa: E501
        :type: bool
        """

        self._no_summary = no_summary

    @property
    def no_redistribution(self):
        """Gets the no_redistribution of this IOspfAreaType.  # noqa: E501


        :return: The no_redistribution of this IOspfAreaType.  # noqa: E501
        :rtype: bool
        """
        return self._no_redistribution

    @no_redistribution.setter
    def no_redistribution(self, no_redistribution):
        """Sets the no_redistribution of this IOspfAreaType.


        :param no_redistribution: The no_redistribution of this IOspfAreaType.  # noqa: E501
        :type: bool
        """

        self._no_redistribution = no_redistribution

    @property
    def type(self):
        """Gets the type of this IOspfAreaType.  # noqa: E501


        :return: The type of this IOspfAreaType.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this IOspfAreaType.


        :param type: The type of this IOspfAreaType.  # noqa: E501
        :type: str
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IOspfAreaType, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IOspfAreaType):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IOspfAreaType):
            return True

        return self.to_dict() != other.to_dict()
