# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IOspfFilterList(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'prefix_list': 'IReference',
        'filter_direction': 'str'
    }

    attribute_map = {
        'prefix_list': 'prefixList',
        'filter_direction': 'filterDirection'
    }

    def __init__(self, prefix_list=None, filter_direction=None, _configuration=None):  # noqa: E501
        """IOspfFilterList - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._prefix_list = None
        self._filter_direction = None
        self.discriminator = None

        if prefix_list is not None:
            self.prefix_list = prefix_list
        if filter_direction is not None:
            self.filter_direction = filter_direction

    @property
    def prefix_list(self):
        """Gets the prefix_list of this IOspfFilterList.  # noqa: E501


        :return: The prefix_list of this IOspfFilterList.  # noqa: E501
        :rtype: IReference
        """
        return self._prefix_list

    @prefix_list.setter
    def prefix_list(self, prefix_list):
        """Sets the prefix_list of this IOspfFilterList.


        :param prefix_list: The prefix_list of this IOspfFilterList.  # noqa: E501
        :type: IReference
        """

        self._prefix_list = prefix_list

    @property
    def filter_direction(self):
        """Gets the filter_direction of this IOspfFilterList.  # noqa: E501


        :return: The filter_direction of this IOspfFilterList.  # noqa: E501
        :rtype: str
        """
        return self._filter_direction

    @filter_direction.setter
    def filter_direction(self, filter_direction):
        """Sets the filter_direction of this IOspfFilterList.


        :param filter_direction: The filter_direction of this IOspfFilterList.  # noqa: E501
        :type: str
        """
        allowed_values = ["IN", "OUT"]  # noqa: E501
        if (self._configuration.client_side_validation and
                filter_direction not in allowed_values):
            raise ValueError(
                "Invalid value for `filter_direction` ({0}), must be one of {1}"  # noqa: E501
                .format(filter_direction, allowed_values)
            )

        self._filter_direction = filter_direction

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IOspfFilterList, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IOspfFilterList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IOspfFilterList):
            return True

        return self.to_dict() != other.to_dict()
