# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IOspfHelloMultiplierMechanism(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'hello_multiplier': 'int',
        'neighbor_detection_type': 'str'
    }

    attribute_map = {
        'hello_multiplier': 'helloMultiplier',
        'neighbor_detection_type': 'neighborDetectionType'
    }

    def __init__(self, hello_multiplier=None, neighbor_detection_type=None, _configuration=None):  # noqa: E501
        """IOspfHelloMultiplierMechanism - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._hello_multiplier = None
        self._neighbor_detection_type = None
        self.discriminator = None

        if hello_multiplier is not None:
            self.hello_multiplier = hello_multiplier
        if neighbor_detection_type is not None:
            self.neighbor_detection_type = neighbor_detection_type

    @property
    def hello_multiplier(self):
        """Gets the hello_multiplier of this IOspfHelloMultiplierMechanism.  # noqa: E501


        :return: The hello_multiplier of this IOspfHelloMultiplierMechanism.  # noqa: E501
        :rtype: int
        """
        return self._hello_multiplier

    @hello_multiplier.setter
    def hello_multiplier(self, hello_multiplier):
        """Sets the hello_multiplier of this IOspfHelloMultiplierMechanism.


        :param hello_multiplier: The hello_multiplier of this IOspfHelloMultiplierMechanism.  # noqa: E501
        :type: int
        """

        self._hello_multiplier = hello_multiplier

    @property
    def neighbor_detection_type(self):
        """Gets the neighbor_detection_type of this IOspfHelloMultiplierMechanism.  # noqa: E501


        :return: The neighbor_detection_type of this IOspfHelloMultiplierMechanism.  # noqa: E501
        :rtype: str
        """
        return self._neighbor_detection_type

    @neighbor_detection_type.setter
    def neighbor_detection_type(self, neighbor_detection_type):
        """Sets the neighbor_detection_type of this IOspfHelloMultiplierMechanism.


        :param neighbor_detection_type: The neighbor_detection_type of this IOspfHelloMultiplierMechanism.  # noqa: E501
        :type: str
        """

        self._neighbor_detection_type = neighbor_detection_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IOspfHelloMultiplierMechanism, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IOspfHelloMultiplierMechanism):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IOspfHelloMultiplierMechanism):
            return True

        return self.to_dict() != other.to_dict()
