# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IOspfInterval(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'hello_interval': 'IOspfDeadIntervalMechanism',
        'hello_multiplier': 'IOspfHelloMultiplierMechanism'
    }

    attribute_map = {
        'hello_interval': 'helloInterval',
        'hello_multiplier': 'helloMultiplier'
    }

    def __init__(self, hello_interval=None, hello_multiplier=None, _configuration=None):  # noqa: E501
        """IOspfInterval - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._hello_interval = None
        self._hello_multiplier = None
        self.discriminator = None

        if hello_interval is not None:
            self.hello_interval = hello_interval
        if hello_multiplier is not None:
            self.hello_multiplier = hello_multiplier

    @property
    def hello_interval(self):
        """Gets the hello_interval of this IOspfInterval.  # noqa: E501


        :return: The hello_interval of this IOspfInterval.  # noqa: E501
        :rtype: IOspfDeadIntervalMechanism
        """
        return self._hello_interval

    @hello_interval.setter
    def hello_interval(self, hello_interval):
        """Sets the hello_interval of this IOspfInterval.


        :param hello_interval: The hello_interval of this IOspfInterval.  # noqa: E501
        :type: IOspfDeadIntervalMechanism
        """

        self._hello_interval = hello_interval

    @property
    def hello_multiplier(self):
        """Gets the hello_multiplier of this IOspfInterval.  # noqa: E501


        :return: The hello_multiplier of this IOspfInterval.  # noqa: E501
        :rtype: IOspfHelloMultiplierMechanism
        """
        return self._hello_multiplier

    @hello_multiplier.setter
    def hello_multiplier(self, hello_multiplier):
        """Sets the hello_multiplier of this IOspfInterval.


        :param hello_multiplier: The hello_multiplier of this IOspfInterval.  # noqa: E501
        :type: IOspfHelloMultiplierMechanism
        """

        self._hello_multiplier = hello_multiplier

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IOspfInterval, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IOspfInterval):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IOspfInterval):
            return True

        return self.to_dict() != other.to_dict()
