# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IOspfMD5Auth(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'md5_key': 'str',
        'auth_type': 'str',
        'md5_key_id': 'int'
    }

    attribute_map = {
        'md5_key': 'md5Key',
        'auth_type': 'authType',
        'md5_key_id': 'md5KeyId'
    }

    def __init__(self, md5_key=None, auth_type=None, md5_key_id=None, _configuration=None):  # noqa: E501
        """IOspfMD5Auth - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._md5_key = None
        self._auth_type = None
        self._md5_key_id = None
        self.discriminator = None

        if md5_key is not None:
            self.md5_key = md5_key
        if auth_type is not None:
            self.auth_type = auth_type
        if md5_key_id is not None:
            self.md5_key_id = md5_key_id

    @property
    def md5_key(self):
        """Gets the md5_key of this IOspfMD5Auth.  # noqa: E501


        :return: The md5_key of this IOspfMD5Auth.  # noqa: E501
        :rtype: str
        """
        return self._md5_key

    @md5_key.setter
    def md5_key(self, md5_key):
        """Sets the md5_key of this IOspfMD5Auth.


        :param md5_key: The md5_key of this IOspfMD5Auth.  # noqa: E501
        :type: str
        """

        self._md5_key = md5_key

    @property
    def auth_type(self):
        """Gets the auth_type of this IOspfMD5Auth.  # noqa: E501


        :return: The auth_type of this IOspfMD5Auth.  # noqa: E501
        :rtype: str
        """
        return self._auth_type

    @auth_type.setter
    def auth_type(self, auth_type):
        """Sets the auth_type of this IOspfMD5Auth.


        :param auth_type: The auth_type of this IOspfMD5Auth.  # noqa: E501
        :type: str
        """

        self._auth_type = auth_type

    @property
    def md5_key_id(self):
        """Gets the md5_key_id of this IOspfMD5Auth.  # noqa: E501


        :return: The md5_key_id of this IOspfMD5Auth.  # noqa: E501
        :rtype: int
        """
        return self._md5_key_id

    @md5_key_id.setter
    def md5_key_id(self, md5_key_id):
        """Sets the md5_key_id of this IOspfMD5Auth.


        :param md5_key_id: The md5_key_id of this IOspfMD5Auth.  # noqa: E501
        :type: int
        """

        self._md5_key_id = md5_key_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IOspfMD5Auth, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IOspfMD5Auth):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IOspfMD5Auth):
            return True

        return self.to_dict() != other.to_dict()
