# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IOspfv3InterfaceConfiguration(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'retransmit_interval': 'int',
        'dead_interval': 'int',
        'flood_reduction': 'bool',
        'ignore_mtu_mismatch': 'bool',
        'hello_interval': 'int',
        'filter_outgoing_lsa': 'bool',
        'priority': 'int',
        'ptp_non_broadcast': 'bool',
        'transmit_delay': 'int',
        'packet_cost': 'int'
    }

    attribute_map = {
        'retransmit_interval': 'retransmitInterval',
        'dead_interval': 'deadInterval',
        'flood_reduction': 'floodReduction',
        'ignore_mtu_mismatch': 'ignoreMtuMismatch',
        'hello_interval': 'helloInterval',
        'filter_outgoing_lsa': 'filterOutgoingLSA',
        'priority': 'priority',
        'ptp_non_broadcast': 'ptpNonBroadcast',
        'transmit_delay': 'transmitDelay',
        'packet_cost': 'packetCost'
    }

    def __init__(self, retransmit_interval=None, dead_interval=None, flood_reduction=None, ignore_mtu_mismatch=None, hello_interval=None, filter_outgoing_lsa=None, priority=None, ptp_non_broadcast=None, transmit_delay=None, packet_cost=None, _configuration=None):  # noqa: E501
        """IOspfv3InterfaceConfiguration - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._retransmit_interval = None
        self._dead_interval = None
        self._flood_reduction = None
        self._ignore_mtu_mismatch = None
        self._hello_interval = None
        self._filter_outgoing_lsa = None
        self._priority = None
        self._ptp_non_broadcast = None
        self._transmit_delay = None
        self._packet_cost = None
        self.discriminator = None

        if retransmit_interval is not None:
            self.retransmit_interval = retransmit_interval
        if dead_interval is not None:
            self.dead_interval = dead_interval
        if flood_reduction is not None:
            self.flood_reduction = flood_reduction
        if ignore_mtu_mismatch is not None:
            self.ignore_mtu_mismatch = ignore_mtu_mismatch
        if hello_interval is not None:
            self.hello_interval = hello_interval
        if filter_outgoing_lsa is not None:
            self.filter_outgoing_lsa = filter_outgoing_lsa
        if priority is not None:
            self.priority = priority
        if ptp_non_broadcast is not None:
            self.ptp_non_broadcast = ptp_non_broadcast
        if transmit_delay is not None:
            self.transmit_delay = transmit_delay
        if packet_cost is not None:
            self.packet_cost = packet_cost

    @property
    def retransmit_interval(self):
        """Gets the retransmit_interval of this IOspfv3InterfaceConfiguration.  # noqa: E501


        :return: The retransmit_interval of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._retransmit_interval

    @retransmit_interval.setter
    def retransmit_interval(self, retransmit_interval):
        """Sets the retransmit_interval of this IOspfv3InterfaceConfiguration.


        :param retransmit_interval: The retransmit_interval of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :type: int
        """

        self._retransmit_interval = retransmit_interval

    @property
    def dead_interval(self):
        """Gets the dead_interval of this IOspfv3InterfaceConfiguration.  # noqa: E501


        :return: The dead_interval of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._dead_interval

    @dead_interval.setter
    def dead_interval(self, dead_interval):
        """Sets the dead_interval of this IOspfv3InterfaceConfiguration.


        :param dead_interval: The dead_interval of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :type: int
        """

        self._dead_interval = dead_interval

    @property
    def flood_reduction(self):
        """Gets the flood_reduction of this IOspfv3InterfaceConfiguration.  # noqa: E501


        :return: The flood_reduction of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :rtype: bool
        """
        return self._flood_reduction

    @flood_reduction.setter
    def flood_reduction(self, flood_reduction):
        """Sets the flood_reduction of this IOspfv3InterfaceConfiguration.


        :param flood_reduction: The flood_reduction of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :type: bool
        """

        self._flood_reduction = flood_reduction

    @property
    def ignore_mtu_mismatch(self):
        """Gets the ignore_mtu_mismatch of this IOspfv3InterfaceConfiguration.  # noqa: E501


        :return: The ignore_mtu_mismatch of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :rtype: bool
        """
        return self._ignore_mtu_mismatch

    @ignore_mtu_mismatch.setter
    def ignore_mtu_mismatch(self, ignore_mtu_mismatch):
        """Sets the ignore_mtu_mismatch of this IOspfv3InterfaceConfiguration.


        :param ignore_mtu_mismatch: The ignore_mtu_mismatch of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :type: bool
        """

        self._ignore_mtu_mismatch = ignore_mtu_mismatch

    @property
    def hello_interval(self):
        """Gets the hello_interval of this IOspfv3InterfaceConfiguration.  # noqa: E501


        :return: The hello_interval of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._hello_interval

    @hello_interval.setter
    def hello_interval(self, hello_interval):
        """Sets the hello_interval of this IOspfv3InterfaceConfiguration.


        :param hello_interval: The hello_interval of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :type: int
        """

        self._hello_interval = hello_interval

    @property
    def filter_outgoing_lsa(self):
        """Gets the filter_outgoing_lsa of this IOspfv3InterfaceConfiguration.  # noqa: E501


        :return: The filter_outgoing_lsa of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :rtype: bool
        """
        return self._filter_outgoing_lsa

    @filter_outgoing_lsa.setter
    def filter_outgoing_lsa(self, filter_outgoing_lsa):
        """Sets the filter_outgoing_lsa of this IOspfv3InterfaceConfiguration.


        :param filter_outgoing_lsa: The filter_outgoing_lsa of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :type: bool
        """

        self._filter_outgoing_lsa = filter_outgoing_lsa

    @property
    def priority(self):
        """Gets the priority of this IOspfv3InterfaceConfiguration.  # noqa: E501


        :return: The priority of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._priority

    @priority.setter
    def priority(self, priority):
        """Sets the priority of this IOspfv3InterfaceConfiguration.


        :param priority: The priority of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :type: int
        """

        self._priority = priority

    @property
    def ptp_non_broadcast(self):
        """Gets the ptp_non_broadcast of this IOspfv3InterfaceConfiguration.  # noqa: E501


        :return: The ptp_non_broadcast of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :rtype: bool
        """
        return self._ptp_non_broadcast

    @ptp_non_broadcast.setter
    def ptp_non_broadcast(self, ptp_non_broadcast):
        """Sets the ptp_non_broadcast of this IOspfv3InterfaceConfiguration.


        :param ptp_non_broadcast: The ptp_non_broadcast of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :type: bool
        """

        self._ptp_non_broadcast = ptp_non_broadcast

    @property
    def transmit_delay(self):
        """Gets the transmit_delay of this IOspfv3InterfaceConfiguration.  # noqa: E501


        :return: The transmit_delay of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._transmit_delay

    @transmit_delay.setter
    def transmit_delay(self, transmit_delay):
        """Sets the transmit_delay of this IOspfv3InterfaceConfiguration.


        :param transmit_delay: The transmit_delay of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :type: int
        """

        self._transmit_delay = transmit_delay

    @property
    def packet_cost(self):
        """Gets the packet_cost of this IOspfv3InterfaceConfiguration.  # noqa: E501


        :return: The packet_cost of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._packet_cost

    @packet_cost.setter
    def packet_cost(self, packet_cost):
        """Sets the packet_cost of this IOspfv3InterfaceConfiguration.


        :param packet_cost: The packet_cost of this IOspfv3InterfaceConfiguration.  # noqa: E501
        :type: int
        """

        self._packet_cost = packet_cost

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IOspfv3InterfaceConfiguration, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IOspfv3InterfaceConfiguration):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IOspfv3InterfaceConfiguration):
            return True

        return self.to_dict() != other.to_dict()
