# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IOspfv3NeighborConfiguration(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'link_local_address': 'str',
        'properties': 'IOspfv3NeighborProperties'
    }

    attribute_map = {
        'link_local_address': 'linkLocalAddress',
        'properties': 'properties'
    }

    def __init__(self, link_local_address=None, properties=None, _configuration=None):  # noqa: E501
        """IOspfv3NeighborConfiguration - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._link_local_address = None
        self._properties = None
        self.discriminator = None

        self.link_local_address = link_local_address
        self.properties = properties

    @property
    def link_local_address(self):
        """Gets the link_local_address of this IOspfv3NeighborConfiguration.  # noqa: E501


        :return: The link_local_address of this IOspfv3NeighborConfiguration.  # noqa: E501
        :rtype: str
        """
        return self._link_local_address

    @link_local_address.setter
    def link_local_address(self, link_local_address):
        """Sets the link_local_address of this IOspfv3NeighborConfiguration.


        :param link_local_address: The link_local_address of this IOspfv3NeighborConfiguration.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and link_local_address is None:
            raise ValueError("Invalid value for `link_local_address`, must not be `None`")  # noqa: E501

        self._link_local_address = link_local_address

    @property
    def properties(self):
        """Gets the properties of this IOspfv3NeighborConfiguration.  # noqa: E501


        :return: The properties of this IOspfv3NeighborConfiguration.  # noqa: E501
        :rtype: IOspfv3NeighborProperties
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this IOspfv3NeighborConfiguration.


        :param properties: The properties of this IOspfv3NeighborConfiguration.  # noqa: E501
        :type: IOspfv3NeighborProperties
        """
        if self._configuration.client_side_validation and properties is None:
            raise ValueError("Invalid value for `properties`, must not be `None`")  # noqa: E501

        self._properties = properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IOspfv3NeighborConfiguration, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IOspfv3NeighborConfiguration):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IOspfv3NeighborConfiguration):
            return True

        return self.to_dict() != other.to_dict()
