# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IOspfv3ProcessModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ignore_lsa_mospf': 'bool',
        'timers': 'IOspfv3Timers',
        'metadata': 'IMetadata',
        'log_adjacency_changes': 'IOspfv3LogAdjacencyChanges',
        'description': 'str',
        'passive_interfaces': 'list[IFTDInterface]',
        'type': 'str',
        'version': 'str',
        'nsf_graceful_restart': 'IOspfv3NsfGracefulRestart',
        'default_information_originate': 'IOspfv3DefaultInfoOriginate',
        'router_id': 'str',
        'name': 'str',
        'links': 'ILinks',
        'id': 'str',
        'administrative_distance': 'IOspfAdministrativeDistance'
    }

    attribute_map = {
        'ignore_lsa_mospf': 'ignoreLsaMospf',
        'timers': 'timers',
        'metadata': 'metadata',
        'log_adjacency_changes': 'logAdjacencyChanges',
        'description': 'description',
        'passive_interfaces': 'passiveInterfaces',
        'type': 'type',
        'version': 'version',
        'nsf_graceful_restart': 'nsfGracefulRestart',
        'default_information_originate': 'defaultInformationOriginate',
        'router_id': 'routerId',
        'name': 'name',
        'links': 'links',
        'id': 'id',
        'administrative_distance': 'administrativeDistance'
    }

    def __init__(self, ignore_lsa_mospf=None, timers=None, metadata=None, log_adjacency_changes=None, description=None, passive_interfaces=None, type=None, version=None, nsf_graceful_restart=None, default_information_originate=None, router_id=None, name=None, links=None, id=None, administrative_distance=None, _configuration=None):  # noqa: E501
        """IOspfv3ProcessModel - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._ignore_lsa_mospf = None
        self._timers = None
        self._metadata = None
        self._log_adjacency_changes = None
        self._description = None
        self._passive_interfaces = None
        self._type = None
        self._version = None
        self._nsf_graceful_restart = None
        self._default_information_originate = None
        self._router_id = None
        self._name = None
        self._links = None
        self._id = None
        self._administrative_distance = None
        self.discriminator = None

        if ignore_lsa_mospf is not None:
            self.ignore_lsa_mospf = ignore_lsa_mospf
        if timers is not None:
            self.timers = timers
        if metadata is not None:
            self.metadata = metadata
        if log_adjacency_changes is not None:
            self.log_adjacency_changes = log_adjacency_changes
        if description is not None:
            self.description = description
        if passive_interfaces is not None:
            self.passive_interfaces = passive_interfaces
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version
        if nsf_graceful_restart is not None:
            self.nsf_graceful_restart = nsf_graceful_restart
        if default_information_originate is not None:
            self.default_information_originate = default_information_originate
        if router_id is not None:
            self.router_id = router_id
        if name is not None:
            self.name = name
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if administrative_distance is not None:
            self.administrative_distance = administrative_distance

    @property
    def ignore_lsa_mospf(self):
        """Gets the ignore_lsa_mospf of this IOspfv3ProcessModel.  # noqa: E501


        :return: The ignore_lsa_mospf of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: bool
        """
        return self._ignore_lsa_mospf

    @ignore_lsa_mospf.setter
    def ignore_lsa_mospf(self, ignore_lsa_mospf):
        """Sets the ignore_lsa_mospf of this IOspfv3ProcessModel.


        :param ignore_lsa_mospf: The ignore_lsa_mospf of this IOspfv3ProcessModel.  # noqa: E501
        :type: bool
        """

        self._ignore_lsa_mospf = ignore_lsa_mospf

    @property
    def timers(self):
        """Gets the timers of this IOspfv3ProcessModel.  # noqa: E501


        :return: The timers of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: IOspfv3Timers
        """
        return self._timers

    @timers.setter
    def timers(self, timers):
        """Sets the timers of this IOspfv3ProcessModel.


        :param timers: The timers of this IOspfv3ProcessModel.  # noqa: E501
        :type: IOspfv3Timers
        """

        self._timers = timers

    @property
    def metadata(self):
        """Gets the metadata of this IOspfv3ProcessModel.  # noqa: E501


        :return: The metadata of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: IMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this IOspfv3ProcessModel.


        :param metadata: The metadata of this IOspfv3ProcessModel.  # noqa: E501
        :type: IMetadata
        """

        self._metadata = metadata

    @property
    def log_adjacency_changes(self):
        """Gets the log_adjacency_changes of this IOspfv3ProcessModel.  # noqa: E501


        :return: The log_adjacency_changes of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: IOspfv3LogAdjacencyChanges
        """
        return self._log_adjacency_changes

    @log_adjacency_changes.setter
    def log_adjacency_changes(self, log_adjacency_changes):
        """Sets the log_adjacency_changes of this IOspfv3ProcessModel.


        :param log_adjacency_changes: The log_adjacency_changes of this IOspfv3ProcessModel.  # noqa: E501
        :type: IOspfv3LogAdjacencyChanges
        """

        self._log_adjacency_changes = log_adjacency_changes

    @property
    def description(self):
        """Gets the description of this IOspfv3ProcessModel.  # noqa: E501


        :return: The description of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this IOspfv3ProcessModel.


        :param description: The description of this IOspfv3ProcessModel.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def passive_interfaces(self):
        """Gets the passive_interfaces of this IOspfv3ProcessModel.  # noqa: E501


        :return: The passive_interfaces of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: list[IFTDInterface]
        """
        return self._passive_interfaces

    @passive_interfaces.setter
    def passive_interfaces(self, passive_interfaces):
        """Sets the passive_interfaces of this IOspfv3ProcessModel.


        :param passive_interfaces: The passive_interfaces of this IOspfv3ProcessModel.  # noqa: E501
        :type: list[IFTDInterface]
        """

        self._passive_interfaces = passive_interfaces

    @property
    def type(self):
        """Gets the type of this IOspfv3ProcessModel.  # noqa: E501


        :return: The type of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this IOspfv3ProcessModel.


        :param type: The type of this IOspfv3ProcessModel.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this IOspfv3ProcessModel.  # noqa: E501


        :return: The version of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this IOspfv3ProcessModel.


        :param version: The version of this IOspfv3ProcessModel.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def nsf_graceful_restart(self):
        """Gets the nsf_graceful_restart of this IOspfv3ProcessModel.  # noqa: E501


        :return: The nsf_graceful_restart of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: IOspfv3NsfGracefulRestart
        """
        return self._nsf_graceful_restart

    @nsf_graceful_restart.setter
    def nsf_graceful_restart(self, nsf_graceful_restart):
        """Sets the nsf_graceful_restart of this IOspfv3ProcessModel.


        :param nsf_graceful_restart: The nsf_graceful_restart of this IOspfv3ProcessModel.  # noqa: E501
        :type: IOspfv3NsfGracefulRestart
        """

        self._nsf_graceful_restart = nsf_graceful_restart

    @property
    def default_information_originate(self):
        """Gets the default_information_originate of this IOspfv3ProcessModel.  # noqa: E501


        :return: The default_information_originate of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: IOspfv3DefaultInfoOriginate
        """
        return self._default_information_originate

    @default_information_originate.setter
    def default_information_originate(self, default_information_originate):
        """Sets the default_information_originate of this IOspfv3ProcessModel.


        :param default_information_originate: The default_information_originate of this IOspfv3ProcessModel.  # noqa: E501
        :type: IOspfv3DefaultInfoOriginate
        """

        self._default_information_originate = default_information_originate

    @property
    def router_id(self):
        """Gets the router_id of this IOspfv3ProcessModel.  # noqa: E501


        :return: The router_id of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: str
        """
        return self._router_id

    @router_id.setter
    def router_id(self, router_id):
        """Sets the router_id of this IOspfv3ProcessModel.


        :param router_id: The router_id of this IOspfv3ProcessModel.  # noqa: E501
        :type: str
        """

        self._router_id = router_id

    @property
    def name(self):
        """Gets the name of this IOspfv3ProcessModel.  # noqa: E501


        :return: The name of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this IOspfv3ProcessModel.


        :param name: The name of this IOspfv3ProcessModel.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def links(self):
        """Gets the links of this IOspfv3ProcessModel.  # noqa: E501


        :return: The links of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this IOspfv3ProcessModel.


        :param links: The links of this IOspfv3ProcessModel.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this IOspfv3ProcessModel.  # noqa: E501


        :return: The id of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this IOspfv3ProcessModel.


        :param id: The id of this IOspfv3ProcessModel.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def administrative_distance(self):
        """Gets the administrative_distance of this IOspfv3ProcessModel.  # noqa: E501


        :return: The administrative_distance of this IOspfv3ProcessModel.  # noqa: E501
        :rtype: IOspfAdministrativeDistance
        """
        return self._administrative_distance

    @administrative_distance.setter
    def administrative_distance(self, administrative_distance):
        """Sets the administrative_distance of this IOspfv3ProcessModel.


        :param administrative_distance: The administrative_distance of this IOspfv3ProcessModel.  # noqa: E501
        :type: IOspfAdministrativeDistance
        """

        self._administrative_distance = administrative_distance

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IOspfv3ProcessModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IOspfv3ProcessModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IOspfv3ProcessModel):
            return True

        return self.to_dict() != other.to_dict()
