# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IPoeConfig(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'consumption_wattage': 'int',
        'state': 'bool'
    }

    attribute_map = {
        'consumption_wattage': 'consumptionWattage',
        'state': 'state'
    }

    def __init__(self, consumption_wattage=None, state=None, _configuration=None):  # noqa: E501
        """IPoeConfig - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._consumption_wattage = None
        self._state = None
        self.discriminator = None

        if consumption_wattage is not None:
            self.consumption_wattage = consumption_wattage
        if state is not None:
            self.state = state

    @property
    def consumption_wattage(self):
        """Gets the consumption_wattage of this IPoeConfig.  # noqa: E501


        :return: The consumption_wattage of this IPoeConfig.  # noqa: E501
        :rtype: int
        """
        return self._consumption_wattage

    @consumption_wattage.setter
    def consumption_wattage(self, consumption_wattage):
        """Sets the consumption_wattage of this IPoeConfig.


        :param consumption_wattage: The consumption_wattage of this IPoeConfig.  # noqa: E501
        :type: int
        """

        self._consumption_wattage = consumption_wattage

    @property
    def state(self):
        """Gets the state of this IPoeConfig.  # noqa: E501


        :return: The state of this IPoeConfig.  # noqa: E501
        :rtype: bool
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this IPoeConfig.


        :param state: The state of this IPoeConfig.  # noqa: E501
        :type: bool
        """

        self._state = state

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IPoeConfig, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IPoeConfig):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IPoeConfig):
            return True

        return self.to_dict() != other.to_dict()
