# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IRollbackDeviceListEntry(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'device_list': 'list[str]',
        'deployment_job_id': 'str'
    }

    attribute_map = {
        'device_list': 'deviceList',
        'deployment_job_id': 'deploymentJobId'
    }

    def __init__(self, device_list=None, deployment_job_id=None, _configuration=None):  # noqa: E501
        """IRollbackDeviceListEntry - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._device_list = None
        self._deployment_job_id = None
        self.discriminator = None

        if device_list is not None:
            self.device_list = device_list
        if deployment_job_id is not None:
            self.deployment_job_id = deployment_job_id

    @property
    def device_list(self):
        """Gets the device_list of this IRollbackDeviceListEntry.  # noqa: E501

        List of device UUIDs which are part of deployment job id.  # noqa: E501

        :return: The device_list of this IRollbackDeviceListEntry.  # noqa: E501
        :rtype: list[str]
        """
        return self._device_list

    @device_list.setter
    def device_list(self, device_list):
        """Sets the device_list of this IRollbackDeviceListEntry.

        List of device UUIDs which are part of deployment job id.  # noqa: E501

        :param device_list: The device_list of this IRollbackDeviceListEntry.  # noqa: E501
        :type: list[str]
        """

        self._device_list = device_list

    @property
    def deployment_job_id(self):
        """Gets the deployment_job_id of this IRollbackDeviceListEntry.  # noqa: E501

        Deployment job UUID.  # noqa: E501

        :return: The deployment_job_id of this IRollbackDeviceListEntry.  # noqa: E501
        :rtype: str
        """
        return self._deployment_job_id

    @deployment_job_id.setter
    def deployment_job_id(self, deployment_job_id):
        """Sets the deployment_job_id of this IRollbackDeviceListEntry.

        Deployment job UUID.  # noqa: E501

        :param deployment_job_id: The deployment_job_id of this IRollbackDeviceListEntry.  # noqa: E501
        :type: str
        """

        self._deployment_job_id = deployment_job_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IRollbackDeviceListEntry, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IRollbackDeviceListEntry):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IRollbackDeviceListEntry):
            return True

        return self.to_dict() != other.to_dict()
