# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class ISelectedPoliciesforDevices(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'selected_policies': 'list[str]',
        'device_uuid': 'str'
    }

    attribute_map = {
        'selected_policies': 'selectedPolicies',
        'device_uuid': 'deviceUUID'
    }

    def __init__(self, selected_policies=None, device_uuid=None, _configuration=None):  # noqa: E501
        """ISelectedPoliciesforDevices - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._selected_policies = None
        self._device_uuid = None
        self.discriminator = None

        if selected_policies is not None:
            self.selected_policies = selected_policies
        if device_uuid is not None:
            self.device_uuid = device_uuid

    @property
    def selected_policies(self):
        """Gets the selected_policies of this ISelectedPoliciesforDevices.  # noqa: E501

        List of Policy Types which have to be selectively deployed. Note: mandatoryDeployablePolicies should not be included in this list.  # noqa: E501

        :return: The selected_policies of this ISelectedPoliciesforDevices.  # noqa: E501
        :rtype: list[str]
        """
        return self._selected_policies

    @selected_policies.setter
    def selected_policies(self, selected_policies):
        """Sets the selected_policies of this ISelectedPoliciesforDevices.

        List of Policy Types which have to be selectively deployed. Note: mandatoryDeployablePolicies should not be included in this list.  # noqa: E501

        :param selected_policies: The selected_policies of this ISelectedPoliciesforDevices.  # noqa: E501
        :type: list[str]
        """

        self._selected_policies = selected_policies

    @property
    def device_uuid(self):
        """Gets the device_uuid of this ISelectedPoliciesforDevices.  # noqa: E501

        Corresponding device UUID for which the selection is mentioned.  # noqa: E501

        :return: The device_uuid of this ISelectedPoliciesforDevices.  # noqa: E501
        :rtype: str
        """
        return self._device_uuid

    @device_uuid.setter
    def device_uuid(self, device_uuid):
        """Sets the device_uuid of this ISelectedPoliciesforDevices.

        Corresponding device UUID for which the selection is mentioned.  # noqa: E501

        :param device_uuid: The device_uuid of this ISelectedPoliciesforDevices.  # noqa: E501
        :type: str
        """

        self._device_uuid = device_uuid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ISelectedPoliciesforDevices, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ISelectedPoliciesforDevices):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ISelectedPoliciesforDevices):
            return True

        return self.to_dict() != other.to_dict()
