# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class ITimeRangeModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'effective_end_date_time': 'str',
        'effective_start_date_time': 'str',
        'name': 'str',
        'links': 'ILinks',
        'id': 'str',
        'type': 'str',
        'recurrence_list': 'list[IRecurrence]'
    }

    attribute_map = {
        'effective_end_date_time': 'effectiveEndDateTime',
        'effective_start_date_time': 'effectiveStartDateTime',
        'name': 'name',
        'links': 'links',
        'id': 'id',
        'type': 'type',
        'recurrence_list': 'recurrenceList'
    }

    def __init__(self, effective_end_date_time=None, effective_start_date_time=None, name=None, links=None, id=None, type=None, recurrence_list=None, _configuration=None):  # noqa: E501
        """ITimeRangeModel - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._effective_end_date_time = None
        self._effective_start_date_time = None
        self._name = None
        self._links = None
        self._id = None
        self._type = None
        self._recurrence_list = None
        self.discriminator = None

        if effective_end_date_time is not None:
            self.effective_end_date_time = effective_end_date_time
        if effective_start_date_time is not None:
            self.effective_start_date_time = effective_start_date_time
        self.name = name
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if recurrence_list is not None:
            self.recurrence_list = recurrence_list

    @property
    def effective_end_date_time(self):
        """Gets the effective_end_date_time of this ITimeRangeModel.  # noqa: E501


        :return: The effective_end_date_time of this ITimeRangeModel.  # noqa: E501
        :rtype: str
        """
        return self._effective_end_date_time

    @effective_end_date_time.setter
    def effective_end_date_time(self, effective_end_date_time):
        """Sets the effective_end_date_time of this ITimeRangeModel.


        :param effective_end_date_time: The effective_end_date_time of this ITimeRangeModel.  # noqa: E501
        :type: str
        """

        self._effective_end_date_time = effective_end_date_time

    @property
    def effective_start_date_time(self):
        """Gets the effective_start_date_time of this ITimeRangeModel.  # noqa: E501


        :return: The effective_start_date_time of this ITimeRangeModel.  # noqa: E501
        :rtype: str
        """
        return self._effective_start_date_time

    @effective_start_date_time.setter
    def effective_start_date_time(self, effective_start_date_time):
        """Sets the effective_start_date_time of this ITimeRangeModel.


        :param effective_start_date_time: The effective_start_date_time of this ITimeRangeModel.  # noqa: E501
        :type: str
        """

        self._effective_start_date_time = effective_start_date_time

    @property
    def name(self):
        """Gets the name of this ITimeRangeModel.  # noqa: E501


        :return: The name of this ITimeRangeModel.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ITimeRangeModel.


        :param name: The name of this ITimeRangeModel.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def links(self):
        """Gets the links of this ITimeRangeModel.  # noqa: E501


        :return: The links of this ITimeRangeModel.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this ITimeRangeModel.


        :param links: The links of this ITimeRangeModel.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this ITimeRangeModel.  # noqa: E501


        :return: The id of this ITimeRangeModel.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ITimeRangeModel.


        :param id: The id of this ITimeRangeModel.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this ITimeRangeModel.  # noqa: E501


        :return: The type of this ITimeRangeModel.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ITimeRangeModel.


        :param type: The type of this ITimeRangeModel.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def recurrence_list(self):
        """Gets the recurrence_list of this ITimeRangeModel.  # noqa: E501


        :return: The recurrence_list of this ITimeRangeModel.  # noqa: E501
        :rtype: list[IRecurrence]
        """
        return self._recurrence_list

    @recurrence_list.setter
    def recurrence_list(self, recurrence_list):
        """Sets the recurrence_list of this ITimeRangeModel.


        :param recurrence_list: The recurrence_list of this ITimeRangeModel.  # noqa: E501
        :type: list[IRecurrence]
        """

        self._recurrence_list = recurrence_list

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ITimeRangeModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ITimeRangeModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ITimeRangeModel):
            return True

        return self.to_dict() != other.to_dict()
