# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IVlanTagLiteral(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'start_tag': 'int',
        'end_tag': 'int',
        'type': 'str'
    }

    attribute_map = {
        'start_tag': 'startTag',
        'end_tag': 'endTag',
        'type': 'type'
    }

    def __init__(self, start_tag=None, end_tag=None, type=None, _configuration=None):  # noqa: E501
        """IVlanTagLiteral - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._start_tag = None
        self._end_tag = None
        self._type = None
        self.discriminator = None

        if start_tag is not None:
            self.start_tag = start_tag
        if end_tag is not None:
            self.end_tag = end_tag
        if type is not None:
            self.type = type

    @property
    def start_tag(self):
        """Gets the start_tag of this IVlanTagLiteral.  # noqa: E501


        :return: The start_tag of this IVlanTagLiteral.  # noqa: E501
        :rtype: int
        """
        return self._start_tag

    @start_tag.setter
    def start_tag(self, start_tag):
        """Sets the start_tag of this IVlanTagLiteral.


        :param start_tag: The start_tag of this IVlanTagLiteral.  # noqa: E501
        :type: int
        """

        self._start_tag = start_tag

    @property
    def end_tag(self):
        """Gets the end_tag of this IVlanTagLiteral.  # noqa: E501


        :return: The end_tag of this IVlanTagLiteral.  # noqa: E501
        :rtype: int
        """
        return self._end_tag

    @end_tag.setter
    def end_tag(self, end_tag):
        """Sets the end_tag of this IVlanTagLiteral.


        :param end_tag: The end_tag of this IVlanTagLiteral.  # noqa: E501
        :type: int
        """

        self._end_tag = end_tag

    @property
    def type(self):
        """Gets the type of this IVlanTagLiteral.  # noqa: E501


        :return: The type of this IVlanTagLiteral.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this IVlanTagLiteral.


        :param type: The type of this IVlanTagLiteral.  # noqa: E501
        :type: str
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IVlanTagLiteral, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IVlanTagLiteral):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IVlanTagLiteral):
            return True

        return self.to_dict() != other.to_dict()
