# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IVpnExtranetInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'is_dynamic_ip': 'bool',
        'name': 'str',
        'ip_address': 'str'
    }

    attribute_map = {
        'is_dynamic_ip': 'isDynamicIP',
        'name': 'name',
        'ip_address': 'ipAddress'
    }

    def __init__(self, is_dynamic_ip=None, name=None, ip_address=None, _configuration=None):  # noqa: E501
        """IVpnExtranetInfo - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._is_dynamic_ip = None
        self._name = None
        self._ip_address = None
        self.discriminator = None

        if is_dynamic_ip is not None:
            self.is_dynamic_ip = is_dynamic_ip
        if name is not None:
            self.name = name
        if ip_address is not None:
            self.ip_address = ip_address

    @property
    def is_dynamic_ip(self):
        """Gets the is_dynamic_ip of this IVpnExtranetInfo.  # noqa: E501

        Indicates whether the VPN endpoint has a dynamic IP.  # noqa: E501

        :return: The is_dynamic_ip of this IVpnExtranetInfo.  # noqa: E501
        :rtype: bool
        """
        return self._is_dynamic_ip

    @is_dynamic_ip.setter
    def is_dynamic_ip(self, is_dynamic_ip):
        """Sets the is_dynamic_ip of this IVpnExtranetInfo.

        Indicates whether the VPN endpoint has a dynamic IP.  # noqa: E501

        :param is_dynamic_ip: The is_dynamic_ip of this IVpnExtranetInfo.  # noqa: E501
        :type: bool
        """

        self._is_dynamic_ip = is_dynamic_ip

    @property
    def name(self):
        """Gets the name of this IVpnExtranetInfo.  # noqa: E501

        User chosen resource name.  # noqa: E501

        :return: The name of this IVpnExtranetInfo.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this IVpnExtranetInfo.

        User chosen resource name.  # noqa: E501

        :param name: The name of this IVpnExtranetInfo.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def ip_address(self):
        """Gets the ip_address of this IVpnExtranetInfo.  # noqa: E501

        IP address of the VPN endpoint.  # noqa: E501

        :return: The ip_address of this IVpnExtranetInfo.  # noqa: E501
        :rtype: str
        """
        return self._ip_address

    @ip_address.setter
    def ip_address(self, ip_address):
        """Sets the ip_address of this IVpnExtranetInfo.

        IP address of the VPN endpoint.  # noqa: E501

        :param ip_address: The ip_address of this IVpnExtranetInfo.  # noqa: E501
        :type: str
        """

        self._ip_address = ip_address

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IVpnExtranetInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IVpnExtranetInfo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IVpnExtranetInfo):
            return True

        return self.to_dict() != other.to_dict()
