# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IVpnProtectedNetwork(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'acl': 'IReference',
        'networks': 'list[IReference]'
    }

    attribute_map = {
        'acl': 'acl',
        'networks': 'networks'
    }

    def __init__(self, acl=None, networks=None, _configuration=None):  # noqa: E501
        """IVpnProtectedNetwork - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._acl = None
        self._networks = None
        self.discriminator = None

        if acl is not None:
            self.acl = acl
        if networks is not None:
            self.networks = networks

    @property
    def acl(self):
        """Gets the acl of this IVpnProtectedNetwork.  # noqa: E501

        Access control list of the network.  # noqa: E501

        :return: The acl of this IVpnProtectedNetwork.  # noqa: E501
        :rtype: IReference
        """
        return self._acl

    @acl.setter
    def acl(self, acl):
        """Sets the acl of this IVpnProtectedNetwork.

        Access control list of the network.  # noqa: E501

        :param acl: The acl of this IVpnProtectedNetwork.  # noqa: E501
        :type: IReference
        """

        self._acl = acl

    @property
    def networks(self):
        """Gets the networks of this IVpnProtectedNetwork.  # noqa: E501

        Represents networks in the VPN.  # noqa: E501

        :return: The networks of this IVpnProtectedNetwork.  # noqa: E501
        :rtype: list[IReference]
        """
        return self._networks

    @networks.setter
    def networks(self, networks):
        """Sets the networks of this IVpnProtectedNetwork.

        Represents networks in the VPN.  # noqa: E501

        :param networks: The networks of this IVpnProtectedNetwork.  # noqa: E501
        :type: list[IReference]
        """

        self._networks = networks

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IVpnProtectedNetwork, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IVpnProtectedNetwork):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IVpnProtectedNetwork):
            return True

        return self.to_dict() != other.to_dict()
