# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IARPConfigContainer(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'mac_address': 'str',
        'enable_alias': 'bool',
        'ip_address': 'str'
    }

    attribute_map = {
        'mac_address': 'macAddress',
        'enable_alias': 'enableAlias',
        'ip_address': 'ipAddress'
    }

    def __init__(self, mac_address=None, enable_alias=None, ip_address=None, _configuration=None):  # noqa: E501
        """IARPConfigContainer - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._mac_address = None
        self._enable_alias = None
        self._ip_address = None
        self.discriminator = None

        if mac_address is not None:
            self.mac_address = mac_address
        if enable_alias is not None:
            self.enable_alias = enable_alias
        if ip_address is not None:
            self.ip_address = ip_address

    @property
    def mac_address(self):
        """Gets the mac_address of this IARPConfigContainer.  # noqa: E501


        :return: The mac_address of this IARPConfigContainer.  # noqa: E501
        :rtype: str
        """
        return self._mac_address

    @mac_address.setter
    def mac_address(self, mac_address):
        """Sets the mac_address of this IARPConfigContainer.


        :param mac_address: The mac_address of this IARPConfigContainer.  # noqa: E501
        :type: str
        """

        self._mac_address = mac_address

    @property
    def enable_alias(self):
        """Gets the enable_alias of this IARPConfigContainer.  # noqa: E501


        :return: The enable_alias of this IARPConfigContainer.  # noqa: E501
        :rtype: bool
        """
        return self._enable_alias

    @enable_alias.setter
    def enable_alias(self, enable_alias):
        """Sets the enable_alias of this IARPConfigContainer.


        :param enable_alias: The enable_alias of this IARPConfigContainer.  # noqa: E501
        :type: bool
        """

        self._enable_alias = enable_alias

    @property
    def ip_address(self):
        """Gets the ip_address of this IARPConfigContainer.  # noqa: E501


        :return: The ip_address of this IARPConfigContainer.  # noqa: E501
        :rtype: str
        """
        return self._ip_address

    @ip_address.setter
    def ip_address(self, ip_address):
        """Sets the ip_address of this IARPConfigContainer.


        :param ip_address: The ip_address of this IARPConfigContainer.  # noqa: E501
        :type: str
        """

        self._ip_address = ip_address

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IARPConfigContainer, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IARPConfigContainer):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IARPConfigContainer):
            return True

        return self.to_dict() != other.to_dict()
