# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IBGPGSBestPath(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'deterministic_med': 'bool',
        'default_local_preference_value': 'int',
        'always_compare_med': 'bool',
        'name': 'str',
        'links': 'ILinks',
        'id': 'str',
        'type': 'str',
        'best_path_compare_router_id': 'bool',
        'best_path_med_missing_as_worst': 'bool'
    }

    attribute_map = {
        'deterministic_med': 'deterministicMed',
        'default_local_preference_value': 'defaultLocalPreferenceValue',
        'always_compare_med': 'alwaysCompareMed',
        'name': 'name',
        'links': 'links',
        'id': 'id',
        'type': 'type',
        'best_path_compare_router_id': 'bestPathCompareRouterId',
        'best_path_med_missing_as_worst': 'bestPathMedMissingAsWorst'
    }

    def __init__(self, deterministic_med=None, default_local_preference_value=None, always_compare_med=None, name=None, links=None, id=None, type=None, best_path_compare_router_id=None, best_path_med_missing_as_worst=None, _configuration=None):  # noqa: E501
        """IBGPGSBestPath - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._deterministic_med = None
        self._default_local_preference_value = None
        self._always_compare_med = None
        self._name = None
        self._links = None
        self._id = None
        self._type = None
        self._best_path_compare_router_id = None
        self._best_path_med_missing_as_worst = None
        self.discriminator = None

        if deterministic_med is not None:
            self.deterministic_med = deterministic_med
        if default_local_preference_value is not None:
            self.default_local_preference_value = default_local_preference_value
        if always_compare_med is not None:
            self.always_compare_med = always_compare_med
        if name is not None:
            self.name = name
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if best_path_compare_router_id is not None:
            self.best_path_compare_router_id = best_path_compare_router_id
        if best_path_med_missing_as_worst is not None:
            self.best_path_med_missing_as_worst = best_path_med_missing_as_worst

    @property
    def deterministic_med(self):
        """Gets the deterministic_med of this IBGPGSBestPath.  # noqa: E501


        :return: The deterministic_med of this IBGPGSBestPath.  # noqa: E501
        :rtype: bool
        """
        return self._deterministic_med

    @deterministic_med.setter
    def deterministic_med(self, deterministic_med):
        """Sets the deterministic_med of this IBGPGSBestPath.


        :param deterministic_med: The deterministic_med of this IBGPGSBestPath.  # noqa: E501
        :type: bool
        """

        self._deterministic_med = deterministic_med

    @property
    def default_local_preference_value(self):
        """Gets the default_local_preference_value of this IBGPGSBestPath.  # noqa: E501


        :return: The default_local_preference_value of this IBGPGSBestPath.  # noqa: E501
        :rtype: int
        """
        return self._default_local_preference_value

    @default_local_preference_value.setter
    def default_local_preference_value(self, default_local_preference_value):
        """Sets the default_local_preference_value of this IBGPGSBestPath.


        :param default_local_preference_value: The default_local_preference_value of this IBGPGSBestPath.  # noqa: E501
        :type: int
        """

        self._default_local_preference_value = default_local_preference_value

    @property
    def always_compare_med(self):
        """Gets the always_compare_med of this IBGPGSBestPath.  # noqa: E501


        :return: The always_compare_med of this IBGPGSBestPath.  # noqa: E501
        :rtype: bool
        """
        return self._always_compare_med

    @always_compare_med.setter
    def always_compare_med(self, always_compare_med):
        """Sets the always_compare_med of this IBGPGSBestPath.


        :param always_compare_med: The always_compare_med of this IBGPGSBestPath.  # noqa: E501
        :type: bool
        """

        self._always_compare_med = always_compare_med

    @property
    def name(self):
        """Gets the name of this IBGPGSBestPath.  # noqa: E501


        :return: The name of this IBGPGSBestPath.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this IBGPGSBestPath.


        :param name: The name of this IBGPGSBestPath.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def links(self):
        """Gets the links of this IBGPGSBestPath.  # noqa: E501


        :return: The links of this IBGPGSBestPath.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this IBGPGSBestPath.


        :param links: The links of this IBGPGSBestPath.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this IBGPGSBestPath.  # noqa: E501


        :return: The id of this IBGPGSBestPath.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this IBGPGSBestPath.


        :param id: The id of this IBGPGSBestPath.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this IBGPGSBestPath.  # noqa: E501


        :return: The type of this IBGPGSBestPath.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this IBGPGSBestPath.


        :param type: The type of this IBGPGSBestPath.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def best_path_compare_router_id(self):
        """Gets the best_path_compare_router_id of this IBGPGSBestPath.  # noqa: E501


        :return: The best_path_compare_router_id of this IBGPGSBestPath.  # noqa: E501
        :rtype: bool
        """
        return self._best_path_compare_router_id

    @best_path_compare_router_id.setter
    def best_path_compare_router_id(self, best_path_compare_router_id):
        """Sets the best_path_compare_router_id of this IBGPGSBestPath.


        :param best_path_compare_router_id: The best_path_compare_router_id of this IBGPGSBestPath.  # noqa: E501
        :type: bool
        """

        self._best_path_compare_router_id = best_path_compare_router_id

    @property
    def best_path_med_missing_as_worst(self):
        """Gets the best_path_med_missing_as_worst of this IBGPGSBestPath.  # noqa: E501


        :return: The best_path_med_missing_as_worst of this IBGPGSBestPath.  # noqa: E501
        :rtype: bool
        """
        return self._best_path_med_missing_as_worst

    @best_path_med_missing_as_worst.setter
    def best_path_med_missing_as_worst(self, best_path_med_missing_as_worst):
        """Sets the best_path_med_missing_as_worst of this IBGPGSBestPath.


        :param best_path_med_missing_as_worst: The best_path_med_missing_as_worst of this IBGPGSBestPath.  # noqa: E501
        :type: bool
        """

        self._best_path_med_missing_as_worst = best_path_med_missing_as_worst

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IBGPGSBestPath, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IBGPGSBestPath):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IBGPGSBestPath):
            return True

        return self.to_dict() != other.to_dict()
