# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IDHCPContainer(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'dhcp_route_metric': 'int',
        'enable_default_route_dhcp': 'bool'
    }

    attribute_map = {
        'dhcp_route_metric': 'dhcpRouteMetric',
        'enable_default_route_dhcp': 'enableDefaultRouteDHCP'
    }

    def __init__(self, dhcp_route_metric=None, enable_default_route_dhcp=None, _configuration=None):  # noqa: E501
        """IDHCPContainer - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._dhcp_route_metric = None
        self._enable_default_route_dhcp = None
        self.discriminator = None

        if dhcp_route_metric is not None:
            self.dhcp_route_metric = dhcp_route_metric
        if enable_default_route_dhcp is not None:
            self.enable_default_route_dhcp = enable_default_route_dhcp

    @property
    def dhcp_route_metric(self):
        """Gets the dhcp_route_metric of this IDHCPContainer.  # noqa: E501


        :return: The dhcp_route_metric of this IDHCPContainer.  # noqa: E501
        :rtype: int
        """
        return self._dhcp_route_metric

    @dhcp_route_metric.setter
    def dhcp_route_metric(self, dhcp_route_metric):
        """Sets the dhcp_route_metric of this IDHCPContainer.


        :param dhcp_route_metric: The dhcp_route_metric of this IDHCPContainer.  # noqa: E501
        :type: int
        """

        self._dhcp_route_metric = dhcp_route_metric

    @property
    def enable_default_route_dhcp(self):
        """Gets the enable_default_route_dhcp of this IDHCPContainer.  # noqa: E501


        :return: The enable_default_route_dhcp of this IDHCPContainer.  # noqa: E501
        :rtype: bool
        """
        return self._enable_default_route_dhcp

    @enable_default_route_dhcp.setter
    def enable_default_route_dhcp(self, enable_default_route_dhcp):
        """Sets the enable_default_route_dhcp of this IDHCPContainer.


        :param enable_default_route_dhcp: The enable_default_route_dhcp of this IDHCPContainer.  # noqa: E501
        :type: bool
        """

        self._enable_default_route_dhcp = enable_default_route_dhcp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IDHCPContainer, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IDHCPContainer):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IDHCPContainer):
            return True

        return self.to_dict() != other.to_dict()
