# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IFTDHAIPv6ActiveStandbyPair(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'active_i_pv6': 'str',
        'standby_i_pv6': 'str'
    }

    attribute_map = {
        'active_i_pv6': 'activeIPv6',
        'standby_i_pv6': 'standbyIPv6'
    }

    def __init__(self, active_i_pv6=None, standby_i_pv6=None, _configuration=None):  # noqa: E501
        """IFTDHAIPv6ActiveStandbyPair - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._active_i_pv6 = None
        self._standby_i_pv6 = None
        self.discriminator = None

        if active_i_pv6 is not None:
            self.active_i_pv6 = active_i_pv6
        if standby_i_pv6 is not None:
            self.standby_i_pv6 = standby_i_pv6

    @property
    def active_i_pv6(self):
        """Gets the active_i_pv6 of this IFTDHAIPv6ActiveStandbyPair.  # noqa: E501


        :return: The active_i_pv6 of this IFTDHAIPv6ActiveStandbyPair.  # noqa: E501
        :rtype: str
        """
        return self._active_i_pv6

    @active_i_pv6.setter
    def active_i_pv6(self, active_i_pv6):
        """Sets the active_i_pv6 of this IFTDHAIPv6ActiveStandbyPair.


        :param active_i_pv6: The active_i_pv6 of this IFTDHAIPv6ActiveStandbyPair.  # noqa: E501
        :type: str
        """

        self._active_i_pv6 = active_i_pv6

    @property
    def standby_i_pv6(self):
        """Gets the standby_i_pv6 of this IFTDHAIPv6ActiveStandbyPair.  # noqa: E501


        :return: The standby_i_pv6 of this IFTDHAIPv6ActiveStandbyPair.  # noqa: E501
        :rtype: str
        """
        return self._standby_i_pv6

    @standby_i_pv6.setter
    def standby_i_pv6(self, standby_i_pv6):
        """Sets the standby_i_pv6 of this IFTDHAIPv6ActiveStandbyPair.


        :param standby_i_pv6: The standby_i_pv6 of this IFTDHAIPv6ActiveStandbyPair.  # noqa: E501
        :type: str
        """

        self._standby_i_pv6 = standby_i_pv6

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IFTDHAIPv6ActiveStandbyPair, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IFTDHAIPv6ActiveStandbyPair):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IFTDHAIPv6ActiveStandbyPair):
            return True

        return self.to_dict() != other.to_dict()
