# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IIPv4Container(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'static': 'IStaticIPContainer',
        'pppoe': 'IPPPoEContianer',
        'dhcp': 'IDHCPContainer'
    }

    attribute_map = {
        'static': 'static',
        'pppoe': 'pppoe',
        'dhcp': 'dhcp'
    }

    def __init__(self, static=None, pppoe=None, dhcp=None, _configuration=None):  # noqa: E501
        """IIPv4Container - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._static = None
        self._pppoe = None
        self._dhcp = None
        self.discriminator = None

        if static is not None:
            self.static = static
        if pppoe is not None:
            self.pppoe = pppoe
        if dhcp is not None:
            self.dhcp = dhcp

    @property
    def static(self):
        """Gets the static of this IIPv4Container.  # noqa: E501


        :return: The static of this IIPv4Container.  # noqa: E501
        :rtype: IStaticIPContainer
        """
        return self._static

    @static.setter
    def static(self, static):
        """Sets the static of this IIPv4Container.


        :param static: The static of this IIPv4Container.  # noqa: E501
        :type: IStaticIPContainer
        """

        self._static = static

    @property
    def pppoe(self):
        """Gets the pppoe of this IIPv4Container.  # noqa: E501


        :return: The pppoe of this IIPv4Container.  # noqa: E501
        :rtype: IPPPoEContianer
        """
        return self._pppoe

    @pppoe.setter
    def pppoe(self, pppoe):
        """Sets the pppoe of this IIPv4Container.


        :param pppoe: The pppoe of this IIPv4Container.  # noqa: E501
        :type: IPPPoEContianer
        """

        self._pppoe = pppoe

    @property
    def dhcp(self):
        """Gets the dhcp of this IIPv4Container.  # noqa: E501


        :return: The dhcp of this IIPv4Container.  # noqa: E501
        :rtype: IDHCPContainer
        """
        return self._dhcp

    @dhcp.setter
    def dhcp(self, dhcp):
        """Sets the dhcp of this IIPv4Container.


        :param dhcp: The dhcp of this IIPv4Container.  # noqa: E501
        :type: IDHCPContainer
        """

        self._dhcp = dhcp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IIPv4Container, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IIPv4Container):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IIPv4Container):
            return True

        return self.to_dict() != other.to_dict()
