# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IIPvPrefixListEntry(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sequence': 'int',
        'min_prefix_lenth': 'int',
        'max_prefix_length': 'int',
        'ip_address': 'str',
        'action': 'str'
    }

    attribute_map = {
        'sequence': 'sequence',
        'min_prefix_lenth': 'minPrefixLenth',
        'max_prefix_length': 'maxPrefixLength',
        'ip_address': 'ipAddress',
        'action': 'action'
    }

    def __init__(self, sequence=None, min_prefix_lenth=None, max_prefix_length=None, ip_address=None, action=None, _configuration=None):  # noqa: E501
        """IIPvPrefixListEntry - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._sequence = None
        self._min_prefix_lenth = None
        self._max_prefix_length = None
        self._ip_address = None
        self._action = None
        self.discriminator = None

        self.sequence = sequence
        if min_prefix_lenth is not None:
            self.min_prefix_lenth = min_prefix_lenth
        if max_prefix_length is not None:
            self.max_prefix_length = max_prefix_length
        if ip_address is not None:
            self.ip_address = ip_address
        if action is not None:
            self.action = action

    @property
    def sequence(self):
        """Gets the sequence of this IIPvPrefixListEntry.  # noqa: E501


        :return: The sequence of this IIPvPrefixListEntry.  # noqa: E501
        :rtype: int
        """
        return self._sequence

    @sequence.setter
    def sequence(self, sequence):
        """Sets the sequence of this IIPvPrefixListEntry.


        :param sequence: The sequence of this IIPvPrefixListEntry.  # noqa: E501
        :type: int
        """
        if self._configuration.client_side_validation and sequence is None:
            raise ValueError("Invalid value for `sequence`, must not be `None`")  # noqa: E501

        self._sequence = sequence

    @property
    def min_prefix_lenth(self):
        """Gets the min_prefix_lenth of this IIPvPrefixListEntry.  # noqa: E501


        :return: The min_prefix_lenth of this IIPvPrefixListEntry.  # noqa: E501
        :rtype: int
        """
        return self._min_prefix_lenth

    @min_prefix_lenth.setter
    def min_prefix_lenth(self, min_prefix_lenth):
        """Sets the min_prefix_lenth of this IIPvPrefixListEntry.


        :param min_prefix_lenth: The min_prefix_lenth of this IIPvPrefixListEntry.  # noqa: E501
        :type: int
        """

        self._min_prefix_lenth = min_prefix_lenth

    @property
    def max_prefix_length(self):
        """Gets the max_prefix_length of this IIPvPrefixListEntry.  # noqa: E501


        :return: The max_prefix_length of this IIPvPrefixListEntry.  # noqa: E501
        :rtype: int
        """
        return self._max_prefix_length

    @max_prefix_length.setter
    def max_prefix_length(self, max_prefix_length):
        """Sets the max_prefix_length of this IIPvPrefixListEntry.


        :param max_prefix_length: The max_prefix_length of this IIPvPrefixListEntry.  # noqa: E501
        :type: int
        """

        self._max_prefix_length = max_prefix_length

    @property
    def ip_address(self):
        """Gets the ip_address of this IIPvPrefixListEntry.  # noqa: E501


        :return: The ip_address of this IIPvPrefixListEntry.  # noqa: E501
        :rtype: str
        """
        return self._ip_address

    @ip_address.setter
    def ip_address(self, ip_address):
        """Sets the ip_address of this IIPvPrefixListEntry.


        :param ip_address: The ip_address of this IIPvPrefixListEntry.  # noqa: E501
        :type: str
        """

        self._ip_address = ip_address

    @property
    def action(self):
        """Gets the action of this IIPvPrefixListEntry.  # noqa: E501


        :return: The action of this IIPvPrefixListEntry.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this IIPvPrefixListEntry.


        :param action: The action of this IIPvPrefixListEntry.  # noqa: E501
        :type: str
        """
        allowed_values = ["PERMIT", "DENY"]  # noqa: E501
        if (self._configuration.client_side_validation and
                action not in allowed_values):
            raise ValueError(
                "Invalid value for `action` ({0}), must be one of {1}"  # noqa: E501
                .format(action, allowed_values)
            )

        self._action = action

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IIPvPrefixListEntry, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IIPvPrefixListEntry):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IIPvPrefixListEntry):
            return True

        return self.to_dict() != other.to_dict()
