# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class Ikev1PolicyObject(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'metadata': 'Metadata',
        'description': 'str',
        'priority': 'int',
        'type': 'str',
        'version': 'str',
        'diffie_hellman_group': 'int',
        'encryption': 'str',
        'authentication_method': 'str',
        'name': 'str',
        'links': 'Links',
        'lifetime_in_seconds': 'int',
        'id': 'str',
        'hash': 'str'
    }

    attribute_map = {
        'metadata': 'metadata',
        'description': 'description',
        'priority': 'priority',
        'type': 'type',
        'version': 'version',
        'diffie_hellman_group': 'diffieHellmanGroup',
        'encryption': 'encryption',
        'authentication_method': 'authenticationMethod',
        'name': 'name',
        'links': 'links',
        'lifetime_in_seconds': 'lifetimeInSeconds',
        'id': 'id',
        'hash': 'hash'
    }

    def __init__(self, metadata=None, description=None, priority=None, type=None, version=None, diffie_hellman_group=None, encryption=None, authentication_method=None, name=None, links=None, lifetime_in_seconds=None, id=None, hash=None, _configuration=None):  # noqa: E501
        """Ikev1PolicyObject - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._metadata = None
        self._description = None
        self._priority = None
        self._type = None
        self._version = None
        self._diffie_hellman_group = None
        self._encryption = None
        self._authentication_method = None
        self._name = None
        self._links = None
        self._lifetime_in_seconds = None
        self._id = None
        self._hash = None
        self.discriminator = None

        if metadata is not None:
            self.metadata = metadata
        if description is not None:
            self.description = description
        if priority is not None:
            self.priority = priority
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version
        if diffie_hellman_group is not None:
            self.diffie_hellman_group = diffie_hellman_group
        if encryption is not None:
            self.encryption = encryption
        if authentication_method is not None:
            self.authentication_method = authentication_method
        if name is not None:
            self.name = name
        if links is not None:
            self.links = links
        if lifetime_in_seconds is not None:
            self.lifetime_in_seconds = lifetime_in_seconds
        if id is not None:
            self.id = id
        if hash is not None:
            self.hash = hash

    @property
    def metadata(self):
        """Gets the metadata of this Ikev1PolicyObject.  # noqa: E501


        :return: The metadata of this Ikev1PolicyObject.  # noqa: E501
        :rtype: Metadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this Ikev1PolicyObject.


        :param metadata: The metadata of this Ikev1PolicyObject.  # noqa: E501
        :type: Metadata
        """

        self._metadata = metadata

    @property
    def description(self):
        """Gets the description of this Ikev1PolicyObject.  # noqa: E501


        :return: The description of this Ikev1PolicyObject.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Ikev1PolicyObject.


        :param description: The description of this Ikev1PolicyObject.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def priority(self):
        """Gets the priority of this Ikev1PolicyObject.  # noqa: E501


        :return: The priority of this Ikev1PolicyObject.  # noqa: E501
        :rtype: int
        """
        return self._priority

    @priority.setter
    def priority(self, priority):
        """Sets the priority of this Ikev1PolicyObject.


        :param priority: The priority of this Ikev1PolicyObject.  # noqa: E501
        :type: int
        """

        self._priority = priority

    @property
    def type(self):
        """Gets the type of this Ikev1PolicyObject.  # noqa: E501


        :return: The type of this Ikev1PolicyObject.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Ikev1PolicyObject.


        :param type: The type of this Ikev1PolicyObject.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this Ikev1PolicyObject.  # noqa: E501


        :return: The version of this Ikev1PolicyObject.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this Ikev1PolicyObject.


        :param version: The version of this Ikev1PolicyObject.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def diffie_hellman_group(self):
        """Gets the diffie_hellman_group of this Ikev1PolicyObject.  # noqa: E501


        :return: The diffie_hellman_group of this Ikev1PolicyObject.  # noqa: E501
        :rtype: int
        """
        return self._diffie_hellman_group

    @diffie_hellman_group.setter
    def diffie_hellman_group(self, diffie_hellman_group):
        """Sets the diffie_hellman_group of this Ikev1PolicyObject.


        :param diffie_hellman_group: The diffie_hellman_group of this Ikev1PolicyObject.  # noqa: E501
        :type: int
        """

        self._diffie_hellman_group = diffie_hellman_group

    @property
    def encryption(self):
        """Gets the encryption of this Ikev1PolicyObject.  # noqa: E501


        :return: The encryption of this Ikev1PolicyObject.  # noqa: E501
        :rtype: str
        """
        return self._encryption

    @encryption.setter
    def encryption(self, encryption):
        """Sets the encryption of this Ikev1PolicyObject.


        :param encryption: The encryption of this Ikev1PolicyObject.  # noqa: E501
        :type: str
        """

        self._encryption = encryption

    @property
    def authentication_method(self):
        """Gets the authentication_method of this Ikev1PolicyObject.  # noqa: E501


        :return: The authentication_method of this Ikev1PolicyObject.  # noqa: E501
        :rtype: str
        """
        return self._authentication_method

    @authentication_method.setter
    def authentication_method(self, authentication_method):
        """Sets the authentication_method of this Ikev1PolicyObject.


        :param authentication_method: The authentication_method of this Ikev1PolicyObject.  # noqa: E501
        :type: str
        """

        self._authentication_method = authentication_method

    @property
    def name(self):
        """Gets the name of this Ikev1PolicyObject.  # noqa: E501


        :return: The name of this Ikev1PolicyObject.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Ikev1PolicyObject.


        :param name: The name of this Ikev1PolicyObject.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def links(self):
        """Gets the links of this Ikev1PolicyObject.  # noqa: E501


        :return: The links of this Ikev1PolicyObject.  # noqa: E501
        :rtype: Links
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Ikev1PolicyObject.


        :param links: The links of this Ikev1PolicyObject.  # noqa: E501
        :type: Links
        """

        self._links = links

    @property
    def lifetime_in_seconds(self):
        """Gets the lifetime_in_seconds of this Ikev1PolicyObject.  # noqa: E501


        :return: The lifetime_in_seconds of this Ikev1PolicyObject.  # noqa: E501
        :rtype: int
        """
        return self._lifetime_in_seconds

    @lifetime_in_seconds.setter
    def lifetime_in_seconds(self, lifetime_in_seconds):
        """Sets the lifetime_in_seconds of this Ikev1PolicyObject.


        :param lifetime_in_seconds: The lifetime_in_seconds of this Ikev1PolicyObject.  # noqa: E501
        :type: int
        """

        self._lifetime_in_seconds = lifetime_in_seconds

    @property
    def id(self):
        """Gets the id of this Ikev1PolicyObject.  # noqa: E501


        :return: The id of this Ikev1PolicyObject.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Ikev1PolicyObject.


        :param id: The id of this Ikev1PolicyObject.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def hash(self):
        """Gets the hash of this Ikev1PolicyObject.  # noqa: E501


        :return: The hash of this Ikev1PolicyObject.  # noqa: E501
        :rtype: str
        """
        return self._hash

    @hash.setter
    def hash(self, hash):
        """Sets the hash of this Ikev1PolicyObject.


        :param hash: The hash of this Ikev1PolicyObject.  # noqa: E501
        :type: str
        """

        self._hash = hash

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Ikev1PolicyObject, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Ikev1PolicyObject):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Ikev1PolicyObject):
            return True

        return self.to_dict() != other.to_dict()
