# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class Ikev2PolicyObject(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'metadata': 'Metadata',
        'encryption_algorithms': 'list[str]',
        'description': 'str',
        'priority': 'int',
        'type': 'str',
        'diffie_hellman_groups': 'list[int]',
        'version': 'str',
        'prf_integrity_algorithms': 'list[str]',
        'name': 'str',
        'links': 'Links',
        'lifetime_in_seconds': 'int',
        'id': 'str',
        'integrity_algorithms': 'list[str]'
    }

    attribute_map = {
        'metadata': 'metadata',
        'encryption_algorithms': 'encryptionAlgorithms',
        'description': 'description',
        'priority': 'priority',
        'type': 'type',
        'diffie_hellman_groups': 'diffieHellmanGroups',
        'version': 'version',
        'prf_integrity_algorithms': 'prfIntegrityAlgorithms',
        'name': 'name',
        'links': 'links',
        'lifetime_in_seconds': 'lifetimeInSeconds',
        'id': 'id',
        'integrity_algorithms': 'integrityAlgorithms'
    }

    def __init__(self, metadata=None, encryption_algorithms=None, description=None, priority=None, type=None, diffie_hellman_groups=None, version=None, prf_integrity_algorithms=None, name=None, links=None, lifetime_in_seconds=None, id=None, integrity_algorithms=None, _configuration=None):  # noqa: E501
        """Ikev2PolicyObject - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._metadata = None
        self._encryption_algorithms = None
        self._description = None
        self._priority = None
        self._type = None
        self._diffie_hellman_groups = None
        self._version = None
        self._prf_integrity_algorithms = None
        self._name = None
        self._links = None
        self._lifetime_in_seconds = None
        self._id = None
        self._integrity_algorithms = None
        self.discriminator = None

        if metadata is not None:
            self.metadata = metadata
        if encryption_algorithms is not None:
            self.encryption_algorithms = encryption_algorithms
        if description is not None:
            self.description = description
        if priority is not None:
            self.priority = priority
        if type is not None:
            self.type = type
        if diffie_hellman_groups is not None:
            self.diffie_hellman_groups = diffie_hellman_groups
        if version is not None:
            self.version = version
        if prf_integrity_algorithms is not None:
            self.prf_integrity_algorithms = prf_integrity_algorithms
        if name is not None:
            self.name = name
        if links is not None:
            self.links = links
        if lifetime_in_seconds is not None:
            self.lifetime_in_seconds = lifetime_in_seconds
        if id is not None:
            self.id = id
        if integrity_algorithms is not None:
            self.integrity_algorithms = integrity_algorithms

    @property
    def metadata(self):
        """Gets the metadata of this Ikev2PolicyObject.  # noqa: E501


        :return: The metadata of this Ikev2PolicyObject.  # noqa: E501
        :rtype: Metadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this Ikev2PolicyObject.


        :param metadata: The metadata of this Ikev2PolicyObject.  # noqa: E501
        :type: Metadata
        """

        self._metadata = metadata

    @property
    def encryption_algorithms(self):
        """Gets the encryption_algorithms of this Ikev2PolicyObject.  # noqa: E501


        :return: The encryption_algorithms of this Ikev2PolicyObject.  # noqa: E501
        :rtype: list[str]
        """
        return self._encryption_algorithms

    @encryption_algorithms.setter
    def encryption_algorithms(self, encryption_algorithms):
        """Sets the encryption_algorithms of this Ikev2PolicyObject.


        :param encryption_algorithms: The encryption_algorithms of this Ikev2PolicyObject.  # noqa: E501
        :type: list[str]
        """

        self._encryption_algorithms = encryption_algorithms

    @property
    def description(self):
        """Gets the description of this Ikev2PolicyObject.  # noqa: E501


        :return: The description of this Ikev2PolicyObject.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Ikev2PolicyObject.


        :param description: The description of this Ikev2PolicyObject.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def priority(self):
        """Gets the priority of this Ikev2PolicyObject.  # noqa: E501


        :return: The priority of this Ikev2PolicyObject.  # noqa: E501
        :rtype: int
        """
        return self._priority

    @priority.setter
    def priority(self, priority):
        """Sets the priority of this Ikev2PolicyObject.


        :param priority: The priority of this Ikev2PolicyObject.  # noqa: E501
        :type: int
        """

        self._priority = priority

    @property
    def type(self):
        """Gets the type of this Ikev2PolicyObject.  # noqa: E501


        :return: The type of this Ikev2PolicyObject.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Ikev2PolicyObject.


        :param type: The type of this Ikev2PolicyObject.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def diffie_hellman_groups(self):
        """Gets the diffie_hellman_groups of this Ikev2PolicyObject.  # noqa: E501


        :return: The diffie_hellman_groups of this Ikev2PolicyObject.  # noqa: E501
        :rtype: list[int]
        """
        return self._diffie_hellman_groups

    @diffie_hellman_groups.setter
    def diffie_hellman_groups(self, diffie_hellman_groups):
        """Sets the diffie_hellman_groups of this Ikev2PolicyObject.


        :param diffie_hellman_groups: The diffie_hellman_groups of this Ikev2PolicyObject.  # noqa: E501
        :type: list[int]
        """

        self._diffie_hellman_groups = diffie_hellman_groups

    @property
    def version(self):
        """Gets the version of this Ikev2PolicyObject.  # noqa: E501


        :return: The version of this Ikev2PolicyObject.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this Ikev2PolicyObject.


        :param version: The version of this Ikev2PolicyObject.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def prf_integrity_algorithms(self):
        """Gets the prf_integrity_algorithms of this Ikev2PolicyObject.  # noqa: E501


        :return: The prf_integrity_algorithms of this Ikev2PolicyObject.  # noqa: E501
        :rtype: list[str]
        """
        return self._prf_integrity_algorithms

    @prf_integrity_algorithms.setter
    def prf_integrity_algorithms(self, prf_integrity_algorithms):
        """Sets the prf_integrity_algorithms of this Ikev2PolicyObject.


        :param prf_integrity_algorithms: The prf_integrity_algorithms of this Ikev2PolicyObject.  # noqa: E501
        :type: list[str]
        """

        self._prf_integrity_algorithms = prf_integrity_algorithms

    @property
    def name(self):
        """Gets the name of this Ikev2PolicyObject.  # noqa: E501


        :return: The name of this Ikev2PolicyObject.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Ikev2PolicyObject.


        :param name: The name of this Ikev2PolicyObject.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def links(self):
        """Gets the links of this Ikev2PolicyObject.  # noqa: E501


        :return: The links of this Ikev2PolicyObject.  # noqa: E501
        :rtype: Links
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Ikev2PolicyObject.


        :param links: The links of this Ikev2PolicyObject.  # noqa: E501
        :type: Links
        """

        self._links = links

    @property
    def lifetime_in_seconds(self):
        """Gets the lifetime_in_seconds of this Ikev2PolicyObject.  # noqa: E501


        :return: The lifetime_in_seconds of this Ikev2PolicyObject.  # noqa: E501
        :rtype: int
        """
        return self._lifetime_in_seconds

    @lifetime_in_seconds.setter
    def lifetime_in_seconds(self, lifetime_in_seconds):
        """Sets the lifetime_in_seconds of this Ikev2PolicyObject.


        :param lifetime_in_seconds: The lifetime_in_seconds of this Ikev2PolicyObject.  # noqa: E501
        :type: int
        """

        self._lifetime_in_seconds = lifetime_in_seconds

    @property
    def id(self):
        """Gets the id of this Ikev2PolicyObject.  # noqa: E501


        :return: The id of this Ikev2PolicyObject.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Ikev2PolicyObject.


        :param id: The id of this Ikev2PolicyObject.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def integrity_algorithms(self):
        """Gets the integrity_algorithms of this Ikev2PolicyObject.  # noqa: E501


        :return: The integrity_algorithms of this Ikev2PolicyObject.  # noqa: E501
        :rtype: list[str]
        """
        return self._integrity_algorithms

    @integrity_algorithms.setter
    def integrity_algorithms(self, integrity_algorithms):
        """Sets the integrity_algorithms of this Ikev2PolicyObject.


        :param integrity_algorithms: The integrity_algorithms of this Ikev2PolicyObject.  # noqa: E501
        :type: list[str]
        """

        self._integrity_algorithms = integrity_algorithms

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Ikev2PolicyObject, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Ikev2PolicyObject):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Ikev2PolicyObject):
            return True

        return self.to_dict() != other.to_dict()
