# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class InterfaceGroupObject(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'metadata': 'IMetadata',
        'interfaces': 'list[IFTDInterface]',
        'interface_mode': 'str',
        'name': 'str',
        'overridable': 'bool',
        'description': 'str',
        'links': 'ILinks',
        'id': 'str',
        'overrides': 'IOverride',
        'type': 'str',
        'version': 'str',
        'interface_group': 'int'
    }

    attribute_map = {
        'metadata': 'metadata',
        'interfaces': 'interfaces',
        'interface_mode': 'interfaceMode',
        'name': 'name',
        'overridable': 'overridable',
        'description': 'description',
        'links': 'links',
        'id': 'id',
        'overrides': 'overrides',
        'type': 'type',
        'version': 'version',
        'interface_group': 'interfaceGroup'
    }

    def __init__(self, metadata=None, interfaces=None, interface_mode=None, name=None, overridable=None, description=None, links=None, id=None, overrides=None, type=None, version=None, interface_group=None, _configuration=None):  # noqa: E501
        """InterfaceGroupObject - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._metadata = None
        self._interfaces = None
        self._interface_mode = None
        self._name = None
        self._overridable = None
        self._description = None
        self._links = None
        self._id = None
        self._overrides = None
        self._type = None
        self._version = None
        self._interface_group = None
        self.discriminator = None

        if metadata is not None:
            self.metadata = metadata
        if interfaces is not None:
            self.interfaces = interfaces
        if interface_mode is not None:
            self.interface_mode = interface_mode
        if name is not None:
            self.name = name
        if overridable is not None:
            self.overridable = overridable
        if description is not None:
            self.description = description
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if overrides is not None:
            self.overrides = overrides
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version
        if interface_group is not None:
            self.interface_group = interface_group

    @property
    def metadata(self):
        """Gets the metadata of this InterfaceGroupObject.  # noqa: E501


        :return: The metadata of this InterfaceGroupObject.  # noqa: E501
        :rtype: IMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this InterfaceGroupObject.


        :param metadata: The metadata of this InterfaceGroupObject.  # noqa: E501
        :type: IMetadata
        """

        self._metadata = metadata

    @property
    def interfaces(self):
        """Gets the interfaces of this InterfaceGroupObject.  # noqa: E501


        :return: The interfaces of this InterfaceGroupObject.  # noqa: E501
        :rtype: list[IFTDInterface]
        """
        return self._interfaces

    @interfaces.setter
    def interfaces(self, interfaces):
        """Sets the interfaces of this InterfaceGroupObject.


        :param interfaces: The interfaces of this InterfaceGroupObject.  # noqa: E501
        :type: list[IFTDInterface]
        """

        self._interfaces = interfaces

    @property
    def interface_mode(self):
        """Gets the interface_mode of this InterfaceGroupObject.  # noqa: E501


        :return: The interface_mode of this InterfaceGroupObject.  # noqa: E501
        :rtype: str
        """
        return self._interface_mode

    @interface_mode.setter
    def interface_mode(self, interface_mode):
        """Sets the interface_mode of this InterfaceGroupObject.


        :param interface_mode: The interface_mode of this InterfaceGroupObject.  # noqa: E501
        :type: str
        """
        allowed_values = ["PASSIVE", "INLINE", "SWITCHED", "ROUTED"]  # noqa: E501
        if (self._configuration.client_side_validation and
                interface_mode not in allowed_values):
            raise ValueError(
                "Invalid value for `interface_mode` ({0}), must be one of {1}"  # noqa: E501
                .format(interface_mode, allowed_values)
            )

        self._interface_mode = interface_mode

    @property
    def name(self):
        """Gets the name of this InterfaceGroupObject.  # noqa: E501


        :return: The name of this InterfaceGroupObject.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this InterfaceGroupObject.


        :param name: The name of this InterfaceGroupObject.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def overridable(self):
        """Gets the overridable of this InterfaceGroupObject.  # noqa: E501


        :return: The overridable of this InterfaceGroupObject.  # noqa: E501
        :rtype: bool
        """
        return self._overridable

    @overridable.setter
    def overridable(self, overridable):
        """Sets the overridable of this InterfaceGroupObject.


        :param overridable: The overridable of this InterfaceGroupObject.  # noqa: E501
        :type: bool
        """

        self._overridable = overridable

    @property
    def description(self):
        """Gets the description of this InterfaceGroupObject.  # noqa: E501


        :return: The description of this InterfaceGroupObject.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this InterfaceGroupObject.


        :param description: The description of this InterfaceGroupObject.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def links(self):
        """Gets the links of this InterfaceGroupObject.  # noqa: E501


        :return: The links of this InterfaceGroupObject.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this InterfaceGroupObject.


        :param links: The links of this InterfaceGroupObject.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this InterfaceGroupObject.  # noqa: E501


        :return: The id of this InterfaceGroupObject.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this InterfaceGroupObject.


        :param id: The id of this InterfaceGroupObject.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def overrides(self):
        """Gets the overrides of this InterfaceGroupObject.  # noqa: E501


        :return: The overrides of this InterfaceGroupObject.  # noqa: E501
        :rtype: IOverride
        """
        return self._overrides

    @overrides.setter
    def overrides(self, overrides):
        """Sets the overrides of this InterfaceGroupObject.


        :param overrides: The overrides of this InterfaceGroupObject.  # noqa: E501
        :type: IOverride
        """

        self._overrides = overrides

    @property
    def type(self):
        """Gets the type of this InterfaceGroupObject.  # noqa: E501


        :return: The type of this InterfaceGroupObject.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this InterfaceGroupObject.


        :param type: The type of this InterfaceGroupObject.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this InterfaceGroupObject.  # noqa: E501


        :return: The version of this InterfaceGroupObject.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this InterfaceGroupObject.


        :param version: The version of this InterfaceGroupObject.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def interface_group(self):
        """Gets the interface_group of this InterfaceGroupObject.  # noqa: E501


        :return: The interface_group of this InterfaceGroupObject.  # noqa: E501
        :rtype: int
        """
        return self._interface_group

    @interface_group.setter
    def interface_group(self, interface_group):
        """Sets the interface_group of this InterfaceGroupObject.


        :param interface_group: The interface_group of this InterfaceGroupObject.  # noqa: E501
        :type: int
        """

        self._interface_group = interface_group

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InterfaceGroupObject, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InterfaceGroupObject):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InterfaceGroupObject):
            return True

        return self.to_dict() != other.to_dict()
