# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IntrusionPolicy(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'inline_drop': 'int',
        'metadata': 'IMetadata',
        'snort_engine': 'str',
        'inspection_mode': 'str',
        'is_system_defined': 'bool',
        'name': 'str',
        'description': 'str',
        'base_policy': 'IIntrusionPolicyModel',
        'links': 'ILinks',
        'id': 'str',
        'type': 'str',
        'version': 'str'
    }

    attribute_map = {
        'inline_drop': 'inlineDrop',
        'metadata': 'metadata',
        'snort_engine': 'snortEngine',
        'inspection_mode': 'inspectionMode',
        'is_system_defined': 'isSystemDefined',
        'name': 'name',
        'description': 'description',
        'base_policy': 'basePolicy',
        'links': 'links',
        'id': 'id',
        'type': 'type',
        'version': 'version'
    }

    def __init__(self, inline_drop=None, metadata=None, snort_engine=None, inspection_mode=None, is_system_defined=None, name=None, description=None, base_policy=None, links=None, id=None, type=None, version=None, _configuration=None):  # noqa: E501
        """IntrusionPolicy - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._inline_drop = None
        self._metadata = None
        self._snort_engine = None
        self._inspection_mode = None
        self._is_system_defined = None
        self._name = None
        self._description = None
        self._base_policy = None
        self._links = None
        self._id = None
        self._type = None
        self._version = None
        self.discriminator = None

        if inline_drop is not None:
            self.inline_drop = inline_drop
        if metadata is not None:
            self.metadata = metadata
        if snort_engine is not None:
            self.snort_engine = snort_engine
        if inspection_mode is not None:
            self.inspection_mode = inspection_mode
        if is_system_defined is not None:
            self.is_system_defined = is_system_defined
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if base_policy is not None:
            self.base_policy = base_policy
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version

    @property
    def inline_drop(self):
        """Gets the inline_drop of this IntrusionPolicy.  # noqa: E501

        Indicates the inspection mode <0 or 1>. Applicable for Snort2 engine only.  # noqa: E501

        :return: The inline_drop of this IntrusionPolicy.  # noqa: E501
        :rtype: int
        """
        return self._inline_drop

    @inline_drop.setter
    def inline_drop(self, inline_drop):
        """Sets the inline_drop of this IntrusionPolicy.

        Indicates the inspection mode <0 or 1>. Applicable for Snort2 engine only.  # noqa: E501

        :param inline_drop: The inline_drop of this IntrusionPolicy.  # noqa: E501
        :type: int
        """

        self._inline_drop = inline_drop

    @property
    def metadata(self):
        """Gets the metadata of this IntrusionPolicy.  # noqa: E501

        Object representing metadata properties of IntrusionPolicy.  # noqa: E501

        :return: The metadata of this IntrusionPolicy.  # noqa: E501
        :rtype: IMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this IntrusionPolicy.

        Object representing metadata properties of IntrusionPolicy.  # noqa: E501

        :param metadata: The metadata of this IntrusionPolicy.  # noqa: E501
        :type: IMetadata
        """

        self._metadata = metadata

    @property
    def snort_engine(self):
        """Gets the snort_engine of this IntrusionPolicy.  # noqa: E501

        Indicates the snort engine version <SNORT2 or SNORT3>.  # noqa: E501

        :return: The snort_engine of this IntrusionPolicy.  # noqa: E501
        :rtype: str
        """
        return self._snort_engine

    @snort_engine.setter
    def snort_engine(self, snort_engine):
        """Sets the snort_engine of this IntrusionPolicy.

        Indicates the snort engine version <SNORT2 or SNORT3>.  # noqa: E501

        :param snort_engine: The snort_engine of this IntrusionPolicy.  # noqa: E501
        :type: str
        """
        allowed_values = ["SNORT2", "SNORT3"]  # noqa: E501
        if (self._configuration.client_side_validation and
                snort_engine not in allowed_values):
            raise ValueError(
                "Invalid value for `snort_engine` ({0}), must be one of {1}"  # noqa: E501
                .format(snort_engine, allowed_values)
            )

        self._snort_engine = snort_engine

    @property
    def inspection_mode(self):
        """Gets the inspection_mode of this IntrusionPolicy.  # noqa: E501

        Indicates the inspection mode <DETECTION or PREVENTION>. Applicable for Snort3 engine only.  # noqa: E501

        :return: The inspection_mode of this IntrusionPolicy.  # noqa: E501
        :rtype: str
        """
        return self._inspection_mode

    @inspection_mode.setter
    def inspection_mode(self, inspection_mode):
        """Sets the inspection_mode of this IntrusionPolicy.

        Indicates the inspection mode <DETECTION or PREVENTION>. Applicable for Snort3 engine only.  # noqa: E501

        :param inspection_mode: The inspection_mode of this IntrusionPolicy.  # noqa: E501
        :type: str
        """
        allowed_values = ["PREVENTION", "DETECTION"]  # noqa: E501
        if (self._configuration.client_side_validation and
                inspection_mode not in allowed_values):
            raise ValueError(
                "Invalid value for `inspection_mode` ({0}), must be one of {1}"  # noqa: E501
                .format(inspection_mode, allowed_values)
            )

        self._inspection_mode = inspection_mode

    @property
    def is_system_defined(self):
        """Gets the is_system_defined of this IntrusionPolicy.  # noqa: E501


        :return: The is_system_defined of this IntrusionPolicy.  # noqa: E501
        :rtype: bool
        """
        return self._is_system_defined

    @is_system_defined.setter
    def is_system_defined(self, is_system_defined):
        """Sets the is_system_defined of this IntrusionPolicy.


        :param is_system_defined: The is_system_defined of this IntrusionPolicy.  # noqa: E501
        :type: bool
        """

        self._is_system_defined = is_system_defined

    @property
    def name(self):
        """Gets the name of this IntrusionPolicy.  # noqa: E501

        Name of the IntrusionPolicy  # noqa: E501

        :return: The name of this IntrusionPolicy.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this IntrusionPolicy.

        Name of the IntrusionPolicy  # noqa: E501

        :param name: The name of this IntrusionPolicy.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this IntrusionPolicy.  # noqa: E501

        Description of the IntrusionPolicy  # noqa: E501

        :return: The description of this IntrusionPolicy.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this IntrusionPolicy.

        Description of the IntrusionPolicy  # noqa: E501

        :param description: The description of this IntrusionPolicy.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def base_policy(self):
        """Gets the base_policy of this IntrusionPolicy.  # noqa: E501

        Object representing the basepolicy of the IntrusionPolicy.  # noqa: E501

        :return: The base_policy of this IntrusionPolicy.  # noqa: E501
        :rtype: IIntrusionPolicyModel
        """
        return self._base_policy

    @base_policy.setter
    def base_policy(self, base_policy):
        """Sets the base_policy of this IntrusionPolicy.

        Object representing the basepolicy of the IntrusionPolicy.  # noqa: E501

        :param base_policy: The base_policy of this IntrusionPolicy.  # noqa: E501
        :type: IIntrusionPolicyModel
        """

        self._base_policy = base_policy

    @property
    def links(self):
        """Gets the links of this IntrusionPolicy.  # noqa: E501

        Object containing links to this resource.  # noqa: E501

        :return: The links of this IntrusionPolicy.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this IntrusionPolicy.

        Object containing links to this resource.  # noqa: E501

        :param links: The links of this IntrusionPolicy.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this IntrusionPolicy.  # noqa: E501

        Intrusion Policy UUID.  # noqa: E501

        :return: The id of this IntrusionPolicy.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this IntrusionPolicy.

        Intrusion Policy UUID.  # noqa: E501

        :param id: The id of this IntrusionPolicy.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this IntrusionPolicy.  # noqa: E501

        Type must be intrusionpolicy.  # noqa: E501

        :return: The type of this IntrusionPolicy.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this IntrusionPolicy.

        Type must be intrusionpolicy.  # noqa: E501

        :param type: The type of this IntrusionPolicy.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this IntrusionPolicy.  # noqa: E501

        Version number of the response object.  # noqa: E501

        :return: The version of this IntrusionPolicy.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this IntrusionPolicy.

        Version number of the response object.  # noqa: E501

        :param version: The version of this IntrusionPolicy.  # noqa: E501
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IntrusionPolicy, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IntrusionPolicy):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IntrusionPolicy):
            return True

        return self.to_dict() != other.to_dict()
