# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class ITFCPackets(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'burst_bytes': 'int',
        'timeout_seconds': 'int',
        'enabled': 'bool',
        'payload_bytes': 'int'
    }

    attribute_map = {
        'burst_bytes': 'burstBytes',
        'timeout_seconds': 'timeoutSeconds',
        'enabled': 'enabled',
        'payload_bytes': 'payloadBytes'
    }

    def __init__(self, burst_bytes=None, timeout_seconds=None, enabled=None, payload_bytes=None, _configuration=None):  # noqa: E501
        """ITFCPackets - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._burst_bytes = None
        self._timeout_seconds = None
        self._enabled = None
        self._payload_bytes = None
        self.discriminator = None

        if burst_bytes is not None:
            self.burst_bytes = burst_bytes
        if timeout_seconds is not None:
            self.timeout_seconds = timeout_seconds
        if enabled is not None:
            self.enabled = enabled
        if payload_bytes is not None:
            self.payload_bytes = payload_bytes

    @property
    def burst_bytes(self):
        """Gets the burst_bytes of this ITFCPackets.  # noqa: E501


        :return: The burst_bytes of this ITFCPackets.  # noqa: E501
        :rtype: int
        """
        return self._burst_bytes

    @burst_bytes.setter
    def burst_bytes(self, burst_bytes):
        """Sets the burst_bytes of this ITFCPackets.


        :param burst_bytes: The burst_bytes of this ITFCPackets.  # noqa: E501
        :type: int
        """

        self._burst_bytes = burst_bytes

    @property
    def timeout_seconds(self):
        """Gets the timeout_seconds of this ITFCPackets.  # noqa: E501


        :return: The timeout_seconds of this ITFCPackets.  # noqa: E501
        :rtype: int
        """
        return self._timeout_seconds

    @timeout_seconds.setter
    def timeout_seconds(self, timeout_seconds):
        """Sets the timeout_seconds of this ITFCPackets.


        :param timeout_seconds: The timeout_seconds of this ITFCPackets.  # noqa: E501
        :type: int
        """

        self._timeout_seconds = timeout_seconds

    @property
    def enabled(self):
        """Gets the enabled of this ITFCPackets.  # noqa: E501


        :return: The enabled of this ITFCPackets.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this ITFCPackets.


        :param enabled: The enabled of this ITFCPackets.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def payload_bytes(self):
        """Gets the payload_bytes of this ITFCPackets.  # noqa: E501


        :return: The payload_bytes of this ITFCPackets.  # noqa: E501
        :rtype: int
        """
        return self._payload_bytes

    @payload_bytes.setter
    def payload_bytes(self, payload_bytes):
        """Sets the payload_bytes of this ITFCPackets.


        :param payload_bytes: The payload_bytes of this ITFCPackets.  # noqa: E501
        :type: int
        """

        self._payload_bytes = payload_bytes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ITFCPackets, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ITFCPackets):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ITFCPackets):
            return True

        return self.to_dict() != other.to_dict()
