# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class IVLanTagsContainer(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'objects': 'list[IVlanBase]',
        'literals': 'list[IVlanTagLiteral]'
    }

    attribute_map = {
        'objects': 'objects',
        'literals': 'literals'
    }

    def __init__(self, objects=None, literals=None, _configuration=None):  # noqa: E501
        """IVLanTagsContainer - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._objects = None
        self._literals = None
        self.discriminator = None

        if objects is not None:
            self.objects = objects
        if literals is not None:
            self.literals = literals

    @property
    def objects(self):
        """Gets the objects of this IVLanTagsContainer.  # noqa: E501


        :return: The objects of this IVLanTagsContainer.  # noqa: E501
        :rtype: list[IVlanBase]
        """
        return self._objects

    @objects.setter
    def objects(self, objects):
        """Sets the objects of this IVLanTagsContainer.


        :param objects: The objects of this IVLanTagsContainer.  # noqa: E501
        :type: list[IVlanBase]
        """

        self._objects = objects

    @property
    def literals(self):
        """Gets the literals of this IVLanTagsContainer.  # noqa: E501


        :return: The literals of this IVLanTagsContainer.  # noqa: E501
        :rtype: list[IVlanTagLiteral]
        """
        return self._literals

    @literals.setter
    def literals(self, literals):
        """Sets the literals of this IVLanTagsContainer.


        :param literals: The literals of this IVLanTagsContainer.  # noqa: E501
        :type: list[IVlanTagLiteral]
        """

        self._literals = literals

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IVLanTagsContainer, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IVLanTagsContainer):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IVLanTagsContainer):
            return True

        return self.to_dict() != other.to_dict()
