# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class LLIndicator(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'pending': 'list[str]',
        'description': 'str',
        'raw_data': 'str',
        'type': 'str',
        'no_realized_incidents': 'int',
        'observables': 'list[LLObservable]',
        'stale': 'bool',
        'unsupported': 'bool',
        'feed_id': 'str',
        'effective_property': 'LLFeedProperty',
        'action': 'str',
        'id': 'str',
        'no_partial_incidents': 'int',
        'custom_property': 'LLFeedProperty',
        'updated_at': 'int',
        'equation': 'LLEquationNode',
        'version': 'str',
        'ttl': 'int',
        'tags': 'LLTags',
        'indicator_version': 'str',
        'expiration_time': 'int',
        'publish': 'bool',
        'name': 'str',
        'invalid': 'bool',
        'source_name': 'str',
        'inherited_property': 'LLFeedProperty',
        'file_id': 'str'
    }

    attribute_map = {
        'pending': 'pending',
        'description': 'description',
        'raw_data': 'rawData',
        'type': 'type',
        'no_realized_incidents': 'noRealizedIncidents',
        'observables': 'observables',
        'stale': 'stale',
        'unsupported': 'unsupported',
        'feed_id': 'feedId',
        'effective_property': 'effectiveProperty',
        'action': 'action',
        'id': 'id',
        'no_partial_incidents': 'noPartialIncidents',
        'custom_property': 'customProperty',
        'updated_at': 'updatedAt',
        'equation': 'equation',
        'version': 'version',
        'ttl': 'ttl',
        'tags': 'tags',
        'indicator_version': 'indicatorVersion',
        'expiration_time': 'expirationTime',
        'publish': 'publish',
        'name': 'name',
        'invalid': 'invalid',
        'source_name': 'sourceName',
        'inherited_property': 'inheritedProperty',
        'file_id': 'fileId'
    }

    def __init__(self, pending=None, description=None, raw_data=None, type=None, no_realized_incidents=None, observables=None, stale=None, unsupported=None, feed_id=None, effective_property=None, action=None, id=None, no_partial_incidents=None, custom_property=None, updated_at=None, equation=None, version=None, ttl=None, tags=None, indicator_version=None, expiration_time=None, publish=None, name=None, invalid=None, source_name=None, inherited_property=None, file_id=None, _configuration=None):  # noqa: E501
        """LLIndicator - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._pending = None
        self._description = None
        self._raw_data = None
        self._type = None
        self._no_realized_incidents = None
        self._observables = None
        self._stale = None
        self._unsupported = None
        self._feed_id = None
        self._effective_property = None
        self._action = None
        self._id = None
        self._no_partial_incidents = None
        self._custom_property = None
        self._updated_at = None
        self._equation = None
        self._version = None
        self._ttl = None
        self._tags = None
        self._indicator_version = None
        self._expiration_time = None
        self._publish = None
        self._name = None
        self._invalid = None
        self._source_name = None
        self._inherited_property = None
        self._file_id = None
        self.discriminator = None

        if pending is not None:
            self.pending = pending
        if description is not None:
            self.description = description
        if raw_data is not None:
            self.raw_data = raw_data
        if type is not None:
            self.type = type
        if no_realized_incidents is not None:
            self.no_realized_incidents = no_realized_incidents
        if observables is not None:
            self.observables = observables
        if stale is not None:
            self.stale = stale
        if unsupported is not None:
            self.unsupported = unsupported
        if feed_id is not None:
            self.feed_id = feed_id
        if effective_property is not None:
            self.effective_property = effective_property
        if action is not None:
            self.action = action
        if id is not None:
            self.id = id
        if no_partial_incidents is not None:
            self.no_partial_incidents = no_partial_incidents
        if custom_property is not None:
            self.custom_property = custom_property
        if updated_at is not None:
            self.updated_at = updated_at
        if equation is not None:
            self.equation = equation
        if version is not None:
            self.version = version
        if ttl is not None:
            self.ttl = ttl
        if tags is not None:
            self.tags = tags
        if indicator_version is not None:
            self.indicator_version = indicator_version
        if expiration_time is not None:
            self.expiration_time = expiration_time
        if publish is not None:
            self.publish = publish
        if name is not None:
            self.name = name
        if invalid is not None:
            self.invalid = invalid
        if source_name is not None:
            self.source_name = source_name
        if inherited_property is not None:
            self.inherited_property = inherited_property
        if file_id is not None:
            self.file_id = file_id

    @property
    def pending(self):
        """Gets the pending of this LLIndicator.  # noqa: E501


        :return: The pending of this LLIndicator.  # noqa: E501
        :rtype: list[str]
        """
        return self._pending

    @pending.setter
    def pending(self, pending):
        """Sets the pending of this LLIndicator.


        :param pending: The pending of this LLIndicator.  # noqa: E501
        :type: list[str]
        """

        self._pending = pending

    @property
    def description(self):
        """Gets the description of this LLIndicator.  # noqa: E501


        :return: The description of this LLIndicator.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this LLIndicator.


        :param description: The description of this LLIndicator.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def raw_data(self):
        """Gets the raw_data of this LLIndicator.  # noqa: E501


        :return: The raw_data of this LLIndicator.  # noqa: E501
        :rtype: str
        """
        return self._raw_data

    @raw_data.setter
    def raw_data(self, raw_data):
        """Sets the raw_data of this LLIndicator.


        :param raw_data: The raw_data of this LLIndicator.  # noqa: E501
        :type: str
        """

        self._raw_data = raw_data

    @property
    def type(self):
        """Gets the type of this LLIndicator.  # noqa: E501


        :return: The type of this LLIndicator.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this LLIndicator.


        :param type: The type of this LLIndicator.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def no_realized_incidents(self):
        """Gets the no_realized_incidents of this LLIndicator.  # noqa: E501


        :return: The no_realized_incidents of this LLIndicator.  # noqa: E501
        :rtype: int
        """
        return self._no_realized_incidents

    @no_realized_incidents.setter
    def no_realized_incidents(self, no_realized_incidents):
        """Sets the no_realized_incidents of this LLIndicator.


        :param no_realized_incidents: The no_realized_incidents of this LLIndicator.  # noqa: E501
        :type: int
        """

        self._no_realized_incidents = no_realized_incidents

    @property
    def observables(self):
        """Gets the observables of this LLIndicator.  # noqa: E501


        :return: The observables of this LLIndicator.  # noqa: E501
        :rtype: list[LLObservable]
        """
        return self._observables

    @observables.setter
    def observables(self, observables):
        """Sets the observables of this LLIndicator.


        :param observables: The observables of this LLIndicator.  # noqa: E501
        :type: list[LLObservable]
        """

        self._observables = observables

    @property
    def stale(self):
        """Gets the stale of this LLIndicator.  # noqa: E501


        :return: The stale of this LLIndicator.  # noqa: E501
        :rtype: bool
        """
        return self._stale

    @stale.setter
    def stale(self, stale):
        """Sets the stale of this LLIndicator.


        :param stale: The stale of this LLIndicator.  # noqa: E501
        :type: bool
        """

        self._stale = stale

    @property
    def unsupported(self):
        """Gets the unsupported of this LLIndicator.  # noqa: E501


        :return: The unsupported of this LLIndicator.  # noqa: E501
        :rtype: bool
        """
        return self._unsupported

    @unsupported.setter
    def unsupported(self, unsupported):
        """Sets the unsupported of this LLIndicator.


        :param unsupported: The unsupported of this LLIndicator.  # noqa: E501
        :type: bool
        """

        self._unsupported = unsupported

    @property
    def feed_id(self):
        """Gets the feed_id of this LLIndicator.  # noqa: E501


        :return: The feed_id of this LLIndicator.  # noqa: E501
        :rtype: str
        """
        return self._feed_id

    @feed_id.setter
    def feed_id(self, feed_id):
        """Sets the feed_id of this LLIndicator.


        :param feed_id: The feed_id of this LLIndicator.  # noqa: E501
        :type: str
        """

        self._feed_id = feed_id

    @property
    def effective_property(self):
        """Gets the effective_property of this LLIndicator.  # noqa: E501


        :return: The effective_property of this LLIndicator.  # noqa: E501
        :rtype: LLFeedProperty
        """
        return self._effective_property

    @effective_property.setter
    def effective_property(self, effective_property):
        """Sets the effective_property of this LLIndicator.


        :param effective_property: The effective_property of this LLIndicator.  # noqa: E501
        :type: LLFeedProperty
        """

        self._effective_property = effective_property

    @property
    def action(self):
        """Gets the action of this LLIndicator.  # noqa: E501


        :return: The action of this LLIndicator.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this LLIndicator.


        :param action: The action of this LLIndicator.  # noqa: E501
        :type: str
        """

        self._action = action

    @property
    def id(self):
        """Gets the id of this LLIndicator.  # noqa: E501


        :return: The id of this LLIndicator.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this LLIndicator.


        :param id: The id of this LLIndicator.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def no_partial_incidents(self):
        """Gets the no_partial_incidents of this LLIndicator.  # noqa: E501


        :return: The no_partial_incidents of this LLIndicator.  # noqa: E501
        :rtype: int
        """
        return self._no_partial_incidents

    @no_partial_incidents.setter
    def no_partial_incidents(self, no_partial_incidents):
        """Sets the no_partial_incidents of this LLIndicator.


        :param no_partial_incidents: The no_partial_incidents of this LLIndicator.  # noqa: E501
        :type: int
        """

        self._no_partial_incidents = no_partial_incidents

    @property
    def custom_property(self):
        """Gets the custom_property of this LLIndicator.  # noqa: E501


        :return: The custom_property of this LLIndicator.  # noqa: E501
        :rtype: LLFeedProperty
        """
        return self._custom_property

    @custom_property.setter
    def custom_property(self, custom_property):
        """Sets the custom_property of this LLIndicator.


        :param custom_property: The custom_property of this LLIndicator.  # noqa: E501
        :type: LLFeedProperty
        """

        self._custom_property = custom_property

    @property
    def updated_at(self):
        """Gets the updated_at of this LLIndicator.  # noqa: E501


        :return: The updated_at of this LLIndicator.  # noqa: E501
        :rtype: int
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this LLIndicator.


        :param updated_at: The updated_at of this LLIndicator.  # noqa: E501
        :type: int
        """

        self._updated_at = updated_at

    @property
    def equation(self):
        """Gets the equation of this LLIndicator.  # noqa: E501


        :return: The equation of this LLIndicator.  # noqa: E501
        :rtype: LLEquationNode
        """
        return self._equation

    @equation.setter
    def equation(self, equation):
        """Sets the equation of this LLIndicator.


        :param equation: The equation of this LLIndicator.  # noqa: E501
        :type: LLEquationNode
        """

        self._equation = equation

    @property
    def version(self):
        """Gets the version of this LLIndicator.  # noqa: E501


        :return: The version of this LLIndicator.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this LLIndicator.


        :param version: The version of this LLIndicator.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def ttl(self):
        """Gets the ttl of this LLIndicator.  # noqa: E501


        :return: The ttl of this LLIndicator.  # noqa: E501
        :rtype: int
        """
        return self._ttl

    @ttl.setter
    def ttl(self, ttl):
        """Sets the ttl of this LLIndicator.


        :param ttl: The ttl of this LLIndicator.  # noqa: E501
        :type: int
        """

        self._ttl = ttl

    @property
    def tags(self):
        """Gets the tags of this LLIndicator.  # noqa: E501


        :return: The tags of this LLIndicator.  # noqa: E501
        :rtype: LLTags
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this LLIndicator.


        :param tags: The tags of this LLIndicator.  # noqa: E501
        :type: LLTags
        """

        self._tags = tags

    @property
    def indicator_version(self):
        """Gets the indicator_version of this LLIndicator.  # noqa: E501


        :return: The indicator_version of this LLIndicator.  # noqa: E501
        :rtype: str
        """
        return self._indicator_version

    @indicator_version.setter
    def indicator_version(self, indicator_version):
        """Sets the indicator_version of this LLIndicator.


        :param indicator_version: The indicator_version of this LLIndicator.  # noqa: E501
        :type: str
        """

        self._indicator_version = indicator_version

    @property
    def expiration_time(self):
        """Gets the expiration_time of this LLIndicator.  # noqa: E501


        :return: The expiration_time of this LLIndicator.  # noqa: E501
        :rtype: int
        """
        return self._expiration_time

    @expiration_time.setter
    def expiration_time(self, expiration_time):
        """Sets the expiration_time of this LLIndicator.


        :param expiration_time: The expiration_time of this LLIndicator.  # noqa: E501
        :type: int
        """

        self._expiration_time = expiration_time

    @property
    def publish(self):
        """Gets the publish of this LLIndicator.  # noqa: E501


        :return: The publish of this LLIndicator.  # noqa: E501
        :rtype: bool
        """
        return self._publish

    @publish.setter
    def publish(self, publish):
        """Sets the publish of this LLIndicator.


        :param publish: The publish of this LLIndicator.  # noqa: E501
        :type: bool
        """

        self._publish = publish

    @property
    def name(self):
        """Gets the name of this LLIndicator.  # noqa: E501


        :return: The name of this LLIndicator.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this LLIndicator.


        :param name: The name of this LLIndicator.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def invalid(self):
        """Gets the invalid of this LLIndicator.  # noqa: E501


        :return: The invalid of this LLIndicator.  # noqa: E501
        :rtype: bool
        """
        return self._invalid

    @invalid.setter
    def invalid(self, invalid):
        """Sets the invalid of this LLIndicator.


        :param invalid: The invalid of this LLIndicator.  # noqa: E501
        :type: bool
        """

        self._invalid = invalid

    @property
    def source_name(self):
        """Gets the source_name of this LLIndicator.  # noqa: E501


        :return: The source_name of this LLIndicator.  # noqa: E501
        :rtype: str
        """
        return self._source_name

    @source_name.setter
    def source_name(self, source_name):
        """Sets the source_name of this LLIndicator.


        :param source_name: The source_name of this LLIndicator.  # noqa: E501
        :type: str
        """

        self._source_name = source_name

    @property
    def inherited_property(self):
        """Gets the inherited_property of this LLIndicator.  # noqa: E501


        :return: The inherited_property of this LLIndicator.  # noqa: E501
        :rtype: LLFeedProperty
        """
        return self._inherited_property

    @inherited_property.setter
    def inherited_property(self, inherited_property):
        """Sets the inherited_property of this LLIndicator.


        :param inherited_property: The inherited_property of this LLIndicator.  # noqa: E501
        :type: LLFeedProperty
        """

        self._inherited_property = inherited_property

    @property
    def file_id(self):
        """Gets the file_id of this LLIndicator.  # noqa: E501


        :return: The file_id of this LLIndicator.  # noqa: E501
        :rtype: str
        """
        return self._file_id

    @file_id.setter
    def file_id(self, file_id):
        """Sets the file_id of this LLIndicator.


        :param file_id: The file_id of this LLIndicator.  # noqa: E501
        :type: str
        """

        self._file_id = file_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LLIndicator, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LLIndicator):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LLIndicator):
            return True

        return self.to_dict() != other.to_dict()
