# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class LLObservationData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'action_taken': 'str',
        'misc_data': 'LLMiscData',
        'type': 'str',
        'value': 'str'
    }

    attribute_map = {
        'action_taken': 'actionTaken',
        'misc_data': 'miscData',
        'type': 'type',
        'value': 'value'
    }

    def __init__(self, action_taken=None, misc_data=None, type=None, value=None, _configuration=None):  # noqa: E501
        """LLObservationData - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._action_taken = None
        self._misc_data = None
        self._type = None
        self._value = None
        self.discriminator = None

        if action_taken is not None:
            self.action_taken = action_taken
        if misc_data is not None:
            self.misc_data = misc_data
        if type is not None:
            self.type = type
        if value is not None:
            self.value = value

    @property
    def action_taken(self):
        """Gets the action_taken of this LLObservationData.  # noqa: E501


        :return: The action_taken of this LLObservationData.  # noqa: E501
        :rtype: str
        """
        return self._action_taken

    @action_taken.setter
    def action_taken(self, action_taken):
        """Sets the action_taken of this LLObservationData.


        :param action_taken: The action_taken of this LLObservationData.  # noqa: E501
        :type: str
        """

        self._action_taken = action_taken

    @property
    def misc_data(self):
        """Gets the misc_data of this LLObservationData.  # noqa: E501


        :return: The misc_data of this LLObservationData.  # noqa: E501
        :rtype: LLMiscData
        """
        return self._misc_data

    @misc_data.setter
    def misc_data(self, misc_data):
        """Sets the misc_data of this LLObservationData.


        :param misc_data: The misc_data of this LLObservationData.  # noqa: E501
        :type: LLMiscData
        """

        self._misc_data = misc_data

    @property
    def type(self):
        """Gets the type of this LLObservationData.  # noqa: E501


        :return: The type of this LLObservationData.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this LLObservationData.


        :param type: The type of this LLObservationData.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def value(self):
        """Gets the value of this LLObservationData.  # noqa: E501


        :return: The value of this LLObservationData.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this LLObservationData.


        :param value: The value of this LLObservationData.  # noqa: E501
        :type: str
        """

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LLObservationData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LLObservationData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LLObservationData):
            return True

        return self.to_dict() != other.to_dict()
