# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class Ospfv3InterfacePolicyModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'metadata': 'Metadata',
        'name': 'str',
        'device_interface': 'IFTDInterface',
        'description': 'str',
        'links': 'ILinks',
        'id': 'str',
        'type': 'str',
        'version': 'str',
        'properties': 'IOspfv3InterfaceConfiguration',
        'authentication': 'IOspfv3InterfaceAuthenticationBase'
    }

    attribute_map = {
        'metadata': 'metadata',
        'name': 'name',
        'device_interface': 'deviceInterface',
        'description': 'description',
        'links': 'links',
        'id': 'id',
        'type': 'type',
        'version': 'version',
        'properties': 'properties',
        'authentication': 'authentication'
    }

    def __init__(self, metadata=None, name=None, device_interface=None, description=None, links=None, id=None, type=None, version=None, properties=None, authentication=None, _configuration=None):  # noqa: E501
        """Ospfv3InterfacePolicyModel - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._metadata = None
        self._name = None
        self._device_interface = None
        self._description = None
        self._links = None
        self._id = None
        self._type = None
        self._version = None
        self._properties = None
        self._authentication = None
        self.discriminator = None

        if metadata is not None:
            self.metadata = metadata
        if name is not None:
            self.name = name
        self.device_interface = device_interface
        if description is not None:
            self.description = description
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version
        if properties is not None:
            self.properties = properties
        if authentication is not None:
            self.authentication = authentication

    @property
    def metadata(self):
        """Gets the metadata of this Ospfv3InterfacePolicyModel.  # noqa: E501


        :return: The metadata of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :rtype: Metadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this Ospfv3InterfacePolicyModel.


        :param metadata: The metadata of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :type: Metadata
        """

        self._metadata = metadata

    @property
    def name(self):
        """Gets the name of this Ospfv3InterfacePolicyModel.  # noqa: E501


        :return: The name of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Ospfv3InterfacePolicyModel.


        :param name: The name of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def device_interface(self):
        """Gets the device_interface of this Ospfv3InterfacePolicyModel.  # noqa: E501


        :return: The device_interface of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :rtype: IFTDInterface
        """
        return self._device_interface

    @device_interface.setter
    def device_interface(self, device_interface):
        """Sets the device_interface of this Ospfv3InterfacePolicyModel.


        :param device_interface: The device_interface of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :type: IFTDInterface
        """
        if self._configuration.client_side_validation and device_interface is None:
            raise ValueError("Invalid value for `device_interface`, must not be `None`")  # noqa: E501

        self._device_interface = device_interface

    @property
    def description(self):
        """Gets the description of this Ospfv3InterfacePolicyModel.  # noqa: E501


        :return: The description of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Ospfv3InterfacePolicyModel.


        :param description: The description of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def links(self):
        """Gets the links of this Ospfv3InterfacePolicyModel.  # noqa: E501


        :return: The links of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Ospfv3InterfacePolicyModel.


        :param links: The links of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this Ospfv3InterfacePolicyModel.  # noqa: E501


        :return: The id of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Ospfv3InterfacePolicyModel.


        :param id: The id of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this Ospfv3InterfacePolicyModel.  # noqa: E501


        :return: The type of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Ospfv3InterfacePolicyModel.


        :param type: The type of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this Ospfv3InterfacePolicyModel.  # noqa: E501


        :return: The version of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this Ospfv3InterfacePolicyModel.


        :param version: The version of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def properties(self):
        """Gets the properties of this Ospfv3InterfacePolicyModel.  # noqa: E501


        :return: The properties of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :rtype: IOspfv3InterfaceConfiguration
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this Ospfv3InterfacePolicyModel.


        :param properties: The properties of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :type: IOspfv3InterfaceConfiguration
        """

        self._properties = properties

    @property
    def authentication(self):
        """Gets the authentication of this Ospfv3InterfacePolicyModel.  # noqa: E501


        :return: The authentication of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :rtype: IOspfv3InterfaceAuthenticationBase
        """
        return self._authentication

    @authentication.setter
    def authentication(self, authentication):
        """Sets the authentication of this Ospfv3InterfacePolicyModel.


        :param authentication: The authentication of this Ospfv3InterfacePolicyModel.  # noqa: E501
        :type: IOspfv3InterfaceAuthenticationBase
        """

        self._authentication = authentication

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Ospfv3InterfacePolicyModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Ospfv3InterfacePolicyModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Ospfv3InterfacePolicyModel):
            return True

        return self.to_dict() != other.to_dict()
