# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class Ospfv3PolicyModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'metadata': 'Metadata',
        'process_id': 'int',
        'process_configuration': 'IOspfv3ProcessModel',
        'name': 'str',
        'summary_prefix': 'list[IOspfv3SummaryPrefix]',
        'description': 'str',
        'links': 'ILinks',
        'areas': 'list[IOspfv3Area]',
        'redistribute_protocols': 'list[IRedistributeProtocolBase]',
        'id': 'str',
        'type': 'str',
        'version': 'str'
    }

    attribute_map = {
        'metadata': 'metadata',
        'process_id': 'processId',
        'process_configuration': 'processConfiguration',
        'name': 'name',
        'summary_prefix': 'summaryPrefix',
        'description': 'description',
        'links': 'links',
        'areas': 'areas',
        'redistribute_protocols': 'redistributeProtocols',
        'id': 'id',
        'type': 'type',
        'version': 'version'
    }

    def __init__(self, metadata=None, process_id=None, process_configuration=None, name=None, summary_prefix=None, description=None, links=None, areas=None, redistribute_protocols=None, id=None, type=None, version=None, _configuration=None):  # noqa: E501
        """Ospfv3PolicyModel - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._metadata = None
        self._process_id = None
        self._process_configuration = None
        self._name = None
        self._summary_prefix = None
        self._description = None
        self._links = None
        self._areas = None
        self._redistribute_protocols = None
        self._id = None
        self._type = None
        self._version = None
        self.discriminator = None

        if metadata is not None:
            self.metadata = metadata
        if process_id is not None:
            self.process_id = process_id
        if process_configuration is not None:
            self.process_configuration = process_configuration
        if name is not None:
            self.name = name
        if summary_prefix is not None:
            self.summary_prefix = summary_prefix
        if description is not None:
            self.description = description
        if links is not None:
            self.links = links
        if areas is not None:
            self.areas = areas
        if redistribute_protocols is not None:
            self.redistribute_protocols = redistribute_protocols
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version

    @property
    def metadata(self):
        """Gets the metadata of this Ospfv3PolicyModel.  # noqa: E501


        :return: The metadata of this Ospfv3PolicyModel.  # noqa: E501
        :rtype: Metadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this Ospfv3PolicyModel.


        :param metadata: The metadata of this Ospfv3PolicyModel.  # noqa: E501
        :type: Metadata
        """

        self._metadata = metadata

    @property
    def process_id(self):
        """Gets the process_id of this Ospfv3PolicyModel.  # noqa: E501


        :return: The process_id of this Ospfv3PolicyModel.  # noqa: E501
        :rtype: int
        """
        return self._process_id

    @process_id.setter
    def process_id(self, process_id):
        """Sets the process_id of this Ospfv3PolicyModel.


        :param process_id: The process_id of this Ospfv3PolicyModel.  # noqa: E501
        :type: int
        """

        self._process_id = process_id

    @property
    def process_configuration(self):
        """Gets the process_configuration of this Ospfv3PolicyModel.  # noqa: E501


        :return: The process_configuration of this Ospfv3PolicyModel.  # noqa: E501
        :rtype: IOspfv3ProcessModel
        """
        return self._process_configuration

    @process_configuration.setter
    def process_configuration(self, process_configuration):
        """Sets the process_configuration of this Ospfv3PolicyModel.


        :param process_configuration: The process_configuration of this Ospfv3PolicyModel.  # noqa: E501
        :type: IOspfv3ProcessModel
        """

        self._process_configuration = process_configuration

    @property
    def name(self):
        """Gets the name of this Ospfv3PolicyModel.  # noqa: E501


        :return: The name of this Ospfv3PolicyModel.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Ospfv3PolicyModel.


        :param name: The name of this Ospfv3PolicyModel.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def summary_prefix(self):
        """Gets the summary_prefix of this Ospfv3PolicyModel.  # noqa: E501


        :return: The summary_prefix of this Ospfv3PolicyModel.  # noqa: E501
        :rtype: list[IOspfv3SummaryPrefix]
        """
        return self._summary_prefix

    @summary_prefix.setter
    def summary_prefix(self, summary_prefix):
        """Sets the summary_prefix of this Ospfv3PolicyModel.


        :param summary_prefix: The summary_prefix of this Ospfv3PolicyModel.  # noqa: E501
        :type: list[IOspfv3SummaryPrefix]
        """

        self._summary_prefix = summary_prefix

    @property
    def description(self):
        """Gets the description of this Ospfv3PolicyModel.  # noqa: E501


        :return: The description of this Ospfv3PolicyModel.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Ospfv3PolicyModel.


        :param description: The description of this Ospfv3PolicyModel.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def links(self):
        """Gets the links of this Ospfv3PolicyModel.  # noqa: E501


        :return: The links of this Ospfv3PolicyModel.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Ospfv3PolicyModel.


        :param links: The links of this Ospfv3PolicyModel.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def areas(self):
        """Gets the areas of this Ospfv3PolicyModel.  # noqa: E501


        :return: The areas of this Ospfv3PolicyModel.  # noqa: E501
        :rtype: list[IOspfv3Area]
        """
        return self._areas

    @areas.setter
    def areas(self, areas):
        """Sets the areas of this Ospfv3PolicyModel.


        :param areas: The areas of this Ospfv3PolicyModel.  # noqa: E501
        :type: list[IOspfv3Area]
        """

        self._areas = areas

    @property
    def redistribute_protocols(self):
        """Gets the redistribute_protocols of this Ospfv3PolicyModel.  # noqa: E501


        :return: The redistribute_protocols of this Ospfv3PolicyModel.  # noqa: E501
        :rtype: list[IRedistributeProtocolBase]
        """
        return self._redistribute_protocols

    @redistribute_protocols.setter
    def redistribute_protocols(self, redistribute_protocols):
        """Sets the redistribute_protocols of this Ospfv3PolicyModel.


        :param redistribute_protocols: The redistribute_protocols of this Ospfv3PolicyModel.  # noqa: E501
        :type: list[IRedistributeProtocolBase]
        """

        self._redistribute_protocols = redistribute_protocols

    @property
    def id(self):
        """Gets the id of this Ospfv3PolicyModel.  # noqa: E501


        :return: The id of this Ospfv3PolicyModel.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Ospfv3PolicyModel.


        :param id: The id of this Ospfv3PolicyModel.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this Ospfv3PolicyModel.  # noqa: E501


        :return: The type of this Ospfv3PolicyModel.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Ospfv3PolicyModel.


        :param type: The type of this Ospfv3PolicyModel.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this Ospfv3PolicyModel.  # noqa: E501


        :return: The version of this Ospfv3PolicyModel.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this Ospfv3PolicyModel.


        :param version: The version of this Ospfv3PolicyModel.  # noqa: E501
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Ospfv3PolicyModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Ospfv3PolicyModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Ospfv3PolicyModel):
            return True

        return self.to_dict() != other.to_dict()
