# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class PreferLifeTime(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'duration': 'Duration',
        'expiration_life_time': 'ExpirationLifeTime'
    }

    attribute_map = {
        'duration': 'duration',
        'expiration_life_time': 'expirationLifeTime'
    }

    def __init__(self, duration=None, expiration_life_time=None, _configuration=None):  # noqa: E501
        """PreferLifeTime - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._duration = None
        self._expiration_life_time = None
        self.discriminator = None

        if duration is not None:
            self.duration = duration
        if expiration_life_time is not None:
            self.expiration_life_time = expiration_life_time

    @property
    def duration(self):
        """Gets the duration of this PreferLifeTime.  # noqa: E501


        :return: The duration of this PreferLifeTime.  # noqa: E501
        :rtype: Duration
        """
        return self._duration

    @duration.setter
    def duration(self, duration):
        """Sets the duration of this PreferLifeTime.


        :param duration: The duration of this PreferLifeTime.  # noqa: E501
        :type: Duration
        """

        self._duration = duration

    @property
    def expiration_life_time(self):
        """Gets the expiration_life_time of this PreferLifeTime.  # noqa: E501


        :return: The expiration_life_time of this PreferLifeTime.  # noqa: E501
        :rtype: ExpirationLifeTime
        """
        return self._expiration_life_time

    @expiration_life_time.setter
    def expiration_life_time(self, expiration_life_time):
        """Sets the expiration_life_time of this PreferLifeTime.


        :param expiration_life_time: The expiration_life_time of this PreferLifeTime.  # noqa: E501
        :type: ExpirationLifeTime
        """

        self._expiration_life_time = expiration_life_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PreferLifeTime, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PreferLifeTime):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PreferLifeTime):
            return True

        return self.to_dict() != other.to_dict()
