# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class PrefilterRule(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'metadata': 'Metadata',
        'bidirectional': 'bool',
        'source_interfaces': 'ISecurityZoneContainer',
        'encapsulation_ports': 'list[str]',
        'snmp_config': 'ISNMPConfig',
        'time_range_objects': 'list[ITimeRangeModel]',
        'source_networks': 'INetworkObjectsContainer',
        'syslog_severity': 'str',
        'destination_interfaces': 'ISecurityZoneContainer',
        'tunnel_zone': 'ISourceZoneContainer',
        'type': 'str',
        'enable_syslog': 'bool',
        'enabled': 'bool',
        'syslog_config': 'ISyslogConfig',
        'rule_type': 'str',
        'destination_networks': 'INetworkObjectsContainer',
        'action': 'str',
        'links': 'ILinks',
        'id': 'str',
        'log_end': 'bool',
        'log_begin': 'bool',
        'send_events_to_fmc': 'bool',
        'destination_ports': 'IPortObjectsContainer',
        'source_ports': 'IPortObjectsContainer',
        'version': 'str',
        'new_comments': 'list[str]',
        'comment_history_list': 'list[ICommentHistory]',
        'name': 'str',
        'vlan_tags': 'IVLanTagsContainer'
    }

    attribute_map = {
        'metadata': 'metadata',
        'bidirectional': 'bidirectional',
        'source_interfaces': 'sourceInterfaces',
        'encapsulation_ports': 'encapsulationPorts',
        'snmp_config': 'snmpConfig',
        'time_range_objects': 'timeRangeObjects',
        'source_networks': 'sourceNetworks',
        'syslog_severity': 'syslogSeverity',
        'destination_interfaces': 'destinationInterfaces',
        'tunnel_zone': 'tunnelZone',
        'type': 'type',
        'enable_syslog': 'enableSyslog',
        'enabled': 'enabled',
        'syslog_config': 'syslogConfig',
        'rule_type': 'ruleType',
        'destination_networks': 'destinationNetworks',
        'action': 'action',
        'links': 'links',
        'id': 'id',
        'log_end': 'logEnd',
        'log_begin': 'logBegin',
        'send_events_to_fmc': 'sendEventsToFMC',
        'destination_ports': 'destinationPorts',
        'source_ports': 'sourcePorts',
        'version': 'version',
        'new_comments': 'newComments',
        'comment_history_list': 'commentHistoryList',
        'name': 'name',
        'vlan_tags': 'vlanTags'
    }

    def __init__(self, metadata=None, bidirectional=None, source_interfaces=None, encapsulation_ports=None, snmp_config=None, time_range_objects=None, source_networks=None, syslog_severity=None, destination_interfaces=None, tunnel_zone=None, type=None, enable_syslog=None, enabled=None, syslog_config=None, rule_type=None, destination_networks=None, action=None, links=None, id=None, log_end=None, log_begin=None, send_events_to_fmc=None, destination_ports=None, source_ports=None, version=None, new_comments=None, comment_history_list=None, name=None, vlan_tags=None, _configuration=None):  # noqa: E501
        """PrefilterRule - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._metadata = None
        self._bidirectional = None
        self._source_interfaces = None
        self._encapsulation_ports = None
        self._snmp_config = None
        self._time_range_objects = None
        self._source_networks = None
        self._syslog_severity = None
        self._destination_interfaces = None
        self._tunnel_zone = None
        self._type = None
        self._enable_syslog = None
        self._enabled = None
        self._syslog_config = None
        self._rule_type = None
        self._destination_networks = None
        self._action = None
        self._links = None
        self._id = None
        self._log_end = None
        self._log_begin = None
        self._send_events_to_fmc = None
        self._destination_ports = None
        self._source_ports = None
        self._version = None
        self._new_comments = None
        self._comment_history_list = None
        self._name = None
        self._vlan_tags = None
        self.discriminator = None

        if metadata is not None:
            self.metadata = metadata
        if bidirectional is not None:
            self.bidirectional = bidirectional
        if source_interfaces is not None:
            self.source_interfaces = source_interfaces
        if encapsulation_ports is not None:
            self.encapsulation_ports = encapsulation_ports
        if snmp_config is not None:
            self.snmp_config = snmp_config
        if time_range_objects is not None:
            self.time_range_objects = time_range_objects
        if source_networks is not None:
            self.source_networks = source_networks
        if syslog_severity is not None:
            self.syslog_severity = syslog_severity
        if destination_interfaces is not None:
            self.destination_interfaces = destination_interfaces
        if tunnel_zone is not None:
            self.tunnel_zone = tunnel_zone
        if type is not None:
            self.type = type
        if enable_syslog is not None:
            self.enable_syslog = enable_syslog
        if enabled is not None:
            self.enabled = enabled
        if syslog_config is not None:
            self.syslog_config = syslog_config
        self.rule_type = rule_type
        if destination_networks is not None:
            self.destination_networks = destination_networks
        self.action = action
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if log_end is not None:
            self.log_end = log_end
        if log_begin is not None:
            self.log_begin = log_begin
        if send_events_to_fmc is not None:
            self.send_events_to_fmc = send_events_to_fmc
        if destination_ports is not None:
            self.destination_ports = destination_ports
        if source_ports is not None:
            self.source_ports = source_ports
        if version is not None:
            self.version = version
        if new_comments is not None:
            self.new_comments = new_comments
        if comment_history_list is not None:
            self.comment_history_list = comment_history_list
        if name is not None:
            self.name = name
        if vlan_tags is not None:
            self.vlan_tags = vlan_tags

    @property
    def metadata(self):
        """Gets the metadata of this PrefilterRule.  # noqa: E501

        Object representing metadata attributes for the prefilter rule.  # noqa: E501

        :return: The metadata of this PrefilterRule.  # noqa: E501
        :rtype: Metadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this PrefilterRule.

        Object representing metadata attributes for the prefilter rule.  # noqa: E501

        :param metadata: The metadata of this PrefilterRule.  # noqa: E501
        :type: Metadata
        """

        self._metadata = metadata

    @property
    def bidirectional(self):
        """Gets the bidirectional of this PrefilterRule.  # noqa: E501

        Boolean indicating whether the rule is bidirectional.  # noqa: E501

        :return: The bidirectional of this PrefilterRule.  # noqa: E501
        :rtype: bool
        """
        return self._bidirectional

    @bidirectional.setter
    def bidirectional(self, bidirectional):
        """Sets the bidirectional of this PrefilterRule.

        Boolean indicating whether the rule is bidirectional.  # noqa: E501

        :param bidirectional: The bidirectional of this PrefilterRule.  # noqa: E501
        :type: bool
        """

        self._bidirectional = bidirectional

    @property
    def source_interfaces(self):
        """Gets the source_interfaces of this PrefilterRule.  # noqa: E501

        Object representing source interfaces for prefilter rule.  # noqa: E501

        :return: The source_interfaces of this PrefilterRule.  # noqa: E501
        :rtype: ISecurityZoneContainer
        """
        return self._source_interfaces

    @source_interfaces.setter
    def source_interfaces(self, source_interfaces):
        """Sets the source_interfaces of this PrefilterRule.

        Object representing source interfaces for prefilter rule.  # noqa: E501

        :param source_interfaces: The source_interfaces of this PrefilterRule.  # noqa: E501
        :type: ISecurityZoneContainer
        """

        self._source_interfaces = source_interfaces

    @property
    def encapsulation_ports(self):
        """Gets the encapsulation_ports of this PrefilterRule.  # noqa: E501

        Object representing the encapsulation ports to be used in prefilter rule.  # noqa: E501

        :return: The encapsulation_ports of this PrefilterRule.  # noqa: E501
        :rtype: list[str]
        """
        return self._encapsulation_ports

    @encapsulation_ports.setter
    def encapsulation_ports(self, encapsulation_ports):
        """Sets the encapsulation_ports of this PrefilterRule.

        Object representing the encapsulation ports to be used in prefilter rule.  # noqa: E501

        :param encapsulation_ports: The encapsulation_ports of this PrefilterRule.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["GRE", "IP_IN_IP", "IPV6_IN_IP", "TEREDO"]  # noqa: E501
        if (self._configuration.client_side_validation and
                not set(encapsulation_ports).issubset(set(allowed_values))):  # noqa: E501
            raise ValueError(
                "Invalid values for `encapsulation_ports` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(encapsulation_ports) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._encapsulation_ports = encapsulation_ports

    @property
    def snmp_config(self):
        """Gets the snmp_config of this PrefilterRule.  # noqa: E501

        Object representing the SNMP alert associated with the prefilter rule.  # noqa: E501

        :return: The snmp_config of this PrefilterRule.  # noqa: E501
        :rtype: ISNMPConfig
        """
        return self._snmp_config

    @snmp_config.setter
    def snmp_config(self, snmp_config):
        """Sets the snmp_config of this PrefilterRule.

        Object representing the SNMP alert associated with the prefilter rule.  # noqa: E501

        :param snmp_config: The snmp_config of this PrefilterRule.  # noqa: E501
        :type: ISNMPConfig
        """

        self._snmp_config = snmp_config

    @property
    def time_range_objects(self):
        """Gets the time_range_objects of this PrefilterRule.  # noqa: E501


        :return: The time_range_objects of this PrefilterRule.  # noqa: E501
        :rtype: list[ITimeRangeModel]
        """
        return self._time_range_objects

    @time_range_objects.setter
    def time_range_objects(self, time_range_objects):
        """Sets the time_range_objects of this PrefilterRule.


        :param time_range_objects: The time_range_objects of this PrefilterRule.  # noqa: E501
        :type: list[ITimeRangeModel]
        """

        self._time_range_objects = time_range_objects

    @property
    def source_networks(self):
        """Gets the source_networks of this PrefilterRule.  # noqa: E501

        Object representing source networks selected for the prefilter rule.  # noqa: E501

        :return: The source_networks of this PrefilterRule.  # noqa: E501
        :rtype: INetworkObjectsContainer
        """
        return self._source_networks

    @source_networks.setter
    def source_networks(self, source_networks):
        """Sets the source_networks of this PrefilterRule.

        Object representing source networks selected for the prefilter rule.  # noqa: E501

        :param source_networks: The source_networks of this PrefilterRule.  # noqa: E501
        :type: INetworkObjectsContainer
        """

        self._source_networks = source_networks

    @property
    def syslog_severity(self):
        """Gets the syslog_severity of this PrefilterRule.  # noqa: E501

        Specifies the Override Severity if alerts are being sent to default syslog configuration. One of: ALERT | CRIT | DEBUG | EMERG | ERR | INFO | NOTICE | WARNING.  # noqa: E501

        :return: The syslog_severity of this PrefilterRule.  # noqa: E501
        :rtype: str
        """
        return self._syslog_severity

    @syslog_severity.setter
    def syslog_severity(self, syslog_severity):
        """Sets the syslog_severity of this PrefilterRule.

        Specifies the Override Severity if alerts are being sent to default syslog configuration. One of: ALERT | CRIT | DEBUG | EMERG | ERR | INFO | NOTICE | WARNING.  # noqa: E501

        :param syslog_severity: The syslog_severity of this PrefilterRule.  # noqa: E501
        :type: str
        """
        allowed_values = ["ALERT", "CRIT", "DEBUG", "EMERG", "ERR", "INFO", "NOTICE", "WARNING"]  # noqa: E501
        if (self._configuration.client_side_validation and
                syslog_severity not in allowed_values):
            raise ValueError(
                "Invalid value for `syslog_severity` ({0}), must be one of {1}"  # noqa: E501
                .format(syslog_severity, allowed_values)
            )

        self._syslog_severity = syslog_severity

    @property
    def destination_interfaces(self):
        """Gets the destination_interfaces of this PrefilterRule.  # noqa: E501

        Object representing destination interfaces for prefilter rule.  # noqa: E501

        :return: The destination_interfaces of this PrefilterRule.  # noqa: E501
        :rtype: ISecurityZoneContainer
        """
        return self._destination_interfaces

    @destination_interfaces.setter
    def destination_interfaces(self, destination_interfaces):
        """Sets the destination_interfaces of this PrefilterRule.

        Object representing destination interfaces for prefilter rule.  # noqa: E501

        :param destination_interfaces: The destination_interfaces of this PrefilterRule.  # noqa: E501
        :type: ISecurityZoneContainer
        """

        self._destination_interfaces = destination_interfaces

    @property
    def tunnel_zone(self):
        """Gets the tunnel_zone of this PrefilterRule.  # noqa: E501

        Object Representing tunnel zones for prefilter rule.  # noqa: E501

        :return: The tunnel_zone of this PrefilterRule.  # noqa: E501
        :rtype: ISourceZoneContainer
        """
        return self._tunnel_zone

    @tunnel_zone.setter
    def tunnel_zone(self, tunnel_zone):
        """Sets the tunnel_zone of this PrefilterRule.

        Object Representing tunnel zones for prefilter rule.  # noqa: E501

        :param tunnel_zone: The tunnel_zone of this PrefilterRule.  # noqa: E501
        :type: ISourceZoneContainer
        """

        self._tunnel_zone = tunnel_zone

    @property
    def type(self):
        """Gets the type of this PrefilterRule.  # noqa: E501

        Type must be PrefilterRule.  # noqa: E501

        :return: The type of this PrefilterRule.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this PrefilterRule.

        Type must be PrefilterRule.  # noqa: E501

        :param type: The type of this PrefilterRule.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def enable_syslog(self):
        """Gets the enable_syslog of this PrefilterRule.  # noqa: E501

        Boolean indicating whether the alerts associated with the prefilter rule are sent to default syslog configuration in Prefilter Logging.  # noqa: E501

        :return: The enable_syslog of this PrefilterRule.  # noqa: E501
        :rtype: bool
        """
        return self._enable_syslog

    @enable_syslog.setter
    def enable_syslog(self, enable_syslog):
        """Sets the enable_syslog of this PrefilterRule.

        Boolean indicating whether the alerts associated with the prefilter rule are sent to default syslog configuration in Prefilter Logging.  # noqa: E501

        :param enable_syslog: The enable_syslog of this PrefilterRule.  # noqa: E501
        :type: bool
        """

        self._enable_syslog = enable_syslog

    @property
    def enabled(self):
        """Gets the enabled of this PrefilterRule.  # noqa: E501

        Boolean indicating whether the prefilter rule is in effect (true) or not (false). Default is true.  # noqa: E501

        :return: The enabled of this PrefilterRule.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this PrefilterRule.

        Boolean indicating whether the prefilter rule is in effect (true) or not (false). Default is true.  # noqa: E501

        :param enabled: The enabled of this PrefilterRule.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def syslog_config(self):
        """Gets the syslog_config of this PrefilterRule.  # noqa: E501

        Object representing the syslog alert associated with the prefilter rule.  # noqa: E501

        :return: The syslog_config of this PrefilterRule.  # noqa: E501
        :rtype: ISyslogConfig
        """
        return self._syslog_config

    @syslog_config.setter
    def syslog_config(self, syslog_config):
        """Sets the syslog_config of this PrefilterRule.

        Object representing the syslog alert associated with the prefilter rule.  # noqa: E501

        :param syslog_config: The syslog_config of this PrefilterRule.  # noqa: E501
        :type: ISyslogConfig
        """

        self._syslog_config = syslog_config

    @property
    def rule_type(self):
        """Gets the rule_type of this PrefilterRule.  # noqa: E501

        Object indicating if the Rule is Prefilter Rule or Tunnel Rule.  # noqa: E501

        :return: The rule_type of this PrefilterRule.  # noqa: E501
        :rtype: str
        """
        return self._rule_type

    @rule_type.setter
    def rule_type(self, rule_type):
        """Sets the rule_type of this PrefilterRule.

        Object indicating if the Rule is Prefilter Rule or Tunnel Rule.  # noqa: E501

        :param rule_type: The rule_type of this PrefilterRule.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and rule_type is None:
            raise ValueError("Invalid value for `rule_type`, must not be `None`")  # noqa: E501
        allowed_values = ["PREFILTER", "TUNNEL"]  # noqa: E501
        if (self._configuration.client_side_validation and
                rule_type not in allowed_values):
            raise ValueError(
                "Invalid value for `rule_type` ({0}), must be one of {1}"  # noqa: E501
                .format(rule_type, allowed_values)
            )

        self._rule_type = rule_type

    @property
    def destination_networks(self):
        """Gets the destination_networks of this PrefilterRule.  # noqa: E501

        Object representing destination networks selected for the prefilter rule.  # noqa: E501

        :return: The destination_networks of this PrefilterRule.  # noqa: E501
        :rtype: INetworkObjectsContainer
        """
        return self._destination_networks

    @destination_networks.setter
    def destination_networks(self, destination_networks):
        """Sets the destination_networks of this PrefilterRule.

        Object representing destination networks selected for the prefilter rule.  # noqa: E501

        :param destination_networks: The destination_networks of this PrefilterRule.  # noqa: E501
        :type: INetworkObjectsContainer
        """

        self._destination_networks = destination_networks

    @property
    def action(self):
        """Gets the action of this PrefilterRule.  # noqa: E501

        Specifies the action to take when the conditions defined by the rule are met. One of: BLOCK | TRUST | NETWORK_DISCOVERY | PERMIT.  # noqa: E501

        :return: The action of this PrefilterRule.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this PrefilterRule.

        Specifies the action to take when the conditions defined by the rule are met. One of: BLOCK | TRUST | NETWORK_DISCOVERY | PERMIT.  # noqa: E501

        :param action: The action of this PrefilterRule.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and action is None:
            raise ValueError("Invalid value for `action`, must not be `None`")  # noqa: E501
        allowed_values = ["ANALYZE", "BLOCK", "FASTPATH"]  # noqa: E501
        if (self._configuration.client_side_validation and
                action not in allowed_values):
            raise ValueError(
                "Invalid value for `action` ({0}), must be one of {1}"  # noqa: E501
                .format(action, allowed_values)
            )

        self._action = action

    @property
    def links(self):
        """Gets the links of this PrefilterRule.  # noqa: E501

        Object containing links to this resource.  # noqa: E501

        :return: The links of this PrefilterRule.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this PrefilterRule.

        Object containing links to this resource.  # noqa: E501

        :param links: The links of this PrefilterRule.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this PrefilterRule.  # noqa: E501

        Unique identifier (UUID) for the prefilter rule.  # noqa: E501

        :return: The id of this PrefilterRule.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PrefilterRule.

        Unique identifier (UUID) for the prefilter rule.  # noqa: E501

        :param id: The id of this PrefilterRule.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def log_end(self):
        """Gets the log_end of this PrefilterRule.  # noqa: E501

        Boolean indicating whether the device will log events at the end of the connection. Default is false.  # noqa: E501

        :return: The log_end of this PrefilterRule.  # noqa: E501
        :rtype: bool
        """
        return self._log_end

    @log_end.setter
    def log_end(self, log_end):
        """Sets the log_end of this PrefilterRule.

        Boolean indicating whether the device will log events at the end of the connection. Default is false.  # noqa: E501

        :param log_end: The log_end of this PrefilterRule.  # noqa: E501
        :type: bool
        """

        self._log_end = log_end

    @property
    def log_begin(self):
        """Gets the log_begin of this PrefilterRule.  # noqa: E501

        Boolean indicating whether the device will log events at the beginning of the connection. Default is false.  # noqa: E501

        :return: The log_begin of this PrefilterRule.  # noqa: E501
        :rtype: bool
        """
        return self._log_begin

    @log_begin.setter
    def log_begin(self, log_begin):
        """Sets the log_begin of this PrefilterRule.

        Boolean indicating whether the device will log events at the beginning of the connection. Default is false.  # noqa: E501

        :param log_begin: The log_begin of this PrefilterRule.  # noqa: E501
        :type: bool
        """

        self._log_begin = log_begin

    @property
    def send_events_to_fmc(self):
        """Gets the send_events_to_fmc of this PrefilterRule.  # noqa: E501

        Boolean indicating whether the device will send events to the Firepower Management Center event viewer. Default is false.  # noqa: E501

        :return: The send_events_to_fmc of this PrefilterRule.  # noqa: E501
        :rtype: bool
        """
        return self._send_events_to_fmc

    @send_events_to_fmc.setter
    def send_events_to_fmc(self, send_events_to_fmc):
        """Sets the send_events_to_fmc of this PrefilterRule.

        Boolean indicating whether the device will send events to the Firepower Management Center event viewer. Default is false.  # noqa: E501

        :param send_events_to_fmc: The send_events_to_fmc of this PrefilterRule.  # noqa: E501
        :type: bool
        """

        self._send_events_to_fmc = send_events_to_fmc

    @property
    def destination_ports(self):
        """Gets the destination_ports of this PrefilterRule.  # noqa: E501

        Object representing destination ports selected for the rule.  # noqa: E501

        :return: The destination_ports of this PrefilterRule.  # noqa: E501
        :rtype: IPortObjectsContainer
        """
        return self._destination_ports

    @destination_ports.setter
    def destination_ports(self, destination_ports):
        """Sets the destination_ports of this PrefilterRule.

        Object representing destination ports selected for the rule.  # noqa: E501

        :param destination_ports: The destination_ports of this PrefilterRule.  # noqa: E501
        :type: IPortObjectsContainer
        """

        self._destination_ports = destination_ports

    @property
    def source_ports(self):
        """Gets the source_ports of this PrefilterRule.  # noqa: E501

        Object representing source ports selected for the rule.  # noqa: E501

        :return: The source_ports of this PrefilterRule.  # noqa: E501
        :rtype: IPortObjectsContainer
        """
        return self._source_ports

    @source_ports.setter
    def source_ports(self, source_ports):
        """Sets the source_ports of this PrefilterRule.

        Object representing source ports selected for the rule.  # noqa: E501

        :param source_ports: The source_ports of this PrefilterRule.  # noqa: E501
        :type: IPortObjectsContainer
        """

        self._source_ports = source_ports

    @property
    def version(self):
        """Gets the version of this PrefilterRule.  # noqa: E501

        Version number of the response object.  # noqa: E501

        :return: The version of this PrefilterRule.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this PrefilterRule.

        Version number of the response object.  # noqa: E501

        :param version: The version of this PrefilterRule.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def new_comments(self):
        """Gets the new_comments of this PrefilterRule.  # noqa: E501

        Object representing the new comments provided in prefilter rule.  # noqa: E501

        :return: The new_comments of this PrefilterRule.  # noqa: E501
        :rtype: list[str]
        """
        return self._new_comments

    @new_comments.setter
    def new_comments(self, new_comments):
        """Sets the new_comments of this PrefilterRule.

        Object representing the new comments provided in prefilter rule.  # noqa: E501

        :param new_comments: The new_comments of this PrefilterRule.  # noqa: E501
        :type: list[str]
        """

        self._new_comments = new_comments

    @property
    def comment_history_list(self):
        """Gets the comment_history_list of this PrefilterRule.  # noqa: E501

        List of comments in the prefilter rule's comment history.  # noqa: E501

        :return: The comment_history_list of this PrefilterRule.  # noqa: E501
        :rtype: list[ICommentHistory]
        """
        return self._comment_history_list

    @comment_history_list.setter
    def comment_history_list(self, comment_history_list):
        """Sets the comment_history_list of this PrefilterRule.

        List of comments in the prefilter rule's comment history.  # noqa: E501

        :param comment_history_list: The comment_history_list of this PrefilterRule.  # noqa: E501
        :type: list[ICommentHistory]
        """

        self._comment_history_list = comment_history_list

    @property
    def name(self):
        """Gets the name of this PrefilterRule.  # noqa: E501

        User-specified name of the prefilter rule.  # noqa: E501

        :return: The name of this PrefilterRule.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PrefilterRule.

        User-specified name of the prefilter rule.  # noqa: E501

        :param name: The name of this PrefilterRule.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def vlan_tags(self):
        """Gets the vlan_tags of this PrefilterRule.  # noqa: E501

        Object representing the VLAN tag set associated with the prefilter rule.  # noqa: E501

        :return: The vlan_tags of this PrefilterRule.  # noqa: E501
        :rtype: IVLanTagsContainer
        """
        return self._vlan_tags

    @vlan_tags.setter
    def vlan_tags(self, vlan_tags):
        """Sets the vlan_tags of this PrefilterRule.

        Object representing the VLAN tag set associated with the prefilter rule.  # noqa: E501

        :param vlan_tags: The vlan_tags of this PrefilterRule.  # noqa: E501
        :type: IVLanTagsContainer
        """

        self._vlan_tags = vlan_tags

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PrefilterRule, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PrefilterRule):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PrefilterRule):
            return True

        return self.to_dict() != other.to_dict()
