# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class RealmUserGroup(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'realm_uuid': 'str',
        'links': 'ILinks',
        'realm': 'IRealm',
        'id': 'str',
        'type': 'str'
    }

    attribute_map = {
        'name': 'name',
        'realm_uuid': 'realmUuid',
        'links': 'links',
        'realm': 'realm',
        'id': 'id',
        'type': 'type'
    }

    def __init__(self, name=None, realm_uuid=None, links=None, realm=None, id=None, type=None, _configuration=None):  # noqa: E501
        """RealmUserGroup - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._name = None
        self._realm_uuid = None
        self._links = None
        self._realm = None
        self._id = None
        self._type = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if realm_uuid is not None:
            self.realm_uuid = realm_uuid
        if links is not None:
            self.links = links
        if realm is not None:
            self.realm = realm
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type

    @property
    def name(self):
        """Gets the name of this RealmUserGroup.  # noqa: E501


        :return: The name of this RealmUserGroup.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this RealmUserGroup.


        :param name: The name of this RealmUserGroup.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def realm_uuid(self):
        """Gets the realm_uuid of this RealmUserGroup.  # noqa: E501


        :return: The realm_uuid of this RealmUserGroup.  # noqa: E501
        :rtype: str
        """
        return self._realm_uuid

    @realm_uuid.setter
    def realm_uuid(self, realm_uuid):
        """Sets the realm_uuid of this RealmUserGroup.


        :param realm_uuid: The realm_uuid of this RealmUserGroup.  # noqa: E501
        :type: str
        """

        self._realm_uuid = realm_uuid

    @property
    def links(self):
        """Gets the links of this RealmUserGroup.  # noqa: E501


        :return: The links of this RealmUserGroup.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this RealmUserGroup.


        :param links: The links of this RealmUserGroup.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def realm(self):
        """Gets the realm of this RealmUserGroup.  # noqa: E501


        :return: The realm of this RealmUserGroup.  # noqa: E501
        :rtype: IRealm
        """
        return self._realm

    @realm.setter
    def realm(self, realm):
        """Sets the realm of this RealmUserGroup.


        :param realm: The realm of this RealmUserGroup.  # noqa: E501
        :type: IRealm
        """

        self._realm = realm

    @property
    def id(self):
        """Gets the id of this RealmUserGroup.  # noqa: E501


        :return: The id of this RealmUserGroup.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this RealmUserGroup.


        :param id: The id of this RealmUserGroup.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this RealmUserGroup.  # noqa: E501


        :return: The type of this RealmUserGroup.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this RealmUserGroup.


        :param type: The type of this RealmUserGroup.  # noqa: E501
        :type: str
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RealmUserGroup, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RealmUserGroup):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RealmUserGroup):
            return True

        return self.to_dict() != other.to_dict()
