# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class RESTElement(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'metadata': 'IMetadata',
        'capabilities': 'list[str]',
        'ca_cert': 'str',
        'misc_data': 'LLMiscData',
        'description': 'str',
        'cert': 'str',
        'type': 'str',
        'version': 'str',
        'registration_date': 'int',
        'name': 'str',
        'host': 'str',
        'model': 'str',
        'links': 'ILinks',
        'id': 'str',
        'llelement': 'LLElement',
        'key': 'str',
        'status': 'str'
    }

    attribute_map = {
        'metadata': 'metadata',
        'capabilities': 'capabilities',
        'ca_cert': 'caCert',
        'misc_data': 'miscData',
        'description': 'description',
        'cert': 'cert',
        'type': 'type',
        'version': 'version',
        'registration_date': 'registrationDate',
        'name': 'name',
        'host': 'host',
        'model': 'model',
        'links': 'links',
        'id': 'id',
        'llelement': 'llelement',
        'key': 'key',
        'status': 'status'
    }

    def __init__(self, metadata=None, capabilities=None, ca_cert=None, misc_data=None, description=None, cert=None, type=None, version=None, registration_date=None, name=None, host=None, model=None, links=None, id=None, llelement=None, key=None, status=None, _configuration=None):  # noqa: E501
        """RESTElement - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._metadata = None
        self._capabilities = None
        self._ca_cert = None
        self._misc_data = None
        self._description = None
        self._cert = None
        self._type = None
        self._version = None
        self._registration_date = None
        self._name = None
        self._host = None
        self._model = None
        self._links = None
        self._id = None
        self._llelement = None
        self._key = None
        self._status = None
        self.discriminator = None

        if metadata is not None:
            self.metadata = metadata
        if capabilities is not None:
            self.capabilities = capabilities
        if ca_cert is not None:
            self.ca_cert = ca_cert
        if misc_data is not None:
            self.misc_data = misc_data
        if description is not None:
            self.description = description
        if cert is not None:
            self.cert = cert
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version
        if registration_date is not None:
            self.registration_date = registration_date
        if name is not None:
            self.name = name
        if host is not None:
            self.host = host
        if model is not None:
            self.model = model
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if llelement is not None:
            self.llelement = llelement
        if key is not None:
            self.key = key
        if status is not None:
            self.status = status

    @property
    def metadata(self):
        """Gets the metadata of this RESTElement.  # noqa: E501


        :return: The metadata of this RESTElement.  # noqa: E501
        :rtype: IMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this RESTElement.


        :param metadata: The metadata of this RESTElement.  # noqa: E501
        :type: IMetadata
        """

        self._metadata = metadata

    @property
    def capabilities(self):
        """Gets the capabilities of this RESTElement.  # noqa: E501


        :return: The capabilities of this RESTElement.  # noqa: E501
        :rtype: list[str]
        """
        return self._capabilities

    @capabilities.setter
    def capabilities(self, capabilities):
        """Sets the capabilities of this RESTElement.


        :param capabilities: The capabilities of this RESTElement.  # noqa: E501
        :type: list[str]
        """

        self._capabilities = capabilities

    @property
    def ca_cert(self):
        """Gets the ca_cert of this RESTElement.  # noqa: E501


        :return: The ca_cert of this RESTElement.  # noqa: E501
        :rtype: str
        """
        return self._ca_cert

    @ca_cert.setter
    def ca_cert(self, ca_cert):
        """Sets the ca_cert of this RESTElement.


        :param ca_cert: The ca_cert of this RESTElement.  # noqa: E501
        :type: str
        """

        self._ca_cert = ca_cert

    @property
    def misc_data(self):
        """Gets the misc_data of this RESTElement.  # noqa: E501


        :return: The misc_data of this RESTElement.  # noqa: E501
        :rtype: LLMiscData
        """
        return self._misc_data

    @misc_data.setter
    def misc_data(self, misc_data):
        """Sets the misc_data of this RESTElement.


        :param misc_data: The misc_data of this RESTElement.  # noqa: E501
        :type: LLMiscData
        """

        self._misc_data = misc_data

    @property
    def description(self):
        """Gets the description of this RESTElement.  # noqa: E501


        :return: The description of this RESTElement.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this RESTElement.


        :param description: The description of this RESTElement.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def cert(self):
        """Gets the cert of this RESTElement.  # noqa: E501


        :return: The cert of this RESTElement.  # noqa: E501
        :rtype: str
        """
        return self._cert

    @cert.setter
    def cert(self, cert):
        """Sets the cert of this RESTElement.


        :param cert: The cert of this RESTElement.  # noqa: E501
        :type: str
        """

        self._cert = cert

    @property
    def type(self):
        """Gets the type of this RESTElement.  # noqa: E501


        :return: The type of this RESTElement.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this RESTElement.


        :param type: The type of this RESTElement.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this RESTElement.  # noqa: E501


        :return: The version of this RESTElement.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this RESTElement.


        :param version: The version of this RESTElement.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def registration_date(self):
        """Gets the registration_date of this RESTElement.  # noqa: E501


        :return: The registration_date of this RESTElement.  # noqa: E501
        :rtype: int
        """
        return self._registration_date

    @registration_date.setter
    def registration_date(self, registration_date):
        """Sets the registration_date of this RESTElement.


        :param registration_date: The registration_date of this RESTElement.  # noqa: E501
        :type: int
        """

        self._registration_date = registration_date

    @property
    def name(self):
        """Gets the name of this RESTElement.  # noqa: E501


        :return: The name of this RESTElement.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this RESTElement.


        :param name: The name of this RESTElement.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def host(self):
        """Gets the host of this RESTElement.  # noqa: E501


        :return: The host of this RESTElement.  # noqa: E501
        :rtype: str
        """
        return self._host

    @host.setter
    def host(self, host):
        """Sets the host of this RESTElement.


        :param host: The host of this RESTElement.  # noqa: E501
        :type: str
        """

        self._host = host

    @property
    def model(self):
        """Gets the model of this RESTElement.  # noqa: E501


        :return: The model of this RESTElement.  # noqa: E501
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this RESTElement.


        :param model: The model of this RESTElement.  # noqa: E501
        :type: str
        """

        self._model = model

    @property
    def links(self):
        """Gets the links of this RESTElement.  # noqa: E501


        :return: The links of this RESTElement.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this RESTElement.


        :param links: The links of this RESTElement.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this RESTElement.  # noqa: E501


        :return: The id of this RESTElement.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this RESTElement.


        :param id: The id of this RESTElement.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def llelement(self):
        """Gets the llelement of this RESTElement.  # noqa: E501


        :return: The llelement of this RESTElement.  # noqa: E501
        :rtype: LLElement
        """
        return self._llelement

    @llelement.setter
    def llelement(self, llelement):
        """Sets the llelement of this RESTElement.


        :param llelement: The llelement of this RESTElement.  # noqa: E501
        :type: LLElement
        """

        self._llelement = llelement

    @property
    def key(self):
        """Gets the key of this RESTElement.  # noqa: E501


        :return: The key of this RESTElement.  # noqa: E501
        :rtype: str
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this RESTElement.


        :param key: The key of this RESTElement.  # noqa: E501
        :type: str
        """

        self._key = key

    @property
    def status(self):
        """Gets the status of this RESTElement.  # noqa: E501


        :return: The status of this RESTElement.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this RESTElement.


        :param status: The status of this RESTElement.  # noqa: E501
        :type: str
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RESTElement, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RESTElement):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RESTElement):
            return True

        return self.to_dict() != other.to_dict()
