# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class RollbackRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'metadata': 'RollbackRequestMetadata',
        'rollback_device_list': 'list[IRollbackDeviceListEntry]',
        'type': 'str'
    }

    attribute_map = {
        'metadata': 'metadata',
        'rollback_device_list': 'rollbackDeviceList',
        'type': 'type'
    }

    def __init__(self, metadata=None, rollback_device_list=None, type=None, _configuration=None):  # noqa: E501
        """RollbackRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._metadata = None
        self._rollback_device_list = None
        self._type = None
        self.discriminator = None

        if metadata is not None:
            self.metadata = metadata
        if rollback_device_list is not None:
            self.rollback_device_list = rollback_device_list
        if type is not None:
            self.type = type

    @property
    def metadata(self):
        """Gets the metadata of this RollbackRequest.  # noqa: E501

        Object representing metadata attributes for the rollback request entry.  # noqa: E501

        :return: The metadata of this RollbackRequest.  # noqa: E501
        :rtype: RollbackRequestMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this RollbackRequest.

        Object representing metadata attributes for the rollback request entry.  # noqa: E501

        :param metadata: The metadata of this RollbackRequest.  # noqa: E501
        :type: RollbackRequestMetadata
        """

        self._metadata = metadata

    @property
    def rollback_device_list(self):
        """Gets the rollback_device_list of this RollbackRequest.  # noqa: E501

        A list containing job UUID and device UUIDs combination for the rollback.  # noqa: E501

        :return: The rollback_device_list of this RollbackRequest.  # noqa: E501
        :rtype: list[IRollbackDeviceListEntry]
        """
        return self._rollback_device_list

    @rollback_device_list.setter
    def rollback_device_list(self, rollback_device_list):
        """Sets the rollback_device_list of this RollbackRequest.

        A list containing job UUID and device UUIDs combination for the rollback.  # noqa: E501

        :param rollback_device_list: The rollback_device_list of this RollbackRequest.  # noqa: E501
        :type: list[IRollbackDeviceListEntry]
        """

        self._rollback_device_list = rollback_device_list

    @property
    def type(self):
        """Gets the type of this RollbackRequest.  # noqa: E501

        Type must be RollbackRequest.  # noqa: E501

        :return: The type of this RollbackRequest.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this RollbackRequest.

        Type must be RollbackRequest.  # noqa: E501

        :param type: The type of this RollbackRequest.  # noqa: E501
        :type: str
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RollbackRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RollbackRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RollbackRequest):
            return True

        return self.to_dict() != other.to_dict()
