# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class TaskStatus(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'task_type': 'str',
        'sub_tasks': 'list[ISubTask]',
        'name': 'str',
        'description': 'str',
        'links': 'ILinks',
        'id': 'str',
        'type': 'str',
        'message': 'str',
        'status': 'str'
    }

    attribute_map = {
        'task_type': 'taskType',
        'sub_tasks': 'subTasks',
        'name': 'name',
        'description': 'description',
        'links': 'links',
        'id': 'id',
        'type': 'type',
        'message': 'message',
        'status': 'status'
    }

    def __init__(self, task_type=None, sub_tasks=None, name=None, description=None, links=None, id=None, type=None, message=None, status=None, _configuration=None):  # noqa: E501
        """TaskStatus - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._task_type = None
        self._sub_tasks = None
        self._name = None
        self._description = None
        self._links = None
        self._id = None
        self._type = None
        self._message = None
        self._status = None
        self.discriminator = None

        if task_type is not None:
            self.task_type = task_type
        if sub_tasks is not None:
            self.sub_tasks = sub_tasks
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if message is not None:
            self.message = message
        if status is not None:
            self.status = status

    @property
    def task_type(self):
        """Gets the task_type of this TaskStatus.  # noqa: E501


        :return: The task_type of this TaskStatus.  # noqa: E501
        :rtype: str
        """
        return self._task_type

    @task_type.setter
    def task_type(self, task_type):
        """Sets the task_type of this TaskStatus.


        :param task_type: The task_type of this TaskStatus.  # noqa: E501
        :type: str
        """
        allowed_values = ["DEVICE_REGISTRATION", "DEVICE_DEPLOYMENT", "DEVICE_ROLLBACK", "NGFWHA_OPERATIONS", "COPY_CONFIG_REQUEST", "HIT_COUNT_REFRESH", "NGFW_CLUSTER_OPERATIONS"]  # noqa: E501
        if (self._configuration.client_side_validation and
                task_type not in allowed_values):
            raise ValueError(
                "Invalid value for `task_type` ({0}), must be one of {1}"  # noqa: E501
                .format(task_type, allowed_values)
            )

        self._task_type = task_type

    @property
    def sub_tasks(self):
        """Gets the sub_tasks of this TaskStatus.  # noqa: E501


        :return: The sub_tasks of this TaskStatus.  # noqa: E501
        :rtype: list[ISubTask]
        """
        return self._sub_tasks

    @sub_tasks.setter
    def sub_tasks(self, sub_tasks):
        """Sets the sub_tasks of this TaskStatus.


        :param sub_tasks: The sub_tasks of this TaskStatus.  # noqa: E501
        :type: list[ISubTask]
        """

        self._sub_tasks = sub_tasks

    @property
    def name(self):
        """Gets the name of this TaskStatus.  # noqa: E501


        :return: The name of this TaskStatus.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this TaskStatus.


        :param name: The name of this TaskStatus.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this TaskStatus.  # noqa: E501


        :return: The description of this TaskStatus.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this TaskStatus.


        :param description: The description of this TaskStatus.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def links(self):
        """Gets the links of this TaskStatus.  # noqa: E501


        :return: The links of this TaskStatus.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this TaskStatus.


        :param links: The links of this TaskStatus.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this TaskStatus.  # noqa: E501


        :return: The id of this TaskStatus.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this TaskStatus.


        :param id: The id of this TaskStatus.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this TaskStatus.  # noqa: E501


        :return: The type of this TaskStatus.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this TaskStatus.


        :param type: The type of this TaskStatus.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def message(self):
        """Gets the message of this TaskStatus.  # noqa: E501


        :return: The message of this TaskStatus.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this TaskStatus.


        :param message: The message of this TaskStatus.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def status(self):
        """Gets the status of this TaskStatus.  # noqa: E501


        :return: The status of this TaskStatus.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this TaskStatus.


        :param status: The status of this TaskStatus.  # noqa: E501
        :type: str
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TaskStatus, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TaskStatus):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TaskStatus):
            return True

        return self.to_dict() != other.to_dict()
