# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class VpnAdvancedSettings(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'advanced_ike_setting': 'IS2SIkeAdvanceSettingModel',
        'metadata': 'IMetadata',
        'name': 'str',
        'advanced_tunnel_setting': 'IS2STunnelAdvanceSettingModel',
        'description': 'str',
        'links': 'ILinks',
        'advanced_ipsec_setting': 'IS2SIpSecAdvanceSettingModel',
        'id': 'str',
        'type': 'str',
        'version': 'str'
    }

    attribute_map = {
        'advanced_ike_setting': 'advancedIkeSetting',
        'metadata': 'metadata',
        'name': 'name',
        'advanced_tunnel_setting': 'advancedTunnelSetting',
        'description': 'description',
        'links': 'links',
        'advanced_ipsec_setting': 'advancedIpsecSetting',
        'id': 'id',
        'type': 'type',
        'version': 'version'
    }

    def __init__(self, advanced_ike_setting=None, metadata=None, name=None, advanced_tunnel_setting=None, description=None, links=None, advanced_ipsec_setting=None, id=None, type=None, version=None, _configuration=None):  # noqa: E501
        """VpnAdvancedSettings - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._advanced_ike_setting = None
        self._metadata = None
        self._name = None
        self._advanced_tunnel_setting = None
        self._description = None
        self._links = None
        self._advanced_ipsec_setting = None
        self._id = None
        self._type = None
        self._version = None
        self.discriminator = None

        if advanced_ike_setting is not None:
            self.advanced_ike_setting = advanced_ike_setting
        if metadata is not None:
            self.metadata = metadata
        if name is not None:
            self.name = name
        if advanced_tunnel_setting is not None:
            self.advanced_tunnel_setting = advanced_tunnel_setting
        if description is not None:
            self.description = description
        if links is not None:
            self.links = links
        if advanced_ipsec_setting is not None:
            self.advanced_ipsec_setting = advanced_ipsec_setting
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if version is not None:
            self.version = version

    @property
    def advanced_ike_setting(self):
        """Gets the advanced_ike_setting of this VpnAdvancedSettings.  # noqa: E501


        :return: The advanced_ike_setting of this VpnAdvancedSettings.  # noqa: E501
        :rtype: IS2SIkeAdvanceSettingModel
        """
        return self._advanced_ike_setting

    @advanced_ike_setting.setter
    def advanced_ike_setting(self, advanced_ike_setting):
        """Sets the advanced_ike_setting of this VpnAdvancedSettings.


        :param advanced_ike_setting: The advanced_ike_setting of this VpnAdvancedSettings.  # noqa: E501
        :type: IS2SIkeAdvanceSettingModel
        """

        self._advanced_ike_setting = advanced_ike_setting

    @property
    def metadata(self):
        """Gets the metadata of this VpnAdvancedSettings.  # noqa: E501


        :return: The metadata of this VpnAdvancedSettings.  # noqa: E501
        :rtype: IMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this VpnAdvancedSettings.


        :param metadata: The metadata of this VpnAdvancedSettings.  # noqa: E501
        :type: IMetadata
        """

        self._metadata = metadata

    @property
    def name(self):
        """Gets the name of this VpnAdvancedSettings.  # noqa: E501


        :return: The name of this VpnAdvancedSettings.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this VpnAdvancedSettings.


        :param name: The name of this VpnAdvancedSettings.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def advanced_tunnel_setting(self):
        """Gets the advanced_tunnel_setting of this VpnAdvancedSettings.  # noqa: E501


        :return: The advanced_tunnel_setting of this VpnAdvancedSettings.  # noqa: E501
        :rtype: IS2STunnelAdvanceSettingModel
        """
        return self._advanced_tunnel_setting

    @advanced_tunnel_setting.setter
    def advanced_tunnel_setting(self, advanced_tunnel_setting):
        """Sets the advanced_tunnel_setting of this VpnAdvancedSettings.


        :param advanced_tunnel_setting: The advanced_tunnel_setting of this VpnAdvancedSettings.  # noqa: E501
        :type: IS2STunnelAdvanceSettingModel
        """

        self._advanced_tunnel_setting = advanced_tunnel_setting

    @property
    def description(self):
        """Gets the description of this VpnAdvancedSettings.  # noqa: E501


        :return: The description of this VpnAdvancedSettings.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this VpnAdvancedSettings.


        :param description: The description of this VpnAdvancedSettings.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def links(self):
        """Gets the links of this VpnAdvancedSettings.  # noqa: E501


        :return: The links of this VpnAdvancedSettings.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this VpnAdvancedSettings.


        :param links: The links of this VpnAdvancedSettings.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def advanced_ipsec_setting(self):
        """Gets the advanced_ipsec_setting of this VpnAdvancedSettings.  # noqa: E501


        :return: The advanced_ipsec_setting of this VpnAdvancedSettings.  # noqa: E501
        :rtype: IS2SIpSecAdvanceSettingModel
        """
        return self._advanced_ipsec_setting

    @advanced_ipsec_setting.setter
    def advanced_ipsec_setting(self, advanced_ipsec_setting):
        """Sets the advanced_ipsec_setting of this VpnAdvancedSettings.


        :param advanced_ipsec_setting: The advanced_ipsec_setting of this VpnAdvancedSettings.  # noqa: E501
        :type: IS2SIpSecAdvanceSettingModel
        """

        self._advanced_ipsec_setting = advanced_ipsec_setting

    @property
    def id(self):
        """Gets the id of this VpnAdvancedSettings.  # noqa: E501


        :return: The id of this VpnAdvancedSettings.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VpnAdvancedSettings.


        :param id: The id of this VpnAdvancedSettings.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this VpnAdvancedSettings.  # noqa: E501


        :return: The type of this VpnAdvancedSettings.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this VpnAdvancedSettings.


        :param type: The type of this VpnAdvancedSettings.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def version(self):
        """Gets the version of this VpnAdvancedSettings.  # noqa: E501


        :return: The version of this VpnAdvancedSettings.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this VpnAdvancedSettings.


        :param version: The version of this VpnAdvancedSettings.  # noqa: E501
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VpnAdvancedSettings, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VpnAdvancedSettings):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, VpnAdvancedSettings):
            return True

        return self.to_dict() != other.to_dict()
