# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class VpnIkeSettings(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'metadata': 'Metadata',
        'name': 'str',
        'description': 'str',
        'links': 'ILinks',
        'id': 'str',
        'ike_v1_settings': 'IVpnIkev1Settings',
        'type': 'str',
        'ike_v2_settings': 'IVpnIkev2Settings',
        'version': 'str'
    }

    attribute_map = {
        'metadata': 'metadata',
        'name': 'name',
        'description': 'description',
        'links': 'links',
        'id': 'id',
        'ike_v1_settings': 'ikeV1Settings',
        'type': 'type',
        'ike_v2_settings': 'ikeV2Settings',
        'version': 'version'
    }

    def __init__(self, metadata=None, name=None, description=None, links=None, id=None, ike_v1_settings=None, type=None, ike_v2_settings=None, version=None, _configuration=None):  # noqa: E501
        """VpnIkeSettings - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._metadata = None
        self._name = None
        self._description = None
        self._links = None
        self._id = None
        self._ike_v1_settings = None
        self._type = None
        self._ike_v2_settings = None
        self._version = None
        self.discriminator = None

        if metadata is not None:
            self.metadata = metadata
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if links is not None:
            self.links = links
        if id is not None:
            self.id = id
        if ike_v1_settings is not None:
            self.ike_v1_settings = ike_v1_settings
        if type is not None:
            self.type = type
        if ike_v2_settings is not None:
            self.ike_v2_settings = ike_v2_settings
        if version is not None:
            self.version = version

    @property
    def metadata(self):
        """Gets the metadata of this VpnIkeSettings.  # noqa: E501


        :return: The metadata of this VpnIkeSettings.  # noqa: E501
        :rtype: Metadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this VpnIkeSettings.


        :param metadata: The metadata of this VpnIkeSettings.  # noqa: E501
        :type: Metadata
        """

        self._metadata = metadata

    @property
    def name(self):
        """Gets the name of this VpnIkeSettings.  # noqa: E501


        :return: The name of this VpnIkeSettings.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this VpnIkeSettings.


        :param name: The name of this VpnIkeSettings.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this VpnIkeSettings.  # noqa: E501


        :return: The description of this VpnIkeSettings.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this VpnIkeSettings.


        :param description: The description of this VpnIkeSettings.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def links(self):
        """Gets the links of this VpnIkeSettings.  # noqa: E501


        :return: The links of this VpnIkeSettings.  # noqa: E501
        :rtype: ILinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this VpnIkeSettings.


        :param links: The links of this VpnIkeSettings.  # noqa: E501
        :type: ILinks
        """

        self._links = links

    @property
    def id(self):
        """Gets the id of this VpnIkeSettings.  # noqa: E501


        :return: The id of this VpnIkeSettings.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VpnIkeSettings.


        :param id: The id of this VpnIkeSettings.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def ike_v1_settings(self):
        """Gets the ike_v1_settings of this VpnIkeSettings.  # noqa: E501


        :return: The ike_v1_settings of this VpnIkeSettings.  # noqa: E501
        :rtype: IVpnIkev1Settings
        """
        return self._ike_v1_settings

    @ike_v1_settings.setter
    def ike_v1_settings(self, ike_v1_settings):
        """Sets the ike_v1_settings of this VpnIkeSettings.


        :param ike_v1_settings: The ike_v1_settings of this VpnIkeSettings.  # noqa: E501
        :type: IVpnIkev1Settings
        """

        self._ike_v1_settings = ike_v1_settings

    @property
    def type(self):
        """Gets the type of this VpnIkeSettings.  # noqa: E501


        :return: The type of this VpnIkeSettings.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this VpnIkeSettings.


        :param type: The type of this VpnIkeSettings.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def ike_v2_settings(self):
        """Gets the ike_v2_settings of this VpnIkeSettings.  # noqa: E501


        :return: The ike_v2_settings of this VpnIkeSettings.  # noqa: E501
        :rtype: IVpnIkev2Settings
        """
        return self._ike_v2_settings

    @ike_v2_settings.setter
    def ike_v2_settings(self, ike_v2_settings):
        """Sets the ike_v2_settings of this VpnIkeSettings.


        :param ike_v2_settings: The ike_v2_settings of this VpnIkeSettings.  # noqa: E501
        :type: IVpnIkev2Settings
        """

        self._ike_v2_settings = ike_v2_settings

    @property
    def version(self):
        """Gets the version of this VpnIkeSettings.  # noqa: E501


        :return: The version of this VpnIkeSettings.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this VpnIkeSettings.


        :param version: The version of this VpnIkeSettings.  # noqa: E501
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VpnIkeSettings, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VpnIkeSettings):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, VpnIkeSettings):
            return True

        return self.to_dict() != other.to_dict()
