# coding: utf-8

"""
    Cisco Firepower Management Center Open API Specification

    **Specifies the REST URLs and methods supported in the Cisco Firepower Management Center API. Refer to the version specific [REST API Quick Start Guide](https://www.cisco.com/c/en/us/support/security/defense-center/products-programming-reference-guides-list.html) for additional information.**  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: tac@cisco.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from fmc_client.configuration import Configuration


class VRFInterfaceEntry(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'logical_name': 'str',
        'id': 'int',
        'type': 'str',
        'value': 'str',
        'uuid': 'str',
        'literal': 'bool'
    }

    attribute_map = {
        'name': 'name',
        'logical_name': 'logicalName',
        'id': 'id',
        'type': 'type',
        'value': 'value',
        'uuid': 'uuid',
        'literal': 'literal'
    }

    def __init__(self, name=None, logical_name=None, id=None, type=None, value=None, uuid=None, literal=None, _configuration=None):  # noqa: E501
        """VRFInterfaceEntry - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._name = None
        self._logical_name = None
        self._id = None
        self._type = None
        self._value = None
        self._uuid = None
        self._literal = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if logical_name is not None:
            self.logical_name = logical_name
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if value is not None:
            self.value = value
        if uuid is not None:
            self.uuid = uuid
        if literal is not None:
            self.literal = literal

    @property
    def name(self):
        """Gets the name of this VRFInterfaceEntry.  # noqa: E501


        :return: The name of this VRFInterfaceEntry.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this VRFInterfaceEntry.


        :param name: The name of this VRFInterfaceEntry.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def logical_name(self):
        """Gets the logical_name of this VRFInterfaceEntry.  # noqa: E501


        :return: The logical_name of this VRFInterfaceEntry.  # noqa: E501
        :rtype: str
        """
        return self._logical_name

    @logical_name.setter
    def logical_name(self, logical_name):
        """Sets the logical_name of this VRFInterfaceEntry.


        :param logical_name: The logical_name of this VRFInterfaceEntry.  # noqa: E501
        :type: str
        """

        self._logical_name = logical_name

    @property
    def id(self):
        """Gets the id of this VRFInterfaceEntry.  # noqa: E501


        :return: The id of this VRFInterfaceEntry.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VRFInterfaceEntry.


        :param id: The id of this VRFInterfaceEntry.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this VRFInterfaceEntry.  # noqa: E501


        :return: The type of this VRFInterfaceEntry.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this VRFInterfaceEntry.


        :param type: The type of this VRFInterfaceEntry.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def value(self):
        """Gets the value of this VRFInterfaceEntry.  # noqa: E501


        :return: The value of this VRFInterfaceEntry.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this VRFInterfaceEntry.


        :param value: The value of this VRFInterfaceEntry.  # noqa: E501
        :type: str
        """

        self._value = value

    @property
    def uuid(self):
        """Gets the uuid of this VRFInterfaceEntry.  # noqa: E501


        :return: The uuid of this VRFInterfaceEntry.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this VRFInterfaceEntry.


        :param uuid: The uuid of this VRFInterfaceEntry.  # noqa: E501
        :type: str
        """

        self._uuid = uuid

    @property
    def literal(self):
        """Gets the literal of this VRFInterfaceEntry.  # noqa: E501


        :return: The literal of this VRFInterfaceEntry.  # noqa: E501
        :rtype: bool
        """
        return self._literal

    @literal.setter
    def literal(self, literal):
        """Sets the literal of this VRFInterfaceEntry.


        :param literal: The literal of this VRFInterfaceEntry.  # noqa: E501
        :type: bool
        """

        self._literal = literal

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VRFInterfaceEntry, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VRFInterfaceEntry):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, VRFInterfaceEntry):
            return True

        return self.to_dict() != other.to_dict()
